/*  $Id: SCBalloonAlternative.java,v 1.4 2004/01/02 11:28:41 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2003 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCBalloonAlternative extends NSView {
    protected String refcon;
    protected Object target;
    protected NSSelector selector;
    
    String title;
    NSMutableAttributedString normal_str,selected_str;
    NSColor pen_color,brush_color;
    boolean draw_underline,draw_square,draw_underline_even_if_unselected;
    
    boolean mouse_cursor_is_on_this_view = false;
    
    public SCBalloonAlternative(String title,NSFont font,NSColor normal_font_color,NSColor selected_font_color,
				NSColor pen_color,NSColor brush_color,boolean draw_underline,boolean draw_square,
				boolean draw_underline_even_if_unselected) {
	// draw_underline_even_if_unselectedtrueł΁AJ[\悹ĂȂĂA_[C\B
	// draw_underlinetrueɂȂĂꍇ̂݁B
	this.title = title;
	this.pen_color = pen_color;
	this.brush_color = brush_color;
	this.draw_underline = draw_underline;
	this.draw_square = draw_square;
	this.draw_underline_even_if_unselected = draw_underline_even_if_unselected;
	
	if (selected_font_color == null) { // ꂾnullłǂB
	    selected_font_color = NSColor.colorWithCalibratedRGB(
		1.0f - normal_font_color.redComponent(),
		1.0f - normal_font_color.greenComponent(),
		1.0f - normal_font_color.blueComponent(),
		normal_font_color.alphaComponent());
	}
	
	NSRange range_all = new NSRange(0,title.length());
	normal_str = new NSMutableAttributedString(title);
	normal_str.addAttributeInRange(NSAttributedString.FontAttributeName,font,range_all);
	
	selected_str = new NSMutableAttributedString(normal_str); // copy
	
	normal_str.addAttributeInRange(NSAttributedString.ForegroundColorAttributeName,normal_font_color,range_all);
	selected_str.addAttributeInRange(NSAttributedString.ForegroundColorAttributeName,selected_font_color,range_all);
	
	setFrame(new NSRect(NSPoint.ZeroPoint,NSGraphics.sizeOfAttributedString(normal_str)));
    }
    
    public String title() {
	return title;
    }
    
    private NSRect[] rect_list_contais_bounds = null;
    private NSRect rect_underline = null;
    public void drawRect(NSRect r) {
	if (rect_list_contais_bounds == null)
	    rect_list_contais_bounds = new NSRect[] {bounds()};
	if (rect_underline == null) {
	    NSRect bounds = bounds();
	    rect_underline = new NSRect(0,0,bounds.width(),1);
	}
	
	if (mouse_cursor_is_on_this_view && draw_square) {
	    brush_color.set();
	    NSGraphics.fillRectList(rect_list_contais_bounds);
	}
	
	NSGraphics.drawAttributedString(mouse_cursor_is_on_this_view ? selected_str : normal_str,NSPoint.ZeroPoint);
	
	if (mouse_cursor_is_on_this_view && draw_square) {
	    pen_color.set();
	    NSGraphics.frameRectWithWidth(bounds(),1.0f);
	}
	
	/*System.out.println("draw_underline = "+draw_underline);
	  System.out.println("draw_underline_even_if_unselected = "+draw_underline_even_if_unselected);
	  System.out.println("mouse_cursor_is_on_this_view = "+mouse_cursor_is_on_this_view);*/
	if (draw_underline && 
	    (draw_underline_even_if_unselected ||
	     mouse_cursor_is_on_this_view)) {
	    pen_color.set();
	    NSGraphics.frameRect(rect_underline);
	}
    }
    
    public boolean acceptsFirstMouse(NSEvent theEvent) {
	return true;
    }
    
    public void mouseDown(NSEvent event) {
	try {
	    selector.invoke(target,this);
	} catch (Exception e) {
	    System.err.println("BallonAlternative: exception occured.");
	    System.err.println("  target was "+target.getClass().getName());
	    e.printStackTrace();
	}
    }
    
    // javał͉̂gbLÖ`oȂB̃R[hӖɂȂ邱Ƃ肤B
    private boolean mouse_entered_already = false;
    public void mouseMoved(NSEvent theEvent) {
	NSPoint mouse_point;
	boolean is_mouse_in;
	mouse_point = theEvent.locationInWindow();
	mouse_point = convertPointFromView(mouse_point,null);
	is_mouse_in = isMouseInRect(mouse_point,bounds());  //View̓
	
	if (is_mouse_in && !mouse_entered_already) {
	    this.mouseEntered(theEvent);
	    mouse_entered_already = true;
	}
	else if(!is_mouse_in && mouse_entered_already) {
	    this.mouseExited(theEvent);
	    mouse_entered_already = false;
	}
	//super.mouseMoved(theEvent);
    }
    
    public void mouseEntered(NSEvent event) {
	mouse_cursor_is_on_this_view = true;
	display();
    }
    
    public void mouseExited(NSEvent event) {
	mouse_cursor_is_on_this_view = false;
	display();
    }
    
    public void setAction(NSSelector sel) {
	selector = sel;
    }
    
    public void setTarget(Object o) {
	target = o;
    }
    
    public String getRefcon() {
	return refcon;
    }
    
    public void setRefcon(String refcon) {
	this.refcon = refcon;
    }
}
