/*  $Id: SCBalloonTextView.java,v 1.16 2006/09/03 16:54:41 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2005 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class SCBalloonTextView extends NSView {
    private static final NSRange FIRSTCHAR_RANGE = new NSRange(0,1);
    private static final int SHADOW_INTERVAL = 2;
    private static final int LINE_INTERVAL = 0;
    
    NSFont font;
    float fontHeight;
    NSColor mainColor, mainShadowColor;
    
    float x, y;
    NSImage offscreen;
    
    List cmd_queue; // vf̌^ Character ܂ RunnableB

    float newline_ratio;

    SCBalloonScrollArrow arrow_up, arrow_down;
    
    public SCBalloonTextView(NSRect r) {
		super(r);
	
		cmd_queue = Collections.synchronizedList(new LinkedList());
	
		setFont(NSFont.systemFontOfSize(10.0f));
		setMainColor(NSColor.blackColor());
		setMainShadowColor(null);

		// łTCYݒ肵ĂȂlockFocus()oȂB
		offscreen = new NSImage(new NSSize(10,10)); 
		beEmpty(); // ŐTCYɂB
    }
	
    public void initialize(
		SCBalloonScrollArrow arrow_up, SCBalloonScrollArrow arrow_down) {
	
		this.arrow_up = arrow_up;
		this.arrow_down = arrow_down;
    }

    public void close() {
		arrow_up = null;
		arrow_down = null;
    }

    public void setLocation(int x, int y) {
		/*
		  ̒l͓ʂȈӖB
	  
		  Integer.MIN_VALUE: lɐݒ
		  Integer.MAX_VALUE: ̍XȂ
		*/
		if (x == Integer.MIN_VALUE) {
			this.x = superview().frame().width() / 2;
		}
		else if (x == Integer.MAX_VALUE) {
	    
		}
		else {
			this.x = x;
		}

		if (y == Integer.MIN_VALUE) {
			// FIXME: {cɂŗǂ̂ǂc
			this.y = superview().frame().height() / 2;
			this.y -= fontHeight / 2;
		}
		else if (y == Integer.MAX_VALUE) {

		}
		else {
			this.y = frame().height() - fontHeight - y;
		}
    }
    
    public void updateArrowsVisibilities() {
		// initialize()Ă΂Oɂ̃\bhĂ΂\B
		if (arrow_up != null) arrow_up.updateVisibility();
		if (arrow_down != null) arrow_down.updateVisibility();
    }
    
    protected void addSubviewAtCurrentLoc(NSView view) {
		NSRect view_frame = view.frame();
		float viewwidth = view_frame.width();
		float viewheight = view_frame.height();
	
		view.setFrame(new NSRect(x, y, viewwidth, viewheight));
		addSubview(view);
		x += viewwidth;
    }
    
    public void changedSize() {
		// r[̂̂̃TCYύXKĂłB
		NSRect frame = superview().frame();
		setFrame(frame);
		setOffscreenSize(frame.size());
    }
    
    public void setFont(NSFont f) {
		font = f;
		fontHeight = Math.round(font.boundingRectForFont().height());
    }

    public final float getFontHeight() {
		return fontHeight;
    }
    
    public NSFont getFont() {
		return font;
    }
    
    public void setMainColor(NSColor c) {
		mainColor = c;
    }
    
    public NSColor getMainColor() {
		return mainColor;
    }
    
    public void setMainShadowColor(NSColor c) {
		// nullȂe𗎂Ƃ܂B
		mainShadowColor = c;
    }

    public void waitUntilFlushed() {
		while (cmd_queue.size() > 0) {
			try {
				Thread.sleep(50);
			} catch (Exception e) {}
		}
    }
    
    public void flushBuffer() {
		if (cmd_queue.size() > 0) {
			offscreen.lockFocus();
			while (cmd_queue.size() > 0) {
				Object obj = cmd_queue.remove(0);
				if (obj instanceof Character) {
					drawChar(((Character)obj).charValue());
				}
				else if (obj instanceof Runnable) {
					((Runnable)obj).run();
				}
			}
			offscreen.unlockFocus();
		}
    }
    public void drawRect(NSRect r) {
		flushBuffer();
		offscreen.compositeToPointFromRect(
			r.origin(), r, NSImage.CompositeSourceOver);
    }
    public void drawImage(NSImage image, NSPoint point){
		// FIXME: 摜subviewɂǂƎvBłʓ|Ȃ̂Ō񂵁B
        image.compositeToPoint(point,NSImage.CompositeCopy);
        NSRect r = new NSRect(0,0,image.size().width(),image.size().height());
        offscreen.compositeToPointFromRect(r.origin(),r,NSImage.CompositeSourceOver);
        flushBuffer();
    }
    private NSMutableAttributedString astr, shadowstr;
    private void drawChar(char c) {
		if (astr == null) {
			astr = new NSMutableAttributedString(Character.toString(c));
		}
		else {
			astr.replaceCharactersInRange(
				FIRSTCHAR_RANGE, Character.toString(c));
		}
		astr.addAttributeInRange(
			NSAttributedString.FontAttributeName, font, FIRSTCHAR_RANGE);
		astr.addAttributeInRange(
			NSAttributedString.ForegroundColorAttributeName, mainColor, FIRSTCHAR_RANGE);

        if (mainShadowColor != null) {
			if (shadowstr == null) {
				shadowstr = new NSMutableAttributedString(astr); // copy
			}
			else {
				shadowstr.replaceCharactersInRange(
					FIRSTCHAR_RANGE, astr);
			}
            shadowstr.addAttributeInRange(
				NSAttributedString.ForegroundColorAttributeName, mainShadowColor, FIRSTCHAR_RANGE);
        }
	
		final float widthOfCurrentChar =
			NSGraphics.sizeOfAttributedString(astr).width();
		// słȂĂA̕`悵ƂŔ͈͂𒴂悤ȂsB
		if (c == '\n' || x + widthOfCurrentChar > frame().width()) {
			x = 0;
			if (c == '\n') {
				y -= (float)Math.round(fontHeight * newline_ratio) + LINE_INTERVAL + SHADOW_INTERVAL;
			}
			else {
				y -= fontHeight + LINE_INTERVAL + SHADOW_INTERVAL;
			}
	    
			final float screen_height = offscreen.size().height();
			if (y < 0) { // y˂jt[găXN[B
				float deltaY = -1 * y;
		
				offscreen.unlockFocus();
				NSRect oldframe = frame();
				NSRect newframe = new NSRect(
					0, 0, oldframe.width(), oldframe.height() + deltaY); // sg
				setFrame(newframe);
				setOffscreenSize(newframe.size());
				offscreen.lockFocus();
		
				updateArrowsVisibilities();
		
				offscreen.compositeToPoint(
					new NSPoint(0,deltaY), NSImage.CompositeCopy);
		
				NSArray subviews = subviews();
				final int n_subviews = subviews.count();
				for (int i = 0;i < n_subviews;i++) {
					NSView subview = (NSView)subviews.objectAtIndex(i);
					NSRect subview_oldframe = subview.frame();
					subview.setFrame(
						new NSRect(
							subview_oldframe.x(), subview_oldframe.y()+deltaY,
							subview_oldframe.width(), subview_oldframe.height()));
				}
		
				NSColor.clearColor().set();
				NSGraphics.fillRectList(
					new NSRect[] {new NSRect(0, 0, newframe.width(), deltaY)});

				y = SHADOW_INTERVAL;
			}
		}
		if (c != '\n') {
			if (mainShadowColor != null) { // nullȂe𗎂ƂȂB
				NSGraphics.drawAttributedString(
					shadowstr, new NSPoint(x+SHADOW_INTERVAL, y-SHADOW_INTERVAL));
			}
			NSGraphics.drawAttributedString(astr, new NSPoint(x, y));
			x += widthOfCurrentChar;
		}
    }
    private void cleanUp() {
		// r[ƃItXN[̃TCYlɖ߂B
		offscreen.unlockFocus();
		NSRect frame = superview().frame();
		setFrame(frame);
		setOffscreenSize(frame.size());
		offscreen.lockFocus();
	
		updateArrowsVisibilities();
	
		NSColor.clearColor().set();
		NSGraphics.fillRectList(new NSRect[] {frame()});
	
		resetLocation();
    }
    
    public synchronized void addChar(char c) {
		if (c < '\u0020') {
			throw new RuntimeException(
				"Adding control character is not allowed anymore. "+
				"Use methods like addReturn() instead.");
		}
		cmd_queue.add(new Character(c));
		display();
    }
    
    public void beEmpty() {
		cmd_queue.add(
			new Runnable() {
				public void run() {
					cleanUp();
				}
			});
		display();
    }

    public void addReturn(final float ratio) {
		cmd_queue.add(
			new Runnable() {
				public void run() {
					newline_ratio = ratio;
					drawChar('\n');
				}
			});
		display();
    }

    public void addView(final NSView view) {
		cmd_queue.add(
			new Runnable() {
				public void run() {
					addSubviewAtCurrentLoc(view);
				}
			});
		display();
    }
    
    private void resetLocation() {
		x = 0;
		y = frame().height() - fontHeight;
    }

	public void setOffscreenSize(NSSize new_size) {
		// d offscreen.setSize(new_size) ƁA drawRect 
		//  composite ɃNbV₤c

		NSImage new_buffer = new NSImage(new_size);
		new_buffer.lockFocus();
		offscreen.compositeToPoint(NSPoint.ZeroPoint, NSImage.CompositeCopy);
		new_buffer.unlockFocus();

		offscreen = new_buffer;
	}
}
