/*  $Id: SCDescription.java,v 1.5 2004/01/20 17:34:16 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.util.*;
import util.*;

public class SCDescription {
    Hashtable table; // gStringB
    
    public SCDescription() {
	// ̃CX^X쐬܂B
    }
    
    public SCDescription(File f) {
	// fdescript.txt̃t@CB
        // S[Xg̃[gɂo[XLɂ肷t@CłB
        // tH[}bg͓Ȃ̂łǂɂg܂B
        // t@C݂Ȃȗꂽ̂Ƃ܂B
	try {
	    load(new FileInputStream(f));
	}
	catch (FileNotFoundException e) {}
    }
    
    public SCDescription(InputStream is) {
	load(is);
    }
    
    public SCDescription(SCDescription parent,File f) {
	// parentI[o[ChSCDescription쐬܂B
	// t@C݂Ȃȗꂽ̂Ƃ܂B
	
	// Rs[
	if (parent.getHashtable() != null) {
	    table = (Hashtable)parent.getHashtable().clone();
	}
	
	try {
	    load(new FileInputStream(f));
	}
	catch (FileNotFoundException e) {}
    }
    
    public SCDescription(SCDescription parent,InputStream is) {
	// Rs[
	if (parent.getHashtable() != null) {
	    table = (Hashtable)parent.getHashtable().clone();
	}
	
	load(is);
    }

    private void prepare() {
	// ꂪCCWĴȂc
	if (table == null) {
	    table = new Hashtable();
	}
    }
    
    private void load(InputStream is) {
        BufferedReader br = null;
        try {
            br = new BufferedReader(new InputStreamReader(is,"SJIS"));
        }
	catch(Exception e){
	    return;
	}
        
        String line = null;
        while(true) {
            try{ line = br.readLine(); }catch(Exception e){}
            
            if (line == null) break;
            if (line.indexOf(',') == -1) continue;
	    
	    // 劇ʂň͂܂Ă͈͖͂B
	    if (line.equals("{")) {
		while(true) {
		    try{  line = br.readLine();  }catch(Exception e){}
		    if (line == null || line.equals("}")) break;
		}
		// ŏIIcontinueĕʂXLbvB
		continue;
	    }
            
            // R}ɑOŕB
            int comma_pos = line.indexOf(',');
            String label = line.substring(0,comma_pos).trim(); // 9 septiembre 2002
            String data = line.substring(comma_pos+1).trim(); // 9 septiembre 2002
            
            // Zbg
	    if (table == null) {
		prepare();
	    }
            table.put(label,data);
        }
	
	try{ br.close(); }catch(IOException e){}
    }
    
    public void save(File dest) throws Exception {
	if (dest.exists()) dest.delete();
	OutputStreamWriter osw = new OutputStreamWriter(new FileOutputStream(dest),"SJIS");
	
	if (table != null) {
	    for (Iterator ite = table.entrySet().iterator();
		 ite.hasNext(); ) {
		Map.Entry entry = (Map.Entry)ite.next();
		osw.write((String)entry.getKey());
		osw.write(',');
		osw.write((String)entry.getValue());
		osw.write("\r\n");
	    }
	}
	
	osw.flush();
	osw.close();
    }
    
    public boolean exists(String key) {
	return table != null && table.containsKey(key);
    }
    
    public String getStrValue(String key) {
	return table == null ?
	    null : (String)table.get(key);
    }
    
    public void setStrValue(String key,String data) {
	if (table == null) {
	    prepare();
	}
	table.put(key,data);
    }
    
    public void setIntValue(String key,int data) {
	if (table == null) {
	    prepare();
	}
	table.put(key,Integer.toString(data));
    }
    
    public int getIntValue(String key) {
        // f[^݂Ȃ萔lłȂ0Ԃ܂B
	if (table == null) {
	    return 0;
	}
	
        String strval = getStrValue(key);
        if (strval == null) return 0;
        
        int val = 0;
        try {
            val = Integer.parseInt(strval);
        }
        catch (Exception e) {}
        
        return val;
    }
    
    public void remove(String key) {
	if (table != null) {
	    table.remove(key);
	}
    }
    
    public Object inverseSearch(Object data) {
	// nbVe[utāAL[Ԃ܂B
	if (table == null) {
	    return null;
	}

	for (Iterator ite = table.entrySet().iterator();
	     ite.hasNext(); ) {
	    Map.Entry entry = (Map.Entry)ite.next();
	    if (entry.getValue().equals(data)) {
		return entry.getKey();
	    }
	}
	return null;
    }
    
    public Vector getKeysStartsWith(String str) {
	// w肳ꂽŎn܂L[SĔoĕԂ܂B
	// ԂꂽzɕKvɉăf[^QƂȂǂĉB
	// Ȃ΋̔z񂪕Ԃ܂B
	Vector result = new Vector();
	if (table != null) {
	    for (Iterator ite = table.keySet().iterator();
		 ite.hasNext(); ) {
		String key = (String)ite.next();
		if (key.startsWith(str)) {
		    result.add(key);
		}
	    }
	}
	return result;
    }
    
    public Vector getAllKeys() {
	Vector result = new Vector();
	if (table != null) {
	    for (Iterator ite = table.keySet().iterator();
		 ite.hasNext(); ) {
		result.add(ite.next());
	    }
	}
	return result;
    }
    
    protected Hashtable getHashtable() {
	// nullԂmȂɒӁB
	return table;
    }

    Object tag;
    public void setTag(Object tag) {
	/* fobOp */
	this.tag = tag;
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("content: ");
	if (table != null && table.size() > 0) {
	    buf.append('{');
	    for (Iterator ite = table.keySet().iterator(); ite.hasNext(); ) {
		Object key = ite.next();
		buf.append(key).append(" => {").
		    append(table.get(key)).append('}');
		if (ite.hasNext()) {
		    buf.append(", ");
		}
	    }
	    buf.append('}');
	}
	else {
	    buf.append("empty");
	}
	if (tag != null) {
	    buf.append("; tag: "+tag);
	}
	return buf.toString();
    }

    protected void finalize() {
	if (tag != null) {
	    Logger.log(this, Logger.DEBUG, "finalized");
	}
    }
}
