/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;


public class SCESCalculationCommands extends SCESCommands
{
    public SCESCalculationCommands(SCEseShiori e)
    {
	super(e);
    }
    
    public String RAND(Vector args)
    {
	/*
	    @F$RAND( min , max [,n,flag] )
	    ߂lFflag == 1ȂZo
	*/
	String min = (String)args.elementAt(0);
	String max = (String)args.elementAt(1);
	String result = Integer.toString((int)((Math.random() * Integer.MAX_VALUE) % (Integer.parseInt(max) - Integer.parseInt(min) + 1) + Integer.parseInt(min)));
	
	if (args.size() >= 3)
	{
	    String n = (String)args.elementAt(2);
	    if (n.length() > 0)
	    {
		eseshiori.putToUnivDataArea(Integer.parseInt(n),result);
	    }
	}
	if (args.size() >= 4)
	{
	    String flag = (String)args.elementAt(3);
	    return (flag.equals("1") ? result : null);
	}
	else
	{
	    return null;
	}
    }
    
    public String CALC(Vector args)
    {
	/*
	    @F$CALC( str1 ope str2 [,n,flag] )
	    ߂lFflag == 1Ȃ牉Ž
	    
	    Zqopeɂ+,-,*,/,%gp\łB
	*/
	String cond = (String)args.elementAt(0);
	
	StringBuffer leftbuf = new StringBuffer();
	String str_right = null;
	char ope = '?';
	int in_parenthesis = 0;
	boolean in_quote = false;
	final int len = cond.length();
	for (int pos = 0;pos < len;pos++)
	{
	    char c = cond.charAt(pos);
	    
	    if (c == '\"') {in_quote = !in_quote; leftbuf.append(c);}
	    else if (!in_quote && c == '(') {in_parenthesis++; leftbuf.append(c);}
	    else if (!in_quote && c == ')') {in_parenthesis--; leftbuf.append(c);}
	    else if (in_parenthesis == 0 && !in_quote && (c == '+' || c == '-' || c == '*' || c == '/' || c == '%'))
	    {
		ope = c;
		str_right = cond.substring(pos+1);
		break;
	    }
	    else
	    {
		leftbuf.append(c);
	    }
	}
	if (ope == '?')
	{
	    System.err.println("The EseShiori Clone : operator not found in condition "+cond);
	    return null;
	}
	
	//SCFoundation.debugstr(leftbuf.toString()+" --- "+ope+" --- "+str_right);
	
	int left = Integer.parseInt( eseshiori.getEvaluator().validateStringArgument(leftbuf.toString()) );
	int right = Integer.parseInt( eseshiori.getEvaluator().validateStringArgument(str_right) );
	
	String result = null;
	if (ope == '+')
	{
	    result = Integer.toString(left + right);
	}
	else if (ope == '-')
	{
	    result = Integer.toString(left - right);
	}
	else if (ope == '*')
	{
	    result = Integer.toString(left * right);
	}
	else if (ope == '/')
	{
	    result = Integer.toString((int)(left / right));
	}
	else if (ope == '%')
	{
	    result = Integer.toString(left % right);
	}
	
	if (args.size() >= 2)
	{
	    String n = (String)args.elementAt(1);
	    if (n.length() > 0)
	    {
		eseshiori.putToUnivDataArea(Integer.parseInt(n),result);
	    }
	}
	if (args.size() >= 3)
	{
	    String flag = (String)args.elementAt(2);
	    return (flag.equals("1") ? result : null);
	}
	else
	{
	    return null;
	}
    }
}
