/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.util.*;

public class SCEseShiori
{
    SCESDictionary dictionary;
    SCESEvaluator evaluator;
    SCESIni ini;
    Hashtable universalDataArea; // key : (Integer)index , content : (String)content
    Hashtable replaceDataArea; // 900Ԉȍ~B key : (Integer)index , content : (String)content
    
    String currentSentenceEntryName = "sr1**";
    Vector modeStack; // $MODE()X^bNBoBcontent : (String)mode
    
    String latestInputString; // ŌɎ󂯎R~jP[g̓Cxg̕B
    
    String ghostToSendMessage = null; // ꂪnullłȂɁA̖ÕS[XgɌĂт͕ԓ܂B
    String lastGhostWhoTalkedToThis = null; // ̃S[Xgb|ꂽɂ̃S[Xg̖O܂B
    Hashtable referenceOut; // o͂Reference[id]wb_Bkey : (Integer)index , content : (String)reference
    
    //----------- ȉ̏NOTIFYőĂ܂B------------//
    String ownerGhostName;
    Vector otherGhostNames; // g͌܂łȂStringB
    //------------------------------------------------------------//
    
    int talkInterval; // g[NԊu
    int talkCount = 0; // g[NJE^
    
    public SCEseShiori(File ghost_root)
    {
	ini = new SCESIni(new File(ghost_root,"eseai.ini"));
	otherGhostNames = new Vector();
	dictionary = new SCESDictionary(this);
	evaluator = new SCESEvaluator(this);
	universalDataArea = new Hashtable();
	replaceDataArea = new Hashtable();
	modeStack = new Vector();
	referenceOut = new Hashtable();
	
	talkInterval = ini.getRandomTalkInterval();
	
	File[] items = ghost_root.listFiles();
	final int n_items = items.length;
	for (int i = 0;i < n_items;i++)
	{
	    String fname = items[i].getName();
	    if (fname.startsWith("eseai") && fname.endsWith(".txt"))
	    {
		dictionary.loadDict(items[i]);
	    }
	}
    }
    
    public static boolean checkIfUsable(File ghost_dir)
    {
        // eseai*.txtłtrueB
		File[] items = ghost_dir.listFiles();
		if (items == null) return false;
		final int n_items = items.length;
		for (int i = 0;i < n_items;i++)
		{
			String fname = items[i].getName();
			if (fname.startsWith("eseai") && fname.endsWith(".txt"))
			{
				return true;
			}
		}
		return false;
    }
    
    public void terminate()
    {
    
    }
    
    public static String getModuleName()
    {
        return "\u4f3c\u975e\u0053\u0048\u0049\u004f\u0052\u0049"; // SHIORI
    }
    
    public SCESDictionary getDictionary()
    {
	return dictionary;
    }
    
    public SCESEvaluator getEvaluator()
    {
	return evaluator;
    }
    
    public void putToUnivDataArea(int index,String data)
    {
	universalDataArea.put(new Integer(index),data);
    }
    
    public String getFromUnivDataArea(int index)
    {
	// f[^݂ȂnullԂ܂B
	return (String)universalDataArea.get(new Integer(index));
    }
    
    public void putToReplaceDataArea(int index,String data)
    {
	replaceDataArea.put(new Integer(index),data);
    }
    
    public String getFromReplaceDataArea(int index)
    {
	// f[^݂ȂnullԂ܂B
	return (String)replaceDataArea.get(new Integer(index));
    }
    
    public String getCurrentRandomSentenceMode()
    {
	return currentSentenceEntryName;
    }
    
    public void setRandomSentenceMode(String mode)
    {
	modeStack.add(currentSentenceEntryName);
	currentSentenceEntryName = mode;
    }
    
    public void restoreRandomSentenceMode()
    {
	if (modeStack.size() == 0) // A_[t[
	{
	    currentSentenceEntryName = "%sr1**";
	}
	else
	{
	    currentSentenceEntryName = (String)modeStack.elementAt(modeStack.size()-1);
	    modeStack.removeElementAt(modeStack.size()-1);
	}
    }
    
    public String getLatestInputString()
    {
	return latestInputString;
    }
    
    public String getLastGhostNameWhoTalkedToThis()
    {
	return lastGhostWhoTalkedToThis;
    }
    
    public Vector getOtherGhostNames()
    {
	return otherGhostNames;
    }
    
    public void setGhostToSendMessage(String ghostname)
    {
	ghostToSendMessage = ghostname;
    }
    
    public void setReferenceOutput(int index,String ref)
    {
	referenceOut.put(new Integer(index),ref);
    }
    
    public SCESIni getIni()
    {
	return ini;
    }
    
    public void setTalkInterval(int n)
    {
	// ꎞIɎg[N̊Ԋuݒ肵܂B
	// ̐ݒ͎̎g[N܂ŗLŁA
	// ̎ɍĂiniԊu擾܂B
	talkInterval = n;
    }
    
    protected static String[] TABLE_WEEK = {"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};
    public String request(String req)
    {
	StringBuffer flat_request_string = new StringBuffer();
	BufferedReader br = new BufferedReader(new StringReader(req));
	
	// ΃S[XgR~jP[Vp̊ef[^ZbgB
	ghostToSendMessage = null;
	lastGhostWhoTalkedToThis = null;
	referenceOut.clear();
	
	// ܂̓wb_ǂ
	String header = null;
	try{ header = br.readLine(); }catch (Exception e){}
	flat_request_string.append(header+"[13][10]");
	
	// NOTIFY OtherGhostName͑ĂGgdĂBN\I
	if (header.startsWith("NOTIFY OtherGhostName"))
	{
	    otherGhostNames.clear();
	    
	    String line = null;
	    while (true)
	    {
		try{ line = br.readLine(); }catch (Exception e){}
		if (line == null) break;
		if (!line.startsWith("Ghost: ")) continue;
		
		otherGhostNames.add( line.substring(line.indexOf(':')+2) ); // R̎̃Xy[X͖
	    }
	    
	    try{ br.close(); }catch(IOException e){}
	    return "SHIORI/2.3 204 No Content\r\n\r\n"; 
	}
	
	// NGXgŜǂ
	Hashtable hash = new Hashtable();
	String line = null;
	while (true)
	{
	    try{ line = br.readLine(); }catch (Exception e){}
	    if (line == null) break;
	    flat_request_string.append(line+"[13][10]");
	    if (line.indexOf(':') == -1) continue;
	    
	    String label = line.substring(0,line.indexOf(':'));
	    String data = line.substring(line.indexOf(':')+2); // R̎̃Xy[X͖
	    
	    hash.put(label,data);
	}
	
	try{ br.close(); }catch(IOException e){}
	
	if (header.startsWith("GET Sentence"))
	{
	    if (hash.get("Event") != null) // Cxgt
	    {
		String eventType = (String)hash.get("Event");
		
		Calendar cal = Calendar.getInstance();
		cal.setFirstDayOfWeek(Calendar.SUNDAY);
		flat_request_string.append("\u897f\u66a6="+cal.get(Calendar.YEAR)+","); // 
		flat_request_string.append("\u6708="+((cal.get(Calendar.MONTH)+1) < 10 ? "0"+(cal.get(Calendar.MONTH)+1) : ""+(cal.get(Calendar.MONTH)+1))+","); // 
		flat_request_string.append("\u65e5="+(cal.get(Calendar.DAY_OF_MONTH) < 10 ? "0"+cal.get(Calendar.DAY_OF_MONTH) : ""+cal.get(Calendar.DAY_OF_MONTH))+","); // 
		flat_request_string.append("\u6642="+(cal.get(Calendar.HOUR_OF_DAY) < 10 ? "0"+cal.get(Calendar.HOUR_OF_DAY) : ""+cal.get(Calendar.HOUR_OF_DAY))+","); // 
		flat_request_string.append("\u5206="+(cal.get(Calendar.MINUTE) < 10 ? "0"+cal.get(Calendar.MINUTE) : ""+cal.get(Calendar.MINUTE))+","); // 
		flat_request_string.append("\u79d2="+(cal.get(Calendar.SECOND) < 10 ? "0"+cal.get(Calendar.SECOND) : ""+cal.get(Calendar.SECOND))+","); // b
		flat_request_string.append("\u66dc\u65e5="+TABLE_WEEK[cal.get(Calendar.DAY_OF_WEEK)-1]); // j
		flat_request_string.append("---TIMEEND");
		latestInputString = flat_request_string.toString();
		
		if (eventType.equals("OnSecondChange"))
		{
		    // OnSecondChangeꍇAJE^g[NsB
		    if (talkInterval > 0)
		    {
			talkCount++;
			if (talkCount >= talkInterval)
			{
			    // Cxg𔭍s
			    String internal_event = dictionary.getItemMatches("EseRandomTalk","EVNT");
			    if (internal_event != null) evaluator.evaluate(internal_event);
			    
			    talkCount = 0;
			    talkInterval = ini.getRandomTalkInterval(); // C^[oXV
			    return "SHIORI/2.0 200 OK\r\nSentence: \\a\r\n\r\n";
			}
		    }
		}
		
		// g[NsȂΕʂɃCxg̃}b`Os
		String result = dictionary.getItemMatches(latestInputString,"EVNT");
		if (result != null)
		{
		    for (int i = 0;i < 10;i++)
		    {
			String evaluated = SCESDictionary.unescape(evaluator.evaluate(result));
			if (evaluated.length() > 0)
			{
			    return generateResponce200(evaluated,hash);
			}
		    }
		}
		
		if (eventType.equals("OnChoiceSelect"))
		{
		    // ȊICxg}b`OŏȂ̂ŊȈՑIsB
		    String ref0 = (String)hash.get("Reference0");
		    if (ref0.charAt(0) == '#')
		    {
			String entryname = ref0.substring(1);
			if (entryname.length() > 5) entryname = entryname.substring(0,5);
			
			String s = dictionary.getAnyItem(entryname);
			for (int i = 0;i < 10;i++)
			{
			    String evaluated = SCESDictionary.unescape(evaluator.evaluate(s));
			    if (evaluated.length() > 0)
			    {
				return generateResponce200(evaluated,hash);
			    }
			}
		    }
		}
		
		return "SHIORI/2.0 204 No Content\r\n\r\n"; // CxǧʂԂȂB
	    }
	    else if (hash.get("Sentence") != null) // ZeXt
	    {
		// AgelastGhostWhoTalkedToThisSenderɃZbgBłȂnull̂܂܁B
		if (hash.get("Age") != null)
		{
		    lastGhostWhoTalkedToThis = (String)hash.get("Sender");
		}
		
		latestInputString = (String)hash.get("Sentence");
		String result = dictionary.getItemMatches(latestInputString,"RESP");
		if (result != null)
		{
		    for (int i = 0;i < 10;i++)
		    {
			String evaluated = SCESDictionary.unescape(evaluator.evaluate(result));
			if (evaluated.length() > 0)
			{
			    return generateResponce200(evaluated,hash);
			}
		    }
		}
		return "SHIORI/2.0 204 No Content\r\n\r\n";
	    }
	    else // Dɒ
	    {
		String s = dictionary.getAnyItem(currentSentenceEntryName);
		for (int i = 0;i < 10;i++)
		{
		    String evaluated = SCESDictionary.unescape(evaluator.evaluate(s));
		    if (evaluated.length() > 0)
		    {
			return generateResponce200(evaluated,hash);
		    }
		}
		return "SHIORI/2.0 204 No Content\r\n\r\n";
	    }
	}
	else if (header.startsWith("NOTIFY OwnerGhostName"))
	{
	    ownerGhostName = (String)hash.get("Ghost");
	    
	    return "SHIORI/2.3 204 No Content\r\n\r\n";
	}
	else
	{
	    return "SHIORI/2.0 400 Bad Request\r\n\r\n";
	}
    }
    
    private String generateResponce200(String sentence,Hashtable requestTable)
    {
	// requestTable̓S[XgԃR~jP[g邽߁B
	talkCount = 0; // 点鎞ɂ̓g[NJE^̓ZbgB
	
	if (requestTable.get("Age") != null) // Age
	{
	    if (ghostToSendMessage == null) // $REFLECT()sȂ̂ŉbI
	    {
		return "SHIORI/2.0 200 OK\r\nSentence: "+sentence+"\r\n\r\n";
	    }
	    else
	    {
		// 
		try
		{
		    int oldAge = Integer.parseInt( (String)requestTable.get("Age") );
		    
		    StringBuffer resp = new StringBuffer("SHIORI/2.3 200 OK\r\n");
		    resp.append("Sender: "+ownerGhostName+"\r\n");
		    resp.append("To: "+(String)requestTable.get("Sender")+"\r\n");
		    resp.append("Age: "+Integer.toString(oldAge+1)+"\r\n");
		    resp.append("Sentence: "+sentence+"\r\n");
		    for (int i = 0;i <= 7;i++)
		    {
			String ref = (String)referenceOut.get(new Integer(i));
			if (ref != null) resp.append("Reference"+i+": "+ref+"\r\n");
		    }
		    resp.append("\r\n"); // X|XB
		    return resp.toString();
		}
		catch (Exception e)
		{
		    return "SHIORI/2.3 400 Bad Request\r\n\r\n";
		}
	    }
	}
	else // Age
	{
	    if (ghostToSendMessage != null) // VɃS[XgԃR~jP[VJn
	    {
		StringBuffer resp = new StringBuffer("SHIORI/2.3 200 OK\r\n");
		resp.append("Sender: "+ownerGhostName+"\r\n");
		resp.append("To: "+ghostToSendMessage+"\r\n");
		resp.append("Age: 0\r\n");
		resp.append("Sentence: "+sentence+"\r\n");
		for (int i = 0;i <= 7;i++)
		{
		    String ref = (String)referenceOut.get(new Integer(i));
		    if (ref != null) resp.append("Reference"+i+": "+ref+"\r\n");
		}
		resp.append("\r\n"); // X|X
		return resp.toString();
	    }
	    else
	    {
		return "SHIORI/2.0 200 OK\r\nSentence: "+sentence+"\r\n\r\n";
	    }
	}
    }
}
