/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.net.*;

public class SCFileDownloader
{
    public static void download(String urlstr,File outfile,int timeout) throws Exception
    {
	download(urlstr,outfile,timeout,null);
    }
    
    public static void download(String urlstr,File outfile,int timeout,SCStatusWindowController prog) throws Exception
    {
	// prog : vOXo[^CṽXe[^XEChEB
	// _E[hIĂ܂B
	URL url = new URL(urlstr);
	SCHTTPSession session = new SCHTTPSession(url);
	session.setSoTimeout(timeout);
	session.connect();
	
	// Ԃꂽwb_Location΃_CNgB
	String location = session.getHeader("Location");
	if (location != null)
	{
	    session.disconnect();
	    
	    boolean done = false;
	    String nextLocation = location;
	    for (int i = 0;i < 10;i++) // \񂽂炢񂵂ɂꂽ₳B
	    {
		URL redirect_url = new URL(nextLocation);
		SCHTTPSession redirect_session = new SCHTTPSession(redirect_url);
		redirect_session.setSoTimeout(timeout);
		redirect_session.connect();
		
		nextLocation = redirect_session.getHeader("Location");
		if (nextLocation == null) // Ō
		{
		    done = true;
		    session = redirect_session;
		    break;
		}
		
		redirect_session.disconnect();
	    }
	    if (!done)
	    {
		// ₳
		throw new SCTaraimawasiException();
	    }
	}
	
	// ^[R[h𒲂ׂāA200łȂΐڑ؂ďIB
	int respCode = session.getStatusCode();
	if (respCode != 200)
	{
	    session.disconnect();
	    throw new SCCannotDownloadException(respCode);
	}
	
	// TCY
	String size_str = session.getHeader("Content-Length");
	int size = (size_str == null ? -1 : Integer.parseInt(size_str));
	
	if (prog != null && size == -1)
	{
	    prog.pbartype_setVal(-1.0);
	    prog.pbartype_setText2("Content-Length not given.");
	}
	
	// ]
	InputStream is = session.getInputStream();
	FileOutputStream fos = new FileOutputStream(outfile);
	byte[] buf = new byte[1024];
	int size_downloaded = 0;
	int pos_percentage = 0;
	int pos_kilobytes = 0;
	while (true)
	{
	    int count = is.read(buf);
	    if (count == -1) break; // end
	    
	    fos.write(buf,0,count);
	    size_downloaded += count;
	    
	    if (prog != null)
	    {
		double pos = (double)size_downloaded / (double)size;
		int kilobytes = size_downloaded / 1024;
		if (size != -1 && pos_percentage + 3 <= (int)(pos * 100)) // 3%ɍXV
		{
		    pos_percentage = (int)(pos * 100);
		    prog.pbartype_setVal(pos);
		    prog.pbartype_setText2("["+size_downloaded+"/"+size+"] "+pos_percentage+"%");
		}
		else if (size == -1 && pos_kilobytes + 30 <= kilobytes) // 30kbɍXV
		{
		    pos_kilobytes = kilobytes;
		    prog.pbartype_setText2(pos_kilobytes+"kb");
		}
	    }
	}
	if (prog != null && size != -1)
	{
	    prog.pbartype_setVal(1.0);
	    prog.pbartype_setText2("["+size_downloaded+"/"+size+"] 100%");
	}
	else if (prog != null && size == -1)
	{
	    prog.pbartype_setVal(1.0);
	    prog.pbartype_setText2((size_downloaded / 1024)+"kb");
	}
	
	// ؒf
	session.disconnect();
	fos.flush();
	fos.close();
    }
}
