/*  $Id: SCInstalledBalloonsList.java,v 1.8 2006/01/20 13:33:44 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;

public class SCInstalledBalloonsList implements NSTableView.DataSource {
    Vector list; // gSCInstalledBalloonsList.ListElementB
    int selected_item = 0; // WI{^őIĂ鍀ځB0built-inB
    // Ȃ݂ɋ󗓂̃pXbuilt-in\܂B
    
    SCGhostManager ghostManager;
    
    private static final NSSelector selector_changeBalloonTo;
    static {
	selector_changeBalloonTo = new NSSelector("changeBalloonTo",new Class[] {Object.class});
    }
    
    public SCInstalledBalloonsList(SCGhostManager ghostManager) {
        this.ghostManager = ghostManager;
        SCGhostManagerWindowController windowController =
	    ghostManager.getWindowController();
        NSTableView tableView = windowController.getTableBalloons();
        
        tableView.setDataSource(this);
        
        NSButtonCell bc = new NSButtonCell();
        bc.setButtonType(NSButtonCell.RadioButton);
        bc.setTitle("");
        NSTableColumn tc = tableView.tableColumnWithIdentifier("select");
        if (tc == null) {
	    System.out.println("SCInstalledBalloonsList error : The table doesn\'t have a NSTableColumn named \"select\".");
	}
        tc.setDataCell(bc);
	
	NSImageCell ic = new NSImageCell();
	ic.setImageAlignment(NSImageCell.ImageAlignLeft);
	ic.setImageFrameStyle(NSImageCell.ImageFrameNone);
	ic.setImageScaling(NSImageCell.ScaleNone);
	NSTableColumn thumbnail_tc =
	    tableView.tableColumnWithIdentifier("thumbnail");
	if (thumbnail_tc == null) {
	    System.out.println("SCInstalledBalloonsList error : The table doesn\'t have a NSTableColumn named \"thumbnail\".");
	}
        thumbnail_tc.setDataCell(ic);

        list = new Vector();
        reloadList();
    }
    
    public void setEnabled(boolean bool) {
        SCGhostManagerWindowController windowController =
	    ghostManager.getWindowController();
        
        NSTableView tableView = windowController.getTableBalloons();
        NSTableColumn tc;
        
        tc = tableView.tableColumnWithIdentifier("select");
        tc.dataCell().setEnabled(bool);
	//tableView.display();
	tableView.setNeedsDisplay(true);
    }
    
    public void selectBalloon(String balloon_path) {
        // home/balloon/̃pXŎw肳ꂽo[AXg̃WI{^őI܂B
        // Ȃbuilt-inɂȂ܂B
        int n_items = list.size();
        int found_id = 0; // 0 = built-in
        for (int i = 0;i < n_items;i++) {
            if (balloon_path.equals( ((ListElement)list.elementAt(i)).getPath() )) {
                // 
                found_id = i+1;
                break;
            }
        }
        selected_item = found_id;
        
        SCGhostManagerWindowController windowController =
	    ghostManager.getWindowController();
        NSTableView tableView = windowController.getTableBalloons();
        tableView.reloadData();
        tableView.scrollRowToVisible(found_id);
    }
    
    public void reloadList() {
        SCGhostManagerWindowController windowController =
	    ghostManager.getWindowController();
	windowController.getTableBalloons().deselectAll(this);
        list.clear();
        
        String bundleDir = SCFoundation.sharedFoundation().getParentDirOfBundle();
        File shellDir = new File(bundleDir,"home/balloon");
        File[] items = shellDir.listFiles();
        for (int i = 0;i < items.length;i++) {
            if (items[i].isDirectory()) {
		File descript_txt = new File(items[i],"descript.txt");
		if (!descript_txt.exists()) continue; // descript.txt΃XLbvB
		
                ListElement le = new ListElement(
		    "home/balloon/"+items[i].getName());
                list.add(le);
            }
        }
	
	int maxHeight = getMaxHeightOfThumbnails();
        windowController.getTableBalloons().setRowHeight(
	    maxHeight > 18 ? maxHeight : 18);
	
        windowController.getTableBalloons().reloadData();
    }
    
    private int getMaxHeightOfThumbnails() {
	// Xg̑SẴTlC摜̂Ał̑傫ȉ摜̍Ԃ܂B
	int result = 0;
	
	final int n_elems = list.size();
	for (int i = 0;i < n_elems;i++) {
	    ListElement le = (ListElement)list.elementAt(i);
	    if (le.getThumbnail() != null) {
		int h = (int)le.getThumbnail().size().height();
		if (h > result) result = h;
	    }
	}
	
	return result;
    }
    
    public NSMenu makeBalloonMenu(SCSession self) {
	NSMenu submenu = new NSMenu();
	submenu.setAutoenablesItems(false);
	
	BalloonMenuItem builtinitem = new BalloonMenuItem(self,"[built-in]","");
	builtinitem.setAction(selector_changeBalloonTo);
	builtinitem.setTarget(this);
	builtinitem.setState(self.getBalloonServer().getPath().length() == 0 ? NSCell.OnState : NSCell.OffState);
	builtinitem.setEnabled(builtinitem.state() != NSCell.OnState);
	submenu.addItem(builtinitem);
	
	final int n_balloons = list.size();
	for (int i = 0;i < n_balloons;i++) {
	    ListElement le = (ListElement)list.elementAt(i);
	    
	    BalloonMenuItem item = new BalloonMenuItem(self,le.getName(),le.getPath());
	    item.setAction(selector_changeBalloonTo);
	    item.setTarget(this);
	    item.setState(self.getBalloonServer().getPath().equals(le.getPath()) ? NSCell.OnState : NSCell.OffState);
	    item.setEnabled(item.state() != NSCell.OnState);
	    item.setImage(le.getThumbnail());
	    
	    submenu.addItem(item);
	}
	
	return submenu;
    }
    
    public void changeBalloonTo(Object sender) {
	// j[Ă΂ActionłB
	if (!(sender instanceof BalloonMenuItem)) return;
	BalloonMenuItem gmi = (BalloonMenuItem)sender;
	
	ghostManager.getInstalledList().changeBalloonOfGhost(
	    gmi.getSelf().getGhostPath(), gmi.getBalloonPath());
    }
    
    private class BalloonMenuItem extends NSMenuItem {
	SCSession self;
	String balloon_path;
	
	public BalloonMenuItem(
	    SCSession self, String name, String balloon_path) {
	    super(name,null,"");
	    
	    this.self = self;
	    this.balloon_path = balloon_path;
	}
	
	public SCSession getSelf() {
	    return self;
	}
	
	public String getBalloonPath() {
	    return balloon_path;
	}
    }
    
    private class ListElement {
        String name;
        String path;
	NSImage thumbnail;
        
        public ListElement(String path) {
            this.path = path;
            
            String bundleDir =
		SCFoundation.sharedFoundation().getParentDirOfBundle();
            SCDescription descm = new SCDescription(
		new File(bundleDir, path+"/descript.txt"));
            name = descm.getStrValue("name");
            if (name == null) {
                name = SCStringsServer.getStrFromMainDic(
		    "ghostmanager.balloonname.undefined");
            }
	    
	    File thumbnailFile = new File(bundleDir, path+"/thumbnail.png");
	    if (thumbnailFile.exists()) {
		thumbnail = SCAlphaConverter.convertImage(new NSImage(thumbnailFile.getPath(), true));
		// pna݂邩H
		File pnaFile = new File(bundleDir, path + "/thumbnail.pna");
		if (pnaFile.exists()) {
		    // pna[hăAt@`lɃRs[
		    NSImage pna = new NSImage(pnaFile.getPath(), true);
		    SCAlphaConverter.attachAlphaToImage(pna, thumbnail);
		}
	    }
	    else {
		thumbnailFile = new File(bundleDir, path+"/thumbnail.pnr");
		if (thumbnailFile.exists()) {
		    thumbnail = SCAlphaConverter.convertImage(
			new NSImage(thumbnailFile.getPath(), true));
		}
		else {
		    thumbnail = null;
		}
	    }
	}
	    
	public String getName() {
            return name;
        }
        
        public String getPath() {
            return path;
        }
	
	public NSImage getThumbnail() {
	    return thumbnail;
	}
    }
    
    // implementaion of NSTableView.DataSource
    public int numberOfRowsInTableView(NSTableView aTableView) {
        if (list == null) {
	    return 1;
	}
        return list.size() + 1;
    }
    
    public boolean tableViewAcceptDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation) {
        // optional
        return false;
    }
    
    public void tableViewSortDescriptorsDidChange(
        NSTableView tableView,
        NSArray rows) {
        // optional
    }
    
    public Object tableViewObjectValueForLocation(
        NSTableView aTableView,
        NSTableColumn aTableColumn,
        int rowIndex)
    {
        String column_id = (String)aTableColumn.identifier();
        if (column_id.equals("select")) {
            return new Integer( selected_item == rowIndex ? 1 : 0 );
        }
	else if (column_id.equals("thumbnail")) {
	    if (rowIndex == 0) {
		return null;
	    }
	    else {
		ListElement elem = (ListElement)list.elementAt(rowIndex - 1);
		return elem.getThumbnail();
	    }
	}
        else if (column_id.equals("name")) {
	    if (rowIndex == 0) {
		return "[built-in]";
	    }
	    else {
		ListElement elem = (ListElement)list.elementAt(rowIndex - 1);
		return elem.getName();
	    }
	}
	
	return null;
    }
    
    public void tableViewSetObjectValueForLocation(
        NSTableView aTableView,
        Object anObject,
        NSTableColumn aTableColumn,
        int rowIndex) {
	
        String column_id = (String)aTableColumn.identifier();
        if (column_id.equals("select")) {
            selected_item = rowIndex;
            aTableView.reloadData();
            
            String balloon_path = null;
            if (rowIndex == 0) {
                balloon_path = "";
            }
            else {
                balloon_path = ((ListElement)list.elementAt(rowIndex-1)).getPath();
            }
            ghostManager.getInstalledList()
		.changeBalloonOfCurrentGhost(balloon_path);
        }
    }
    
    public int tableViewValidateDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation) {
        // optional
        return 0;
    }
    
    public boolean tableViewWriteRowsToPasteboard(
        NSTableView tableView,
        NSArray rows,
        NSPasteboard pboard) {
        // optional
        return false;
    }

    public boolean tableViewWriteRowsToPasteboard(
	NSTableView tableView,
	NSIndexSet indexSet,
	NSPasteboard pasteBoard) {
	// optional
	return false;
    }

    public NSArray tableViewNamesOfPromisedFilesDroppedAtDestination(
	NSTableView tableView,
	java.net.URL url,
	NSIndexSet indexSet) {
	// optional
	return null;
    }
}
