/*  $Id: SCInstalledGhostsList.java,v 1.20 2006/01/20 13:09:07 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;

public class SCInstalledGhostsList implements NSTableView.DataSource {
    public static final long DETERMINATOR_WAIT = 300; // DeterminatorXbhꌏ椂ޖɑ҂~bB
    
    private static final NSColor BOOTED_COLOR;
    private static final NSSelector selector_changeGhostTo;
    static {
	BOOTED_COLOR = NSColor.colorWithCalibratedRGB(1.0f,0.0f,0.0f,1.0f);
	selector_changeGhostTo = new NSSelector("changeGhostTo",new Class[] {Object.class});
    }
    
    Vector list; // gSCInstalledGhostsList.ListsElementB
    Vector sublist; // glistƓA͍i荞݌Ă\B
    SCGhostManager ghostManager;
    Determiner last_started_determiner; // ŌɋNDeterminerBNnullB
    
    public SCInstalledGhostsList(SCGhostManager ghostManager) {
        this.ghostManager = ghostManager;
	this.last_started_determiner = null;
        
        SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        NSTableView tableView = windowController.getTableInstalled();
        
        tableView.setDataSource(this);
        tableView.setDelegate(this);
        
        list = new Vector();
	sublist = new Vector();
        reloadList();
        
        tableViewSelectionDidChange(null);
	
	NSNotificationCenter.defaultCenter().addObserver(
	    this,
	    new NSSelector("onShellChangingBeginAndEnd",new Class[] {NSNotification.class}),
	    "shellchanger",
	    null);
	NSNotificationCenter.defaultCenter().addObserver(
	    this,
	    new NSSelector("onNetworkUpdaterBeginAndEnd",new Class[] {NSNotification.class}),
	    "networkupdater",
	    null);
	NSNotificationCenter.defaultCenter().addObserver(
	    this,
	    new NSSelector("onSessionClosingAndOpeningBeginAndEnd",new Class[] {NSNotification.class}),
	    "sessionstarter",
	    null);
	NSNotificationCenter.defaultCenter().addObserver(
	    this,
	    new NSSelector("onSessionClosingAndOpeningBeginAndEnd",new Class[] {NSNotification.class}),
	    "sessionchanger",
	    null);
	NSNotificationCenter.defaultCenter().addObserver(
	    this,
	    new NSSelector("onSessionClosingAndOpeningBeginAndEnd",new Class[] {NSNotification.class}),
	    "sessioncloser",
	    null);
	NSNotificationCenter.defaultCenter().addObserver(
	    this,
	    new NSSelector("onSessionClosingAndOpeningBeginAndEnd",new Class[] {NSNotification.class}),
	    "vanisher",
	    null);
	NSNotificationCenter.defaultCenter().addObserver(
	    this,
	    new NSSelector("onSessionEnteringAndLeavingPassiveMode",new Class[] {NSNotification.class}),
	    "passivemode",
	    null);
    }
    
    public void reloadList() {
	// Determiner쒆Ȃ~߂B
	if (last_started_determiner != null && last_started_determiner.isAlive()) {
	    last_started_determiner.terminateAndWait();
	}
	
        SCGhostManagerWindowController windowController = ghostManager.getWindowController();
	windowController.getTableInstalled().deselectAll(this);
        list.clear();
        
        String bundleDir = SCFoundation.sharedFoundation().getParentDirOfBundle();
        File ghostDir;
        File[] items;
        
        ghostDir = new File(bundleDir,"home/ghost");
        items = ghostDir.listFiles();
        for (int i = 0;i < items.length;i++) {
            if (items[i].isDirectory()) {
		File ghost_dir = new File(items[i],"ghost");
		if (!ghost_dir.exists()) continue; // ghostfBNg΃XLbvB
		
                String path_from_home = "home/ghost/"+items[i].getName();
                NSDictionary ghostDefaults = ghostManager.getGhostDefaults(path_from_home);
                
                Object boot_flag_entry = ghostDefaults.objectForKey("boot_flag");
                boolean boot_flag =
		    (boot_flag_entry != null &&
		     (boot_flag_entry instanceof Long ?
		      ((Long)boot_flag_entry).longValue() :
		      ((Integer)boot_flag_entry).intValue()) == 1 ? true : false );
                
                String balloon = (String)ghostDefaults.objectForKey("balloon");
                if (balloon == null) balloon = "";
                
                Double scale_entry = (Double)ghostDefaults.objectForKey("scale");
                double scale = (scale_entry == null ? 1.0 : scale_entry.doubleValue());
		
		String shell_dirname = (String)ghostDefaults.objectForKey("shell_dirname");
		if (shell_dirname == null) shell_dirname = "master";
                
                ListsElement le = new ListsElement(boot_flag,path_from_home,balloon,shell_dirname,scale);
                list.add(le);
            }
        }
        
	findBoxUpdated();
	
	// DeterminerNB
	if (!SCFoundation.DO_NOT_DETERMINE_GHOST_DETAIL) {
	    last_started_determiner = new Determiner(list);
	    last_started_determiner.start();
	}
    }

    protected void sortList() {
	// defaultsɋL^ꂽŃS[XgXg\[gB
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();

	final String key = (String)defaults.objectForKey("ghostmanager.ghostlist.sort.key");
	final String order = (String)defaults.objectForKey("ghostmanager.ghostlist.sort.order");

	Collections.sort(sublist, new Comparator() {
		public int compare(Object le1, Object le2) {
		    String a, b;
		    if (key == null || key.equals("name")) {
			a = ((ListsElement)le1).getName();
			b = ((ListsElement)le2).getName();
		    }
		    else {
			a = ((ListsElement)le1).getMasterShioriKernelName();
			a = a == null ? "" : a;
			b = ((ListsElement)le2).getMasterShioriKernelName();
			b = b == null ? "" : b;
		    }

		    int sign = order == null || order.equals("asc") ? 1 : -1;
		    return a.compareTo(b) * sign;
		}
	    });

	ghostManager.getWindowController().getTableInstalled().reloadData();
    }
    
    protected class Determiner extends Thread {
	// obNOEhŏeS[XgSHIORIMAKOTO𔻕ʂXbhB
	Vector list;
	volatile boolean flag_term;
	
	public Determiner(Vector list) {
	    this.list = list;
	}
	
	public void run() {
	    int pool = NSAutoreleasePool.push();
	    
	    this.setPriority(Thread.MIN_PRIORITY);
	    flag_term = false;
	    
	    String bundleDir = SCFoundation.sharedFoundation().getParentDirOfBundle();
	    for (int i = 0; !flag_term && i < list.size(); i++) {
		if (i > 0) {
		    try {
			sleep(DETERMINATOR_WAIT);
		    } catch (Exception e) {}
		}
		
		ListsElement le = (ListsElement)list.get(i);
		File master_ghost_dir = new File(bundleDir,le.getPath()+"/ghost/master");
		
		String shiori_name = SCShioriLoader.getModuleName(master_ghost_dir);
		if (shiori_name == null) {
		    shiori_name = "";
		}
		le.setMasterShioriKernelName(shiori_name);
		
		Vector makoto_names = SCMakotoLoader.getModuleNames(master_ghost_dir);
		le.setMakotoNames(makoto_names);

		if (i % 3 == 0) {
		    // e[uXV
		    sortList();
		}
	    }

	    // e[uXV
	    sortList();
	    
	    // e[uȊO̕XV
	    tableViewSelectionDidChange(null);
	    
	    NSAutoreleasePool.pop(pool);
	}
	
	public void terminateAndWait() {
	    flag_term = true;
	    while (isAlive()) {
		try {
		    sleep(150);
		}
		catch (Exception e) {}
	    }
	}
    }
    
    public void findBoxUpdated() {
	// find_box󂾂ꍇ́APlistsublistɃRs[B
	// łȂꍇAS[Xgɕvfind_box̓e܂ł̂sublistցB
	sublist.clear();
	
	String to_find = ghostManager.getWindowController().getFindBox().stringValue();
	if (to_find.length() == 0) {
	    sublist.addAll(list);
	}
	else {
	    for (Enumeration e = list.elements(); e.hasMoreElements(); ) {
		ListsElement le = (ListsElement)e.nextElement();
		
		if (le.getName().indexOf(to_find) != -1) {
		    sublist.add(le);
		}
	    }
	}
	
	sortList();
    }
    
    public class ListsElement {
	// ܂SCInstalledGhostsList̓NXłB̃NXɂ铯̕Ƃ͊֌W܂B
        boolean boot_flag;
        String name;
        String path;
        String balloon_path;
        double scale;
        String masterShioriKernelName; // 
	Vector makotoNames; // ꂪnullȂAʂłB
        String identification;
	String shell_dirname; // ŌɑI΂ꂽVF̃fBNgB
	String selfname;
	String keroname;

	boolean thumb_checked; // TlC̗L𖢔ȂfalseB
	File thumb_file; // pngpnrBnullB
	
	// IDghost/master̂̂ƈقȂVFꗗB
	boolean indep_shells_checked; // L𖢔ȂfalseB
	Map independent_shells; // {ID => VFfBNg} null
        
        public ListsElement(
	    boolean boot_flag, String path, String balloon_path,
	    String shell_dirname, double scale) {
            // path́ÃVF̓S[Xg̃[gfBNgłB
            this.boot_flag = boot_flag;
            this.path = path; // home/ghost/[ghostname]
            this.balloon_path = balloon_path;
            this.scale = scale;
	    this.shell_dirname = shell_dirname;
            
            String bundleDir = SCFoundation.sharedFoundation().getParentDirOfBundle();
	    // ʂȏł͂邪Ap̃R[h͖ʓ|ŏȂB
            SCDescription descm = new SCDescription(new File(bundleDir, path+"/ghost/master/descript.txt"));
            name = descm.getStrValue("name");
            selfname = descm.getStrValue("sakura.name");
            keroname = descm.getStrValue("kero.name");
            if (name == null) {
                if (selfname != null) {
		    if (keroname != null) {
                        name = selfname + ',' + keroname;
                    }
                    else {
                        name = selfname;
                    }
                }
                else {
                    name = SCStringsServer.getStrFromMainDic("ghostmanager.ghostname.undefined");
                }
            }
        }
        
        public boolean getBootFlag() {
            return boot_flag;
        }
        
        public void setBootFlag(boolean bool) {
            boot_flag = bool;
        }
        
        public String getName() {
            return name;
        }
        
        public String getPath() {
            return path;
        }
        
        public String getBalloonPath() {
            return balloon_path;
        }
        
        public void setBalloonPath(String p) {
            balloon_path = p;
        }
        
        public double getScale() {
            return scale;
        }
        
        public void setScale(double scale) {
            this.scale = scale;
        }
        
        public String getMasterShioriKernelName() {
            return masterShioriKernelName;
        }
	
	protected void setMasterShioriKernelName(String name) {
	    masterShioriKernelName = name;
	}
	
	public Vector getMakotoNames() {
	    return makotoNames;
	}
	
	protected void setMakotoNames(Vector names) {
	    makotoNames = names;
	}

	public String make_identification(String sakura, String kero) {
	    // ͖{staticANXȂ̂staticɏo҂ȂB
	    StringBuffer buf = new StringBuffer(30);
	    if (sakura != null) {
		    buf.append(sakura);
	    }
	    buf.append(',');
	    if (kero != null) {
		buf.append(kero);
	    }
	    return buf.toString();
	}
	
        public String getIdentification() {
	    // KvɂȂ܂ōȂB
	    if (identification == null) {
		identification = make_identification(selfname, keroname);
	    }
            return identification;
        }
	
	public String getShellDirName() {
	    return shell_dirname;
	}
	
	public void setShellDirName(String str) {
	    shell_dirname = str;
	}
	
	public File getThumbnailFile() {
	    if (!thumb_checked) {
		// TlC̗L𖢔B
		String bundleDir =
		    SCFoundation.sharedFoundation().getParentDirOfBundle();
		File f = new File(bundleDir, path + "/thumbnail.png");
		if (f.exists()) {
		    thumb_file = f;
		}
		else {
		    f = new File(bundleDir, path + "/thumbnail.pnr");
		    if (f.exists()) {
			thumb_file = f;
		    }
		}
		thumb_checked = true;
	    }
	    
	    return thumb_file;
	}
	
	public String getSelfName() {
	    return selfname;
	}
	
	public String getKeroName() {
	    return keroname;
	}

	public Map getIndependentShells() {
	    if (!indep_shells_checked) {
		// ghost/masterIDႤVFTB
		File shell_dir = new File(
		    SCFoundation.sharedFoundation().getParentDirOfBundle(),
		    path+"/shell");
		File[] shells = shell_dir.listFiles();
		for (int i = 0; i < shells.length; i++) {
		    if (!shells[i].isDirectory()) {
			continue;
		    }
		    File desc_f = new File(shells[i], "descript.txt");
		    if (!desc_f.exists()) {
			continue;
		    }
		    SCDescription desc = new SCDescription(desc_f);
		    String sakura = desc.getStrValue("sakura.name");
		    String kero = desc.getStrValue("kero.name");
		    if ((sakura != null && !sakura.equals(selfname)) ||
			(kero   != null &&   !kero.equals(keroname))) {
			// ʂ̖OĂB
			if (independent_shells == null) {
			    independent_shells =
				Collections.synchronizedMap(new TreeMap());
			}
			independent_shells.put(
			    make_identification(sakura, kero),
			    shells[i].getName());
		    }
		}
		indep_shells_checked = true;
	    }
	    return independent_shells;
	}

	public String search_id_in_independent_shells(String id) {
	    // w肳ꂽID՗VFTAt΂̃VFfBNgԂB
	    // ID͙_̎włAsakurâ݂̎włǂB
	    if (!indep_shells_checked) {
		getIndependentShells();
	    }
	    if (independent_shells == null) {
		return null;
	    }
	    
	    boolean both = (name.indexOf(',') != -1);
	    for (Iterator ite = independent_shells.keySet().iterator();
		 ite.hasNext(); ) {
		String shell_id = (String)ite.next();
		if (both) {
		    if (shell_id.equals(id)) {
			return (String)independent_shells.get(shell_id);
		    }
		}
		else {
		    if (shell_id.startsWith(id+",")) {
			return (String)independent_shells.get(shell_id);
		    }
		}
	    }
	    return null;
	}
    }
    
    public NSMenu makeGhostMenu(SCSession self) {
	NSMenu submenu = new NSMenu();
	submenu.setAutoenablesItems(false);
	
	final int n_ghosts = list.size();
	for (int i = 0;i < n_ghosts;i++) {
	    ListsElement le = (ListsElement)list.elementAt(i);
	    SCSession sessionIfRunning = SCFoundation.sharedFoundation().getSession(le.getPath());
	    
	    GhostMenuItem item = new GhostMenuItem(self,le.getName(),le.getPath(),le.getBalloonPath(),le.getSelfName(),le.getScale());
	    item.setAction(selector_changeGhostTo);
	    item.setTarget(this);
	    item.setState(self.getGhostPath().equals(le.getPath()) ? NSCell.OnState : NSCell.OffState);
	    item.setEnabled(sessionIfRunning == null || self.getGhostPath().equals(le.getPath()));
	    
	    submenu.addItem(item);
	}
	
	return submenu;
    }
    
    public Vector getInstalledGhostList() {
	return list; // eύXĂ͂ȂȂB
    }
    
    public void changeGhostTo(Object sender) {
	// j[Ă΂ActionłB
	if (!(sender instanceof GhostMenuItem)) return;
	GhostMenuItem gmi = (GhostMenuItem)sender;
	
	SCSessionChanger sc = new SCSessionChanger(gmi.getSelf(),gmi.getPath(),gmi.getBalloonPath(),gmi.getSelfName(),gmi.getScale());
	sc.start();
    }
    
    public void changeBalloonOfCurrentGhost(String balloon_dir) {
        // balloon_diŕAhome/balloon/n܂o[̃pXB
        // ݃XgőIĂS[Xg̃o[ςB
        SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        int selected_row = windowController.getTableInstalled().selectedRow();
        if (selected_row == -1) return;
        
        ListsElement elem = (ListsElement)sublist.elementAt(selected_row);
	changeBalloonOfGhost(elem.getPath(),balloon_dir);
    }
    
    public void changeShellOfCurrentGhost(String shell_dirname) {
	// ݃XgőIĂS[Xg̃VFςB
	SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        int selected_row = windowController.getTableInstalled().selectedRow();
        if (selected_row == -1) return;
	
	ListsElement elem = (ListsElement)sublist.elementAt(selected_row);
	changeShellOfGhost(elem.getPath(),shell_dirname);
    }
    
    private ListsElement findGhost(String ghost_path) {
	final int n_elems = list.size();
	for (int i = 0;i < n_elems;i++) {
	    ListsElement elem = (ListsElement)list.elementAt(i);
	    if (elem.getPath().equals(ghost_path)) return elem;
	}
	
	return null;
    }
    
    public void changeShellOfGhost(String ghost_path,String shell_dirname) {
	SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        int selected_row = windowController.getTableInstalled().selectedRow();
        if (selected_row != -1) {
	    ListsElement le = (ListsElement)sublist.elementAt(selected_row);
	    if (le != null && le.getPath().equals(ghost_path)) {
		ghostManager.getShellsList().selectShell(shell_dirname);
	    }
	}
	
	ListsElement le = findGhost(ghost_path);
	if (le != null) le.setShellDirName(shell_dirname);
        
        NSMutableDictionary ghostDefaults = ghostManager.getGhostDefaults(ghost_path);
        ghostDefaults.setObjectForKey(shell_dirname,"shell_dirname");
        ghostManager.setGhostDefaults(ghost_path,ghostDefaults);
        
        // ̃S[XgɋNĂAɃVF̐؂ւsB
        SCSession session = SCFoundation.sharedFoundation().getSession(ghost_path);
        if (session != null) {
            session.changeShell();
        }
	session = SCFoundation.sharedFoundation().
	    getTemporarySession(le.getIdentification(), false);
	if (session != null) {
	    session.changeShell();
	}
	
	tableViewSelectionDidChange(null); // vr[XVB
    }
    
    public void changeBalloonOfGhost(String ghost_path,String balloon_dir) {
        // balloon_diŕAhome/balloon/n܂o[̃pXB
	SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        int selected_row = windowController.getTableInstalled().selectedRow();
        if (selected_row != -1) {
	    ListsElement le = (ListsElement)sublist.elementAt(selected_row);
	    if (le != null && le.getPath().equals(ghost_path)) {
		ghostManager.getBalloonsList().selectBalloon(balloon_dir);
	    }
	}
        
        ListsElement elem = findGhost(ghost_path);
        if (elem != null) elem.setBalloonPath(balloon_dir);
        
        NSMutableDictionary ghostDefaults = ghostManager.getGhostDefaults(ghost_path);
        ghostDefaults.setObjectForKey(balloon_dir,"balloon");
        ghostManager.setGhostDefaults(ghost_path,ghostDefaults);
        
        // ̃S[XgɋNĂAɃo[̐؂ւsB
        SCSession session = SCFoundation.sharedFoundation().getSession(ghost_path);
        if (session != null) {
	    // TuXbhrestartBalloonSkinServerĂԂƃXe[^XEChEoB
	    new BalloonSkinChangerThread(session,balloon_dir).start();
        }
	session = SCFoundation.sharedFoundation().
	    getTemporarySession(elem.getIdentification(), false);
	if (session != null) {
	    session.restartBalloonSkinServer(balloon_dir); // Xe[^XEChEȂǗvȂB
	}
    }
    protected class BalloonSkinChangerThread extends Thread {
	SCSession session;
	String balloon_dir;
	public BalloonSkinChangerThread(SCSession session,String balloon_dir) {
	    this.session = session;
	    this.balloon_dir = balloon_dir;
	}
	public void run() {
	    int pool = NSAutoreleasePool.push();
	    session.restartBalloonSkinServer(balloon_dir);
	    NSAutoreleasePool.pop(pool);
	}
    }
    
    public void changeScale(double scale) {
        // ݃XgőIĂS[Xg̃XP[ςB
	
	if (scale == 0) {
	    // 0ɂƖ߂ȂȂ鋰ꂪ̂ŁAȂB
	    return;
	}
	
        SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        int selected_row = windowController.getTableInstalled().selectedRow();
        if (selected_row == -1) return;
        
        ListsElement elem = (ListsElement)sublist.elementAt(selected_row);
        elem.setScale(scale);
        
        // defaultsɕۑ
        NSMutableDictionary ghostDefaults = ghostManager.getGhostDefaults(elem.getPath());
        ghostDefaults.setObjectForKey(new Double(scale),"scale");
        ghostManager.setGhostDefaults(elem.getPath(),ghostDefaults);
        
        // ̃S[XgNĂAŃXP[ύXB
        SCSession session = SCFoundation.sharedFoundation().getSession(elem.getPath());
        if (session != null) {
            session.resizeShell(scale);
        }
    }
    
    public void networkupdate() {
	// ݃XgőIĂS[Xglbg[NXVB
	SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        int selected_row = windowController.getTableInstalled().selectedRow();
	if (selected_row == -1) return;
	
	ListsElement elem = (ListsElement)sublist.elementAt(selected_row);
	
	SCSession session = SCFoundation.sharedFoundation().getSession(elem.getPath());
        if (session == null) return;
	
	session.doNetworkUpdate();
    }
    
    public void bootOrQuit() {
	// XgőIĂS[Xg̋N/IgO
	SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        int selected_row = windowController.getTableInstalled().selectedRow();
	if (selected_row == -1) return;
	
	ListsElement elem = (ListsElement)sublist.elementAt(selected_row);
	
	SCSession session = SCFoundation.sharedFoundation().getSession(elem.getPath());
        if (session == null) {
	    // N
	    elem.setBootFlag(true);
	    SCSessionStarter.sharedStarter().start(elem.getPath(),elem.getBalloonPath(),elem.getScale());
	}
	else {
	    // I
	    elem.setBootFlag(false);
	    session.performClose();
	}
	ghostManager.setBootFlagInDefaults(elem.getPath(),elem.getBootFlag());
	
	windowController.getTableInstalled().reloadData();
	tableViewSelectionDidChange(null);
    }
    
    public void vanish() {
	// XgőIĂS[XgVANISHEChEJ
	SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        int selected_row = windowController.getTableInstalled().selectedRow();
	if (selected_row == -1) return;
	
	ListsElement elem = (ListsElement)sublist.elementAt(selected_row);
	
	SCSession session = SCFoundation.sharedFoundation().getSession(elem.getPath());
	if (session == null) return;
	
	session.openVanishDialog();
    }
    
    public void setBootFlag(String ghost_path,boolean bool) {
	// ̃f[^boottOω邾łB
	// ɂ͉̓s܂B
	ListsElement le = findGhost(ghost_path);
	if (le == null) return;
	
	le.setBootFlag(bool);
    }
    
    public void bootAllGhostsToBoot()
    {
        // u[gtOĂSẴS[Xgu[g܂B
        // NɈxǂłB
        // OĂԂƂǂȂ邩́DDD@B
        SCFoundation foundation = SCFoundation.sharedFoundation();
        int n_shells = list.size();
        for (int i = 0;i < n_shells;i++) {
            ListsElement elem = (ListsElement)list.elementAt(i);
            
            if (elem.getBootFlag()) {
		SCSessionStarter.sharedStarter().start(elem.getPath(),elem.getBalloonPath(),elem.getScale());
            }
        }
    }

    public void clearBootFlags() {
	for (Iterator ite = list.iterator(); ite.hasNext(); ) {
	    ListsElement elem = (ListsElement)ite.next();

	    if (elem.getBootFlag()) {
		elem.setBootFlag(false);
		ghostManager.setBootFlagInDefaults(elem.getPath(),elem.getBootFlag());
	    }
	}
    }
    
    public Vector getAllGhostPathsInAsleep() {
	// u[gtOĂȂSẴS[Xg̃pXԂ܂B
	// ΋VectorԂ܂B
	Vector result = new Vector();
	int n_shells = list.size();
        for (int i = 0;i < n_shells;i++) {
            ListsElement elem = (ListsElement)list.elementAt(i);
            
            if (!elem.getBootFlag()) {
		result.add(elem.getPath());
            }
        }
	return result;
    }
    
    public String getBalloonPathOfGhost(String ghostPath) {
	ListsElement le = findGhost(ghostPath);
	if (le == null) return "";
	
	return (le.getBalloonPath() == null ? "" : le.getBalloonPath());
    }
    
    public double getScaleOfGhost(String ghostPath) {
	ListsElement le = findGhost(ghostPath);
	if (le == null) return 1.0;
	
	return le.getScale();
    }
    
    public String getNameOfGhost(String ghostPath) {
	ListsElement le = findGhost(ghostPath);
	if (le == null) return "";
	
	return le.getName();
    }
    
    // Notification Callback
    public void onShellChangingBeginAndEnd(NSNotification notification) {
	SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        int selected_row = windowController.getTableInstalled().selectedRow();
	if (selected_row == -1) return;
	ListsElement elem = (ListsElement)sublist.elementAt(selected_row);
	
	SCSession session = (SCSession)notification.userInfo().objectForKey("session");
	if (session.getGhostPath().equals(elem.getPath())) {
	    // ܂ɂꂾ
	    boolean beginning = ((String)notification.object()).equals("begin");
	    windowController.setEnabledOfNetworkUpdateButton(!beginning);
	    windowController.setEnabledOfVanishButton(!beginning);
	    windowController.getBootAndQuitButton().setEnabled(!beginning);
	    ghostManager.getShellsList().setEnabled(!beginning);
	}
    }
    
    public void onSessionEnteringAndLeavingPassiveMode(NSNotification notification) {
	SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        int selected_row = windowController.getTableInstalled().selectedRow();
	if (selected_row == -1) return;
	ListsElement elem = (ListsElement)sublist.elementAt(selected_row);
	
	SCSession session = (SCSession)notification.userInfo().objectForKey("session");
	if (session.getGhostPath().equals(elem.getPath())) {
	    // ܂ɂꂾ
	    boolean entering = ((String)notification.object()).equals("enter");
	    windowController.setEnabledOfNetworkUpdateButton(!entering);
	    windowController.setEnabledOfVanishButton(!entering);
	    windowController.getBootAndQuitButton().setEnabled(!entering);
	    ghostManager.getShellsList().setEnabled(!entering);
	}
    }
    
    public void onNetworkUpdaterBeginAndEnd(NSNotification notification) {
	SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        int selected_row = windowController.getTableInstalled().selectedRow();
	if (selected_row == -1) return;
	ListsElement elem = (ListsElement)sublist.elementAt(selected_row);
	
	SCSession session = (SCSession)notification.userInfo().objectForKey("session");
	if (session.getGhostPath().equals(elem.getPath())) {
	    // ܂ɂꂾ
	    boolean beginning = ((String)notification.object()).equals("begin");
	    windowController.setEnabledOfNetworkUpdateButton(!beginning);
	    windowController.setEnabledOfVanishButton(!beginning);
	    windowController.getBootAndQuitButton().setEnabled(!beginning);
	    ghostManager.getShellsList().setEnabled(!beginning);
	}
    }
    
    public void onSessionClosingAndOpeningBeginAndEnd(NSNotification notification) {
	SCGhostManagerWindowController windowController = ghostManager.getWindowController();
	if (notification.name().equals("vanisher") &&
	    ((String)notification.object()).equals("vanished")) {
	    // S[XgĂ̂ŁAXg̒gƃ[hB
	    ghostManager.reloadLists();
	}
	else {
	    windowController.getTableInstalled().reloadData();
	}
	tableViewSelectionDidChange(null);
    }
    
    // implementaion of NSTableView.DataSource
    public int numberOfRowsInTableView(NSTableView aTableView) {
        if (sublist == null) return 0;
        return sublist.size();
    }
    
    public boolean tableViewAcceptDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation) {
        // optional
        return false;
    }
    
    public Object tableViewObjectValueForLocation(
        NSTableView aTableView,
        NSTableColumn aTableColumn,
        int rowIndex) {
        String column_id = (String)aTableColumn.identifier();
        ListsElement elem = (ListsElement)sublist.elementAt(rowIndex);
        
        if (column_id.equals("name")) {
	    if (SCFoundation.sharedFoundation().getSession(elem.getPath()) != null) {
		NSMutableAttributedString mas = new NSMutableAttributedString(elem.getName());
		mas.addAttributeInRange(NSAttributedString.ForegroundColorAttributeName,BOOTED_COLOR,new NSRange(0,elem.getName().length()));
		return mas;
	    }
	    else {
		return elem.getName();
	    }
        }
        else if (column_id.equals("shiori")) {
	    if (elem.getMasterShioriKernelName() == null) {
		return SCStringsServer.getStrFromMainDic("ghostmanager.undeterminated");
	    }
	    else {
		return elem.getMasterShioriKernelName();
	    }
        }
        
        return null;
    }
    
    public void tableViewSetObjectValueForLocation(
        NSTableView aTableView,
        Object anObject,
        NSTableColumn aTableColumn,
        int rowIndex) {
        
    }
    
    public int tableViewValidateDrop(
        NSTableView tableView,
        NSDraggingInfo info,
        int row,
        int operation) {
        // optional
        return 0;
    }
    
    public boolean tableViewWriteRowsToPasteboard(
        NSTableView tableView,
        NSArray rows,
        NSPasteboard pboard) {
        // optional
        return false;
    }

    public boolean tableViewWriteRowsToPasteboard(
	NSTableView tableView,
	NSIndexSet indexSet,
	NSPasteboard pasteBoard) {
	// optional
	return false;
    }
    
    public void tableViewSortDescriptorsDidChange(
        NSTableView tableView,
        NSArray rows) {
        // optional
    }

    public NSArray tableViewNamesOfPromisedFilesDroppedAtDestination(
	NSTableView tableView,
	java.net.URL url,
	NSIndexSet indexSet) {
	// optional
	return null;
    }
    
    // Delegete of NSTableView
    public boolean tableViewShouldSelectTableColumn( NSTableView aTableView, NSTableColumn aTableColumn) {
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	
	String old_key = (String)defaults.objectForKey("ghostmanager.ghostlist.sort.key");
	String new_key = (String)aTableColumn.identifier();
	if (new_key.equals(old_key)) {
	    // L[Ȃ̂ŏtɁB
	    String old_order = (String)defaults.objectForKey("ghostmanager.ghostlist.sort.order");
	    String new_order = old_order.equals("asc") ? "desc" : "asc";
	    defaults.setObjectForKey(new_order, "ghostmanager.ghostlist.sort.order");
	}
	else {
	    // L[ӁBV͏ɏB
	    defaults.setObjectForKey(new_key, "ghostmanager.ghostlist.sort.key");
	    defaults.setObjectForKey("asc", "ghostmanager.ghostlist.sort.order");
	}
	defaults.synchronize();
	sortList();
	return false;
    }
    
    public void tableViewSelectionDidChange(NSNotification notification) {
	// notification͖
        SCGhostManagerWindowController windowController = ghostManager.getWindowController();
        
        int selected_row = windowController.getTableInstalled().selectedRow();
        if (selected_row == -1) {
	    windowController.getPreviewView().setEmpty();
	    
            windowController.setMasterShioriKernelName("-");
	    windowController.setMakotoName("-");
            windowController.setIdentification("-");
            
            ghostManager.getBalloonsList().setEnabled(false);
	    ghostManager.getShellsList().setEnabled(false);
            windowController.getScaleSlider().setEnabled(false);
            windowController.getScaleIndicator().setEnabled(false);
	    windowController.setNumberOfShells(-1);
            
            // ߂ČĂ΂ꂽ̂߂ɃCWP[^
            windowController.updateScaleIndicator();
	    
	    windowController.setEnabledOfNetworkUpdateButton(false);
	    windowController.setEnabledOfVanishButton(false);
	    windowController.getBootAndQuitButton().setTitle(SCStringsServer.getStrFromMainDic("ghostmanager.bootandquit.boot")); // Ă
	    windowController.getBootAndQuitButton().setEnabled(false);
	    
	    windowController.setThumbnail(null);
        }
        else {
            ListsElement le = (ListsElement)sublist.elementAt(selected_row);
	    SCSession sessionIfRunning = SCFoundation.sharedFoundation().getSession(le.getPath()); // NĂȂnullB
	    boolean session_is_now_booting = SCSessionStarter.sharedStarter().isThisGhostStartingNow(le.getPath());
	    
	    File shell_dir = new File(SCFoundation.sharedFoundation().getParentDirOfBundle(),le.getPath()+"/shell/"+le.getShellDirName());
	    windowController.getPreviewView().setImage(shell_dir);
	    
	    String masterShioriType = le.getMasterShioriKernelName();
	    if (masterShioriType == null) {
		masterShioriType = SCStringsServer.getStrFromMainDic("ghostmanager.undeterminated");
	    }
	    else if (masterShioriType.length() == 0) {
		masterShioriType = SCStringsServer.getStrFromMainDic("ghostmanager.shioritype.none");
	    }
	    windowController.setMasterShioriKernelName( masterShioriType );
	    windowController.setIdentification( le.getIdentification() );
	    
	    Vector makoto_mod_names = le.getMakotoNames();
	    String makotoName;
	    if (makoto_mod_names == null) {
		makotoName = SCStringsServer.getStrFromMainDic("ghostmanager.undeterminated");
	    }
	    else if (makoto_mod_names.size() == 0) {
		makotoName = "\u7121\u3057"; // 
	    }
	    else {
		StringBuffer buf = new StringBuffer();
		final int n_makoto = makoto_mod_names.size();
		for (int i = 0;i < n_makoto;i++) {
		    String name = (String)makoto_mod_names.elementAt(i);
		    buf.append(name.length() == 0 ? SCStringsServer.getStrFromMainDic("ghostmanager.makototype.unknown") : name+", ");
		}
		makotoName = buf.toString();
	    }
	    windowController.setMakotoName(makotoName);
            
	    // o[
	    SCInstalledBalloonsList bl = ghostManager.getBalloonsList();
	    bl.setEnabled(true);
	    bl.selectBalloon( le.getBalloonPath() );
	    
	    // XP[
	    NSSlider scaleSlider = ghostManager.getWindowController().getScaleSlider();
	    scaleSlider.setEnabled(true);
	    scaleSlider.setDoubleValue( le.getScale() );
	    
	    // CWP[^ɔfB
	    ghostManager.getWindowController().updateScaleIndicator();
	    
	    // VF
	    if (sessionIfRunning != null) {
		boolean onoff = (!sessionIfRunning.isShellChangingSessionRunningNow() &&
				 !sessionIfRunning.isStatusClosing() &&
				 !sessionIfRunning.isNetworkUpdaterRunningNow() &&
				 !sessionIfRunning.isInPassiveMode());
		ghostManager.getShellsList().setEnabled(onoff);
	    }
	    else {
		ghostManager.getShellsList().setEnabled(!session_is_now_booting);
	    }
	    ghostManager.getShellsList().setContent(le.getPath());
	    ghostManager.getShellsList().selectShell(le.getShellDirName());
	    windowController.setNumberOfShells(windowController.getTableShells().numberOfRows());
	    
	    // TlC
	    File thumbnailFile = le.getThumbnailFile();
	    if (thumbnailFile != null) {
		NSImage thumbnail = null;
		String lowercase_fname = thumbnailFile.getName().toLowerCase();
		if (lowercase_fname.endsWith(".png")) {
		    thumbnail = new NSImage(thumbnailFile.getPath(), true);
		}
		else if (lowercase_fname.endsWith(".pnr")) {
		    thumbnail = SCAlphaConverter.convertImage(
			new NSImage(thumbnailFile.getPath(), true));
		}
		windowController.setThumbnail(thumbnail);
	    }
	    else {
		windowController.setThumbnail(null);
	    }
	    
	    // lbg[NXV,/
	    if (sessionIfRunning == null) {
		windowController.setEnabledOfNetworkUpdateButton(false);
		windowController.setEnabledOfVanishButton(false);
		
		windowController.getBootAndQuitButton().setTitle(SCStringsServer.getStrFromMainDic("ghostmanager.bootandquit.boot"));
		windowController.getBootAndQuitButton().setEnabled(!session_is_now_booting);
	    }
	    else {
		windowController.getBootAndQuitButton().setTitle(SCStringsServer.getStrFromMainDic("ghostmanager.bootandquit.quit"));
		windowController.getBootAndQuitButton().setEnabled(
		    !sessionIfRunning.isStatusClosing() &&
		    !sessionIfRunning.isNetworkUpdaterRunningNow() &&
		    !sessionIfRunning.isInPassiveMode());
		windowController.setEnabledOfNetworkUpdateButton(
		    sessionIfRunning.getStringFromShiori("homeurl") != null &&
		    !sessionIfRunning.isNetworkUpdaterRunningNow() &&
		    !sessionIfRunning.isStatusClosing() &&
		    !sessionIfRunning.isInPassiveMode());
		NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
		windowController.setEnabledOfVanishButton(
		    (defaults.integerForKey("misc.always_show_vanish") == 1 ||
		     sessionIfRunning.getStringFromShiori("vanishbuttonvisible") == null ||
		     !sessionIfRunning.getStringFromShiori("vanishbuttonvisible").equals("0")) &&
		    !sessionIfRunning.isStatusClosing() &&
		    !sessionIfRunning.isNetworkUpdaterRunningNow() &&
		    !sessionIfRunning.isInPassiveMode());
	    }
        }
    }
    
    private class GhostMenuItem extends NSMenuItem {
	SCSession self;
	String path;
	String balloonPath;
	String selfname;
	double scale;
	
	public GhostMenuItem(SCSession self,String name,String path,String balloonPath,String selfname,double scale) {
	    super(name,null,"");
	    this.self = self;
	    this.path = path;
	    this.balloonPath = balloonPath;
	    this.selfname = selfname;
	    this.scale = scale;
	}
	
	public SCSession getSelf() {
	    return self;
	}
	
	public String getPath() {
	    return path;
	}
	
	public String getBalloonPath() {
	    return balloonPath;
	}
	
	public String getSelfName() {
	    return selfname;
	}
	
	public double getScale() {
	    return scale;
	}
    }
}
