/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.util.*;

public class SCKawariDictionary
{
    SCKawari kawari;
    Hashtable dictionary; // gVectorŁA̒gStringB
    File ghost_dir;
    
    public SCKawariDictionary(SCKawari kawari,File ghost_dir)
    {
	this.kawari = kawari;
	this.ghost_dir = ghost_dir;
	
	dictionary = new Hashtable();
    }
    
    private void addEntry(String line,String fname)
    {
	// t@C̈s]ĎɃGgǉ܂B
	// Ggsł邱Ƃۏ؂ĂKv܂B
	// [JGĝ߂ɂ̎̃t@Cw肵ĉB
	
	// ܂̓Ggo
	String entry_name;
	if (line.charAt(0) == '@')
	{
	    entry_name = fname + line.substring(1,line.indexOf(":"));
	}
	else
	{
	    entry_name = line.substring(0,line.indexOf(":"));
	}
	entry_name = entry_name.trim();
	
	// []Ɉ͂܂Ă甽B
	if (entry_name.charAt(0) == '[' && entry_name.charAt(entry_name.length()-1) == ']')
	{
	    kawari.getResponceDictionary().addResponce(line);
	    return;
	}
	
	// RŕAo^Gg̃XgB
	StringTokenizer stEnts = new StringTokenizer(entry_name,",");
	final int n_destEntries = stEnts.countTokens();
	String[] destEntries = new String[n_destEntries];
	for (int i = 0;i < n_destEntries;i++)
	{
	    destEntries[i] = stEnts.nextToken().trim();
	}
	
	// Gg̕폜
	line = escapeQuoted(line.substring(line.indexOf(":") + 1)); // RāANH[g͈͂̓GXP[vB
	
	StringTokenizer st = new StringTokenizer(line,",");
	int n_tokens = st.countTokens();
	for (int i = 0;i < n_tokens;i++)
	{
	    String token = st.nextToken();
	    // ÕXy[X폜
	    token = token.trim();
	    
	    // ${@${[fname]ɒuB
	    /*int pos;
	    StringBuffer tokenBuf = new StringBuffer(token);
	    while(true)
	    {
		pos = tokenBuf.toString().indexOf("${@");
		if (pos == -1) break;
		
		tokenBuf.replace(pos,pos + 3,"${"+fname);
	    }
	    token = tokenBuf.toString();*/
	    
	    // wGgɈo^
	    for (int j = 0;j < n_destEntries;j++)
	    {
		addToken(destEntries[j],token);
	    }
	}
    }
    
    private static Hashtable _escape_table;
    static
    {
	// GXP[v͕̕Ku&_vŎn܂u_vŏI܂B
	_escape_table = new Hashtable();
	_escape_table.put("$","&_dollar_");
	_escape_table.put(" ","&_space_");
	_escape_table.put(",","&_comma_");
	_escape_table.put("{","&_braceopen_");
	_escape_table.put("}","&_braceclose_");
	_escape_table.put("(","&_parenthesisopen_");
	_escape_table.put(")","&_parenthesisclose_");
	_escape_table.put(";","&_semicolon_");
	// e[uɂ͂܂񂪁AGXP[vꂽ_uNI[g&_doublequote_ɒu܂B
	/* ------------------------ e[uI */
    }
    public static String escapeQuoted(String param)
    {
	// _uNI[gň͂܂ꂽ͈͂̕Ae[uɏ]ăGXP[vĕԂ܂B
	StringBuffer buf = new StringBuffer(param);
	while (true)
	{
	    int blockstart = buf.toString().indexOf('\"');
	    if (blockstart == -1) break;
	    if (blockstart >= 1 && (buf.charAt(blockstart-1) == '\\' || buf.charAt(blockstart-1) == '\u00a5')) // GXP[vĂ
	    {
		buf.replace(blockstart,blockstart+1,"&_doublequote_");
		buf.delete(blockstart-1,blockstart); // 
		continue;
	    }
	    
	    int blockend = buf.toString().indexOf('\"',blockstart+1);
	    if (blockend == -1) break;
	    if (blockend >= 1 && (buf.charAt(blockend-1) == '\\' || buf.charAt(blockend-1) == '\u00a5')) // GXP[vĂ
	    {
		buf.replace(blockend,blockend+1,"&_doublequote_");
		buf.delete(blockend-1,blockend); // 
		continue;
	    }
	    
	    StringBuffer content = new StringBuffer(buf.substring(blockstart+1,blockend)); // _uNH[ggB
	    int pos = 0;
	    while (pos < content.length())
	    {
		String replaced = (String)_escape_table.get( "" + content.charAt(pos) );
		if (replaced != null)
		{
		    content.replace(pos,pos+1,replaced);
		    pos += replaced.length();
		}
		else
		{
		    pos++;
		}
	    }
	    
	    buf.replace(blockstart,blockend+1,content.toString());
	}
	
	return buf.toString();
    }
    
    private static Hashtable _unescape_table;
    static
    {
	_unescape_table = new Hashtable();
	_unescape_table.put("&_dollar_","$");
	_unescape_table.put("&_space_"," ");
	_unescape_table.put("&_comma_",",");
	_unescape_table.put("&_braceopen_","{");
	_unescape_table.put("&_braceclose_","}");
	_unescape_table.put("&_parenthesisopen_","(");
	_unescape_table.put("&_parenthesisclose_",")");
	_unescape_table.put("&_semicolon_",";");
	_unescape_table.put("&_doublequote_","\"");
	/* ------------------------ e[uI */
    }
    public static String unescape(String escaped)
    {
	// e[uɏ]ăAGXP[vĕԂ܂B
	StringBuffer buf = new StringBuffer(escaped);
	int startoffset = 0; // JnʒuBO͖̕B
	while (true)
	{
	    int blockstart = buf.toString().indexOf("&_",startoffset);
	    if (blockstart == -1) break;
	    int blockend = buf.toString().indexOf('_',startoffset+blockstart+2);
	    if (blockend == -1) break;
	    
	    String unescaped = (String)_unescape_table.get( buf.substring(blockstart,blockend+1) );
	    if (unescaped != null)
	    {
		buf.replace(blockstart,blockend+1,unescaped);
	    }
	    else
	    {
		startoffset = blockend + 1; // O͖̕B
	    }
	}
	
	return buf.toString();
    }
    
    public void addToken(String entryName,String token)
    {
        // entryNamẽGgoȂ炻ɒǉAłȂΐVVectorĂɒǉB
        Vector array = (Vector)dictionary.get(entryName);
        if (array == null)
        {
            array = new Vector();
            dictionary.put(entryName,array);
        }
        array.add(token);
    }
    
    public void clearEntry(String entryname)
    {
	// GgTČ炻̃Gg̒g폜܂B
	dictionary.remove(entryname);
    }
    
    public Vector findEntry(String entryname)
    {
	// GgTČString̔zԂ܂B
	// ANDΉłB
	if (entryname.indexOf('&') == -1) // AND
	{
	    return (Vector)dictionary.get(entryname);
	}
	
	StringTokenizer st = new StringTokenizer(entryname,"&");
	Vector array = null;
	while (st.hasMoreTokens()) // ŏ̍ڂZbgĂBȂ玟ցB
	{
	    if (array == null)
	    {
		array = (Vector)dictionary.get(st.nextToken());
	    }
	    else
	    {
		break;
	    }
	}
	if (array == null) return null; // ȂΖ߂B
	
	while (st.hasMoreTokens()) // c̍ڂɌȂ̂𕥂ƂĂB
	{
	    Vector subtraction = (Vector)dictionary.get(st.nextToken());
	    if (subtraction == null) return null; // ȂB
	    
	    for (int i = 0;i < array.size();i++)
	    {
		if (!subtraction.contains(array.elementAt(i))) // Ȃ̂
		{
		    array.removeElementAt(i);
		    i--; // ~Ă̂ŃJE^߂B
		}
	    }
	}
	return array;
    }
    
    public String findEntryAndGetFirstElement(String entryname)
    {
	// GgA̍ŏ̍ڂԂ܂B
	// ȂnullɂȂ܂B
	Vector array = findEntry(entryname);
	if (array == null) return null;
	
	return (String)array.elementAt(0);
    }
    
    public static String convertWinPathToUnixOne(String path)
    {
	// Windows̃pX؂聏AUnix̃pX؂/ɒu܂B
	StringBuffer buf = new StringBuffer(path);
	while (true)
	{
	    int en_pos = buf.toString().indexOf('\\');
	    if (en_pos == -1) en_pos = buf.toString().indexOf('\u00a5');
	    if (en_pos == -1) break; // I
	    
	    buf.setCharAt(en_pos,'/');
	}
	return buf.toString();
    }
    
    public void loadDictFile(String fname)
    {
        // fnameɂkawari.inidict:w肳ꂽt@CĂ܂B
        File dictfile = new File(ghost_dir,convertWinPathToUnixOne(fname));
        if (!dictfile.exists()) return; // Ȃ炱̎͒߂B
        
        BufferedReader br = null;
        try
        {
            br = new BufferedReader(new InputStreamReader(new FileInputStream(dictfile),"SJIS"));
        }catch(Exception e){}
        
        String line = null;
        while(true)
        {
            // t@C̏I܂Ń[vB
            try{  line = br.readLine();  }catch(Exception e){}
            if (line == null) break; // EOF
            
            if (line.startsWith("!KAWA0000"))
            {
                // ÍĂB
                line = decryptString(line);
            }
            
            if (line.length() == 0) continue; // ̍s
            if (line.startsWith("#")) continue; // Rgs
            if (line.startsWith(":crypt")) continue;
            if (line.startsWith(":endcrypt")) continue;
            if (line.indexOf(":") == -1) continue; // Rs͖B
            
            addEntry(line,fname);
        }
	
	try{ br.close(); }catch(IOException e){}
    }
    
    public void saveEntriesToDictFile(String fname,String[] entries,boolean encrypt)
    {
	try
	{
	    File dictfile = new File(ghost_dir,convertWinPathToUnixOne(fname));
	    if (dictfile.exists()) dictfile.delete();
	    
	    OutputStreamWriter osw = new OutputStreamWriter(new FileOutputStream(dictfile),"SJIS");
	    for (int i = 0;i < entries.length;i++)
	    {
		Vector tokens = findEntry(entries[i]);
		if (tokens == null) continue;
		
		StringBuffer buf = new StringBuffer(entries[i]+" : ");
		int n_tokens = tokens.size();
		for (int j = 0;j < n_tokens;j++)
		{
		    buf.append((String)tokens.elementAt(j));
		    buf.append(" , ");
		}
		buf.delete(buf.length()-3,buf.length()); // Ō̎O " , " ͏B
		
		if (encrypt)
		{
		    buf.replace(0,buf.length(),encryptString(buf.toString()));
		}
		
		buf.append("\r\n");
		osw.write(buf.toString(),0,buf.length());
	    }
	    osw.flush();
	    osw.close();
	}
	catch (Exception e){}
    }
    
    private String encryptString(String param)
    {
	byte[] masked = null;
	try{ masked = param.getBytes("SJIS"); }catch(Exception e){}
	for (int i = 0;i < masked.length;i++)
	{
	    masked[i] ^= 0xCC;
	}
	
	return("!KAWA0000"+encodeBase64(masked));
    }

    private String decryptString(String param)
    {
        byte[] decoded = decodeBase64(param.substring(9));
        for (int i = 0;i < decoded.length;i++)
        {
            decoded[i] ^= 0xCC;
        }
        
        String result = null;
        try{  result = new String(decoded,"SJIS");  }catch(Exception e){}
        return result;
    }
    
    private byte[] decodeBase64(String param)
    {
        ByteArrayOutputStream bao = new ByteArrayOutputStream();
        byte[] encodedStr = param.getBytes();
        
        int _rest = 0;
        int len = encodedStr.length / 4;
        for (int i = 0;i < len;i++)
        {
            int dat = 0;
            for (int j = 0;j < 4;j++)
            {
                dat = dat << 6;
                
                byte c = encodedStr[i*4+j];
                int d;
                if((0x30<=c)&&(c<=0x39)) {
                    dat|=c-0x30+52;
                } else if((0x41<=c)&&(c<=0x5a)) {
                    dat|=c-0x41;
                } else if((0x61<=c)&&(c<=0x7a)) {
                    dat|=c-0x61+26;
                } else if(c==0x2b) {
                    dat|=62;
                } else if(c==0x2f) {
                    dat|=63;
                } else if(c==0x3d) {
                    _rest++;
                }
            }
            
            bao.write((dat>>16)&0x0ff);
            bao.write((dat>> 8)&0x0ff);
            bao.write((dat    )&0x0ff);
        }
        
        ByteArrayOutputStream bao2 = new ByteArrayOutputStream();
        byte[] bao_output = bao.toByteArray();
        bao2.write(bao_output,0,bao_output.length - _rest);
        return bao2.toByteArray();
    }
    
    private static final String table = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    private String encodeBase64(byte[] param)
    {
	ByteArrayOutputStream baos = new ByteArrayOutputStream();
	baos.write(param,0,param.length);
	StringBuffer encodedstr = new StringBuffer();
	
	int _rest = baos.size() % 3;
	if (_rest == 1) baos.write(0); // _~[f[^
	if (_rest > 0) baos.write(0); // _~[f[^
	
	byte[] dataByteArray = baos.toByteArray();
	
	int len = baos.size() / 3;
	for(int i=0;i<len;i++)
	{
	    int dat
		=(((int)dataByteArray[i*3  ])&0xff)<<16
		|(((int)dataByteArray[i*3+1])&0xff)<<8
		|(((int)dataByteArray[i*3+2])&0xff);

	    encodedstr.append(table.charAt((int)((dat>>18)&0x3f)));
	    encodedstr.append(table.charAt((int)((dat>>12)&0x3f)));
	    encodedstr.append(table.charAt((int)((dat>> 6)&0x3f)));
	    encodedstr.append(table.charAt((int)((dat    )&0x3f)));
	}

	if (_rest == 1)
	{
	    encodedstr.setCharAt((len-1)*4+2,'=');
	    encodedstr.setCharAt((len-1)*4+3,'=');
	}
	if (_rest == 2)
	{
	    encodedstr.setCharAt((len-1)*4+3,'=');
	}

	return encodedstr.toString();
    }
}
