/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;

public class SCKisCalculationCommands extends SCKisCommands
{
    public SCKisCalculationCommands(SCKawari kawari)
    {
	super(kawari);
    }
    
    public String inc(Vector params)
    {
	/*
	    @@Finc Gg [] []
	    ߂lF
	    
	    w肳ꂽGgɊi[Ă鐔lɁAw肵liȗꂽ1jAʂGgɏ㏑܂B
	    ̎ʂzꍇ́Aʂ̑ɏlZbg܂B
	    
	    l͏ȗꂽꍇ͏s܂B
	    ܂Aw肳ꂽGg݂Ȃ荀ڂȏ゠萔lłȂ肵ꍇ́As܂B
	*/
	try
	{
	    String entryname = (String)params.elementAt(0);
	    
	    // Gg̐l擾
	    Vector entry = kawari.dictionary().findEntry(entryname);
	    String str_firstItem = (String)entry.elementAt(0);
	    int inEntry = Integer.parseInt(str_firstItem);
	    
	    // 擾
	    int inc = 1;
	    if (params.size() >= 2) // incwL
	    {
		String str_inc = (String)params.elementAt(1);
		inc = Integer.parseInt(str_inc);
	    }
	    
	    int result = inEntry + inc;
	    
	    if (params.size() >= 3) // maxwL
	    {
		String str_max = (String)params.elementAt(2);
		int max = Integer.parseInt(str_max);
		
		if (result > max) result = max;
	    }
	    
	    // ʂGgɃZbg
	    kawari.dictionary().clearEntry(entryname);
	    kawari.dictionary().addToken(entryname,Integer.toString(result));
	}
	catch (Exception e) {} // NullExceptionNumberFormatExceptionLb`܂B
	
	return null;
    }
    
    public String dec(Vector params)
    {
	/*
	    @@Fdec Gg [] []
	    ߂lF
	    
	    w肳ꂽGgɊi[Ă鐔lɁAw肵liȗꂽ1jAʂGgɏ㏑܂B
	    ̎ʂꍇ́Aʂ̑ɉlZbg܂B
	    
	    l͏ȗꂽꍇ͉s܂B
	    ܂Aw肳ꂽGg݂Ȃ荀ڂȏ゠萔lłȂ肵ꍇ́As܂B
	*/
	try
	{
	    String entryname = (String)params.elementAt(0);
	    
	    // Gg̐l擾
	    Vector entry = kawari.dictionary().findEntry(entryname);
	    String str_firstItem = (String)entry.elementAt(0);
	    int inEntry = Integer.parseInt(str_firstItem);
	    
	    // 擾
	    int dec = 1;
	    if (params.size() >= 2) // decwL
	    {
		String str_dec = (String)params.elementAt(1);
		dec = Integer.parseInt(str_dec);
	    }
	    
	    int result = inEntry - dec;
	    
	    if (params.size() >= 3) // minwL
	    {
		String str_min = (String)params.elementAt(2);
		int min = Integer.parseInt(str_min);
		
		if (result < min) result = min;
	    }
	    
	    // ʂGgɃZbg
	    kawari.dictionary().clearEntry(entryname);
	    kawari.dictionary().addToken(entryname,Integer.toString(result));
	}
	catch (Exception e) {} // NullExceptionNumberFormatExceptionLb`܂B
	
	return null;
    }
    
    public String test_blockstyle(Vector params)
    {
	/*
	    @@F[ g[N1 Zq g[N2 ]
	    ߂lFtrue or false
	*/
	return _test(params,true);
    }
    
    public String test(Vector params)
    {
	/*
	    @@Ftest g[N1 Zq g[N2
	    ߂lFtrue or false
	*/
	return _test(params,false);
    }
    
    protected String _test(Vector params,boolean blockstyle)
    {
	int argc = params.size();
	if (blockstyle) argc--;
	
	if (argc == 0) return "false";
	else if (argc == 1)
	{
	    String token = SCKawariDictionary.unescape((String)params.elementAt(0));
	    return (SCKis.evaluateAsBoolean(token) ? "true" : "false");
	}
	else if (argc == 2)
	{
	    String ope = SCKawariDictionary.unescape((String)params.elementAt(0));
	    String token = SCKawariDictionary.unescape((String)params.elementAt(1));
	    if (ope.equals("!"))
	    {
		return (!SCKis.evaluateAsBoolean(token) ? "true" : "false");
	    }
	}
	
	String token1 = SCKawariDictionary.unescape((String)params.elementAt(0));
	String ope = SCKawariDictionary.unescape((String)params.elementAt(1));
	String token2 = SCKawariDictionary.unescape((String)params.elementAt(2));
	
	if (ope.equals("==") || ope.equals("="))
	{
	    return (token1.equals(token2) ? "true" : "false");
	}
	if (ope.equals("!="))
	{
	    return (!token1.equals(token2) ? "true" : "false");
	}
	if (ope.equals(">"))
	{
	    return (token1.compareTo(token2) > 0 ? "true" : "false");
	}
	if (ope.equals(">="))
	{
	    return (token1.compareTo(token2) >= 0 ? "true" : "false");
	}
	if (ope.equals("<"))
	{
	    return (token1.compareTo(token2) < 0 ? "true" : "false");
	}
	if (ope.equals("<="))
	{
	    return (token1.compareTo(token2) <= 0 ? "true" : "false");
	}
	if (ope.equals("-gt"))
	{
	    try
	    {
		return (Integer.parseInt(token1) > Integer.parseInt(token2) ? "true" : "false");
	    }
	    catch (Exception e) { return "false"; }
	}
	if (ope.equals("-ge"))
	{
	    try
	    {
		return (Integer.parseInt(token1) >= Integer.parseInt(token2) ? "true" : "false");
	    }
	    catch (Exception e) { return "false"; }
	}
	if (ope.equals("-lt"))
	{
	    try
	    {
		return (Integer.parseInt(token1) < Integer.parseInt(token2) ? "true" : "false");
	    }
	    catch (Exception e) { return "false"; }
	}
	if (ope.equals("-le"))
	{
	    try
	    {
		return (Integer.parseInt(token1) <= Integer.parseInt(token2) ? "true" : "false");
	    }
	    catch (Exception e) { return "false"; }
	}
	if (ope.equals("-eq"))
	{
	    try
	    {
		return (Integer.parseInt(token1) == Integer.parseInt(token2) ? "true" : "false");
	    }
	    catch (Exception e) { return "false"; }
	}
	if (ope.equals("-ne"))
	{
	    try
	    {
		return (Integer.parseInt(token1) != Integer.parseInt(token2) ? "true" : "false");
	    }
	    catch (Exception e) { return "false"; }
	}
	if (ope.equals("&&"))
	{
	    return (SCKis.evaluateAsBoolean(token1) && SCKis.evaluateAsBoolean(token2) ? "true" : "false");
	}
	if (ope.equals("||"))
	{
	    return (SCKis.evaluateAsBoolean(token1) || SCKis.evaluateAsBoolean(token2) ? "true" : "false");
	}
	
	return "false";
    }
    
    public String expr(Vector argv)
    {
	/*
	    @@Fexpr ()
	    ߂lF
	*/
	
	// SăAGXP[v
	Vector unescaped_argv = new Vector();
	
	final int argc = argv.size();
	for (int i = 0;i < argc;i++)
	{
	    unescaped_argv.add(SCKawariDictionary.unescape((String)argv.elementAt(i)));
	}
	
	Vector cond = convertToInvPorland(unescaped_argv);
	
	/*final int size = cond.size();
	StringBuffer buf = new StringBuffer();
	for (int i = 0;i < size;i++)
	{
	    buf.append((String)cond.elementAt(i) + ' ');
	}
	System.out.println(buf.toString());*/
	
	return evalCondition(cond);
    }
    protected String evalCondition(Vector condArray)
    {
	// t|[hZ܂B
	try
	{
	    Vector work_stack = new Vector(); // <String> vZp
	    final int n_cond_elems = condArray.size();
	    for (int i = 0;i < n_cond_elems;i++)
	    {
		String currentElem = (String)condArray.elementAt(i);
		if (isNumber(currentElem) || getPriorityOfOperator(currentElem) == 0)
		{
		    work_stack.add(currentElem);
		}
		else if (currentElem.equals("substr"))
		{
		    int len = Integer.parseInt((String)pop(work_stack));
		    int pos = Integer.parseInt((String)pop(work_stack)) - 1; // 1IW
		    String str = (String)pop(work_stack);
		    
		    if (pos + len + 1 > str.length()) // ͂ݏo܂悤ɂB
		    {
			len = str.length() - pos;
		    }
		    
		    work_stack.add(str.substring(pos,pos+len));
		}
		else if (currentElem.equals("index"))
		{
		    String chars = (String)pop(work_stack);
		    String str = (String)pop(work_stack);
		    
		    String result = "";
		    final int len = str.length();
		    for (int j = 0;j < len;j++)
		    {
			int pos = chars.indexOf(str.charAt(j));
			if (pos != -1)
			{
			    result = Integer.toString(j+1); // 1IW
			    break;
			}
		    }
		    
		    work_stack.add(result);
		}
		else if (currentElem.equals("length"))
		{
		    String str = (String)pop(work_stack);
		    work_stack.add(Integer.toString(str.length()));
		}
		else if (currentElem.equals("find") || currentElem.equals(":"))
		{
		    String substr = (String)pop(work_stack);
		    String str = (String)pop(work_stack);
		
		    work_stack.add(str.indexOf(substr) == -1 ? "" : substr);
		}
		else if (currentElem.equals("findpos"))
		{
		    String substr = (String)pop(work_stack);
		    String str = (String)pop(work_stack);
		    
		    int pos = str.indexOf(substr);
		    work_stack.add(pos == -1 ? "" : Integer.toString(pos+1)); // 1IW
		}
		else
		{
		    String ope = currentElem;
		    String r = (String)pop(work_stack); // E
		    String l = (String)pop(work_stack); // 
		    
		    String result = "";
		    if (ope.equals("|"))
		    {
			result = (SCKis.evaluateAsBoolean(l) ? l : r);
		    }
		    else if (ope.equals("&"))
		    {
			result = (SCKis.evaluateAsBoolean(l) && SCKis.evaluateAsBoolean(r) ? l : null);
		    }
		    else if (ope.equals("<"))
		    {
			try
			{
			    result = (Integer.parseInt(l) < Integer.parseInt(r) ? "1" : null);
			}
			catch (NumberFormatException e)
			{
			    result = (l.compareTo(r) < 0 ? "1" : null);
			}
		    }
		    else if (ope.equals("<="))
		    {
			try
			{
			    result = (Integer.parseInt(l) <= Integer.parseInt(r) ? "1" : null);
			}
			catch (NumberFormatException e)
			{
			    result = (l.compareTo(r) <= 0 ? "1" : null);
			}
		    }
		    else if (ope.equals("=") || ope.equals("=="))
		    {
			try
			{
			    result = (Integer.parseInt(l) == Integer.parseInt(r) ? "1" : null);
			}
			catch (Exception e)
			{
			    result = (l.equals(r) ? "1" : null);
			}
		    }
		    else if (ope.equals("!="))
		    {
			try
			{
			    result = (Integer.parseInt(l) != Integer.parseInt(r) ? "1" : null);
			}
			catch (Exception e)
			{
			    result = (!l.equals(r) ? "1" : null);
			}
		    }
		    else if (ope.equals(">="))
		    {
			try
			{
			    result = (Integer.parseInt(l) >= Integer.parseInt(r) ? "1" : null);
			}
			catch (NumberFormatException e)
			{
			    result = (l.compareTo(r) >= 0 ? "1" : null);
			}
		    }
		    else if (ope.equals(">"))
		    {
			try
			{
			    result = (Integer.parseInt(l) > Integer.parseInt(r) ? "1" : null);
			}
			catch (NumberFormatException e)
			{
			    result = (l.compareTo(r) > 0 ? "1" : null);
			}
		    }
		    else if (ope.equals("+"))
		    {
			try
			{
			    result = Integer.toString( Integer.parseInt(l) + Integer.parseInt(r) );
			}catch(Exception e){}
		    }
		    else if (ope.equals("-"))
		    {
			try
			{
			    result = Integer.toString( Integer.parseInt(l) - Integer.parseInt(r) );
			}catch(Exception e){}
		    }
		    else if (ope.equals("*"))
		    {
			try
			{
			    result = Integer.toString( Integer.parseInt(l) * Integer.parseInt(r) );
			}catch(Exception e){}
		    }
		    else if (ope.equals("/"))
		    {
			try
			{
			    result = Integer.toString( Integer.parseInt(l) / Integer.parseInt(r) );
			}catch(Exception e){}
		    }
		    else if (ope.equals("%"))
		    {
			try
			{
			    result = Integer.toString( Integer.parseInt(l) % Integer.parseInt(r) );
			}catch(Exception e){}
		    }
		    work_stack.add(result);
		}
	    }
	    // ŏIIɃX^bNɂ͒lĉŁAԂB
	    return (String)work_stack.elementAt(0);
	}
	catch (Exception e)
	{
	    System.err.println("The Kawari Java Clone: syntax error in condition.");
	    e.printStackTrace();
	    return "";
	}
    }
    protected Vector convertToInvPorland(Vector src)
    {
	// t|[h`ɕϊB
	Vector cond_stack = new Vector();
	Vector ope_stack = new Vector();
	
	boolean flag_quote = false; // ꂪĂ鎞̓g[Nɒlƌ􂷁B
	final int n_tokens = src.size();
	for (int i = 0;i < n_tokens;i++)
	{
	    String token = (String)src.elementAt(i);
	    if (isNumber(token) || flag_quote ||
		    (!token.equals("(") &&
		    !token.equals(")") &&
		    !token.equals("quote") &&
		    getPriorityOfOperator(token) == 0))
	    {
		// A񉉎Zq͖ł̂܂܏óB
		// flag_quoteĂ΂ǂȃg[Nł̂܂܏óB
		cond_stack.add(token);
		flag_quote = false;
		continue;
	    }
	    
	    if (token.equals("quote"))
	    {
		flag_quote = true;
		continue;
	    }
	    else if (token.equals("("))
	    {
		// Jʂpush
		ope_stack.add(token);
	    }
	    else if (token.equals(")"))
	    {
		// ʂꂽ牉ZqX^bNɊJʂ܂popB
		while (true)
		{
		    String top = (String)pop(ope_stack);
		    
		    if (top.equals("("))
		    {
			break;
		    }
		    else
		    {
			cond_stack.add(top);
		    }
		}
	    }
	    else
	    {
		// Zq́A̎_ł̃X^bÑgbvƔrėD揇ʂpoppushAłȂpusĥ
		// ZqX^bN󂾂gbvJʂȂ疳pusĥ݁B
		if (ope_stack.size() > 0)
		{
		    String top = (String)ope_stack.elementAt(ope_stack.size()-1);
		    if (!top.equals("(") && getPriorityOfOperator(token) <= getPriorityOfOperator(top))
		    {
			cond_stack.add(top);
			ope_stack.removeElementAt(ope_stack.size()-1);
		    }
		}
		ope_stack.add(token);
	    }
	}
	
	// ZqX^bNSpop
	final int ope_stack_size = ope_stack.size();
	for (int i = ope_stack_size-1;i >= 0;i--)
	{
	    cond_stack.add(ope_stack.elementAt(i));
	}
	
	return cond_stack;
    }
    
    public boolean isNumber(String str)
    {
	final int len = str.length();
	for (int i = 0;i < len;i++)
	{
	    char c = str.charAt(i);
	    if (!Character.isDigit(c) && !(i == 0 && c == '-' && len > 1)) return false;
	}
	return true;
    }
    
    public static Object pop(Vector vec)
    {
	final int size = vec.size();
	Object top = vec.elementAt(size-1);
	vec.removeElementAt(size-1);
	return top;
    }
    
    private static Hashtable OPE_PRIORITY;
    static
    {
	OPE_PRIORITY = new Hashtable();
	OPE_PRIORITY.put("substr",new Integer(7));
	OPE_PRIORITY.put("index",new Integer(7));
	OPE_PRIORITY.put("findpos",new Integer(7));
	OPE_PRIORITY.put("find",new Integer(7));
	OPE_PRIORITY.put("length",new Integer(7));
	OPE_PRIORITY.put(":",new Integer(6));
	OPE_PRIORITY.put("*",new Integer(5));
	OPE_PRIORITY.put("/",new Integer(5));
	OPE_PRIORITY.put("%",new Integer(5));
	OPE_PRIORITY.put("+",new Integer(4));
	OPE_PRIORITY.put("-",new Integer(4));
	OPE_PRIORITY.put("<",new Integer(3));
	OPE_PRIORITY.put(">",new Integer(3));
	OPE_PRIORITY.put("<=",new Integer(3));
	OPE_PRIORITY.put(">=",new Integer(3));
	OPE_PRIORITY.put("==",new Integer(3));
	OPE_PRIORITY.put("==",new Integer(3));
	OPE_PRIORITY.put("<=",new Integer(3));
	OPE_PRIORITY.put("&",new Integer(2));
	OPE_PRIORITY.put("|",new Integer(1));
    }
    public static int getPriorityOfOperator(String ope)
    {
	// 傫قǗD揇ʂB
	// ZqłȂ0ԂB
	Integer pri = (Integer)OPE_PRIORITY.get(ope);
	return (pri == null ? 0 : pri.intValue());
    }
    
    public String rand(Vector params)
    {
	/*
	    @@Frand ܂͏
	    ߂lF0烊~bg܂ł͈̔͂ł̗𐮐ŕԂB
	    
	    ~bg̒l͔͈͂ɂ͊܂܂܂B
	*/
	if (params.size() < 1) return null;
	try
	{
	    int limit = Integer.parseInt((String)params.elementAt(0));
	    int signal = 1;
	    if (limit < 0)
	    {
		signal = -1;
		limit *= -1;
	    }
	    int rand = (int)((Math.random() * 2147483647) % limit);
	    return Integer.toString( rand * signal );
	}
	catch (Exception e) {return null;}
    }
}
