/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.Vector;

public class SCKisDictionaryCommands extends SCKisCommands
{
    public SCKisDictionaryCommands(SCKawari kawari)
    {
	super(kawari);
    }
    
    public String array(Vector params) throws Exception
    {
	/*
	    @@Farray Gg CfBbNX
	    ߂lFwGg̎w荀ڂ̒l
	    
	    CfBbNX̓[琔܂B
	    ${}Ɠ悤Ɍʂ]܂B
	*/
	String entry = (String)params.elementAt(0);
	int index = Integer.parseInt((String)params.elementAt(1));
	
	Vector vec = kawari.dictionary().findEntry(entry);
	return (String)vec.elementAt(index);
    }
    
    public String get(Vector params) throws Exception
    {
	/*
	    @@Fget Gg CfBbNX
	    ߂lFwGg̎w荀ڂ̒l
	    
	    CfBbNX̓[琔܂B
	    ${}ƈႢAʂ]܂B
	*/
	Vector items = kawari.dictionary().findEntry((String)params.elementAt(0));
	if (items == null) return null; // Gg݂Ȃ
	
	int index = Integer.parseInt((String)params.elementAt(1));
	if (index < 0 || index >= items.size()) return null; // ڂ݂Ȃ
	
	return (String)items.elementAt(index);
    }
    
    public String set(Vector params)
    {
	/*
	    @@Fset Gg l
	    ߂lF
	    
	    w肳ꂽGgɒl܂B
	    ɒl݂Ă㏑܂B
	*/
	if (params.size() < 2) return null;
	
	String entryname = (String)params.elementAt(0);
	
	// {͂ł͊SłȂƎvAłcقǕGȂƂl͂Ȃ낤B
	String value = (String)params.elementAt(1);
	value = SCKawariDictionary.unescape(value);
	value = SCKawariDictionary.escapeQuoted(value);
	
	kawari.dictionary().clearEntry(entryname);
	kawari.dictionary().addToken(entryname,value);
	
	return null;
    }
    
    public String adddict(Vector params)
    {
	/*
	    @@Fadddict Gg l
	    ߂lF
	    
	    w肳ꂽGgɒlAGXP[vĂǉ܂B
	    ɑ݂l㏑܂B
	*/
	if (params.size() < 2) return null;
	
	String entryname = (String)params.elementAt(0);
	
	// {͂ł͊SłȂƎvAłcقǕGȂƂl͂Ȃ낤B
	String value = (String)params.elementAt(1);
	value = SCKawariDictionary.unescape(value);
	value = SCKawariDictionary.escapeQuoted(value);
	
	kawari.dictionary().addToken(entryname,value);
	
	return null;
    }
    
    public String clear(Vector params)
    {
	/*
	    @@Fclear Gg
	    ߂lF
	    
	    w肳ꂽGgɂ܂B
	*/
	if (params.size() < 1) return null;
	
	String entryname = (String)params.elementAt(0);
	kawari.dictionary().clearEntry(entryname);
	
	return null;
    }
    
    public String enumerate(Vector params)
    {
	/*
	    @@Fenumerate Gg
	    ߂lFwGg̑Sg[Ni󔒋؂j
	    
	    Ԃl̏Ԃ͕słB\[g܂B
	*/
	if (params.size() < 1) return null;
	
	String entryname = (String)params.elementAt(0);
	Vector tokens = kawari.dictionary().findEntry(entryname);
	StringBuffer sb = new StringBuffer();
	int n_tokens = tokens.size();
	for (int i = 0;i < n_tokens;i++)
	{
	    sb.append(' ');
	    sb.append( (String)tokens.elementAt(i) );
	}
	sb.deleteCharAt(0); // 擪ɗ]vȃXy[XtĂB
	
	return sb.toString();
    }
    
    public String size(Vector params)
    {
	/*
	    @@Fsize Gg
	    ߂lFwGg̍ڐ
	*/
	Vector items = kawari.dictionary().findEntry((String)params.elementAt(0));
	return (items == null ? "0" : Integer.toString(items.size()));
    }
}
