/*  $Id: SCMakotoLoader.java,v 1.6 2004/02/05 09:29:35 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.util.*;
import java.lang.reflect.*;

public class SCMakotoLoader {
    private static Vector MAKOTO_MODULES; // content: (Class)
    static {
	// MAKOTO_MODULESɂ́A^ՃW[NXꗗĂ܂B
	// ClassIuWFNg΁ANX̓t@C烍[h悤lbg[NzɃ[h悤S\܂B
	// Ⴆhome/pluginɐ^ՃW[vOCƂăCXg[ÃXgɒǉ铙̏l܂B
	MAKOTO_MODULES = new Vector();
	MAKOTO_MODULES.add(SCExtMakoto.class);
    }
    
    public static void instalMakotoModule(Class module) {
	// ɓ̃W[݂ΒuB
	String module_name = getModuleName(module);
	
	for (int i = 0;i < MAKOTO_MODULES.size();i++) {
	    Class current_module = (Class)MAKOTO_MODULES.elementAt(i);
	    if (getModuleName(current_module).equals(module_name)) {
		MAKOTO_MODULES.removeElementAt(i);
		i--;
	    }
	}
	
	//MAKOTO_MODULES.add(module);
	MAKOTO_MODULES.add(0,module);
    }
    
    public static Vector loadMakotoModules(File spirit_root) {
	/*
	  ̃\bh͎w肳ĂSĂMAKOTOW[[hA
	  ʉߏɕׂꂽVectoř`ŕԂ܂B
	  Vector̊evfSCMakotoAccessorɂȂ܂B
	  FoȂMAKOTOw肳Ă炻MAKOTO͖܂B
	  ŏIIɔFoMAKOTOȂꍇAMAKOTÔ݂̂Ȃꍇ
	  ̔z񂪕Ԃ܂B
	*/
	Vector result = new Vector(0, 1); // ǂʂ̓[B
		
	// descript.txtǂށBKvȃGgtȂalias.txtǂ
	String entry_makoto;
	SCDescription descript_txt = new SCDescription(new File(spirit_root,"descript.txt"));
	if (descript_txt.exists("makoto")) {
	    entry_makoto = descript_txt.getStrValue("makoto");
	}
	else {
	    SCDescription alias_txt = new SCDescription(new File(spirit_root,"alias.txt"));
	    entry_makoto = (alias_txt.exists("makoto") ? alias_txt.getStrValue("makoto") : "makoto.dll");
	}
	
	if (entry_makoto.charAt(0) == '[') { // pCv
	    StringTokenizer st = new StringTokenizer(entry_makoto.substring(1,entry_makoto.length()-1),","); // O̊ʂO
	    while (st.hasMoreTokens()) {
		File f = new File(spirit_root,(String)st.nextToken());
		if (f.exists()) {
		    SCMakotoAccessor makoto = loadMakoto(f);
		    if (makoto != null) {
			result.add(makoto);
		    }
		}
	    }
	}
	else {
	    File f = new File(spirit_root,entry_makoto);
	    if (f.exists()) {
		SCMakotoAccessor makoto = loadMakoto(f);
		if (makoto != null) {
		    result.add(makoto);
		}
	    }
	}
	
	return result;
    }
    
    protected static SCMakotoAccessor loadMakoto(File makotofile) {
	// makotofile : dlliIɂjar̉\Lj̃t@C
	// FoȂnullԂ܂B
        SCMakotoAccessor makoto = null;
        
	final int n_MAKOTO_MODULES = MAKOTO_MODULES.size();
	for (int i = 0;i < n_MAKOTO_MODULES;i++) {
	    Class current_module = (Class)MAKOTO_MODULES.elementAt(i);
	    if (checkIfUsable(current_module,makotofile)) {
		makoto = newAccessor(current_module,makotofile);
		if (makoto != null) {
		    break;
		}
	    }
	}
        
        return makoto;
    }
    
    public static Vector getModuleNames(File spirit_root) {
	/*
	  ̃\bh͎w肳ĂSĂMAKOTOW[XLA
	  ̃W[ʉߏɕׂꂽVectoř`ŕԂ܂B
	  Vector̊evfStringɂȂ܂B
	  FoȂMAKOTOw肳Ă炻̏ꏊɂ͋̕񂪓܂B
	  ŏIIɔFoMAKOTOȂꍇAMAKOTÔ݂̂Ȃꍇ
	  ̔z񂪕Ԃ܂B
	*/
	Vector result = new Vector(0, 1); // ǂʂ̓[B
	
	// alias.txtǂ
	SCDescription alias_txt = new SCDescription(new File(spirit_root,"alias.txt"));
	String entry_makoto = (alias_txt.exists("makoto") ? alias_txt.getStrValue("makoto") : "makoto.dll");
	
	if (entry_makoto.charAt(0) == '[') { // pCv
	    StringTokenizer st = new StringTokenizer(entry_makoto.substring(1,entry_makoto.length()-1),","); // O̊ʂO
	    while (st.hasMoreTokens()) {
		File f = new File(spirit_root,(String)st.nextToken());
		if (f.exists()) {
		    String modname = getModuleName(f);
		    result.add(modname == null ? "" : modname);
		}
	    }
	}
	else {
	    File f = new File(spirit_root,entry_makoto);
	    if (f.exists()) {
		SCMakotoAccessor makoto = loadMakoto(f);
		if (f.exists()) {
		    String modname = getModuleName(f);
		    result.add(modname == null ? "" : modname);
		}
	    }
	}
	
	return result;
    }
    
    public static String getModuleName(Class module) {
	try {
	    Method getModuleName = module.getMethod("getModuleName",null);
	    return (String)getModuleName.invoke(null,null);
	}
	catch (NoSuchMethodException e) {
	    System.err.println("SCMakotoLoader error : Shiori module class \""+module.getName()+"\" doesn\'t have method getModuleName().");
	}
	catch (Exception e) {
	    System.err.println("SCMakotoLoader error : Exception has occured during accesing makoto module class \""+module.getName()+"\".");
	    e.printStackTrace();
	}
	return null;
    }
    
    public static String getModuleInfo(Class module) {
	// public static String getModuleInfo()ĂԁBnullԂB
	try {
	    Method getModuleInfo = module.getMethod("getModuleInfo",null);
	    return (String)getModuleInfo.invoke(null,null);
	}
	catch (Exception e) {
	    return null;
	}
    }
    
    public static boolean checkIfUsable(Class module,File makotofile) {
	try {
	    Method checkroutine = module.getMethod("checkIfUsable",new Class[] {File.class});
	    Boolean resp = (Boolean)checkroutine.invoke(null,new Object[] {makotofile});
	    return resp.booleanValue();
	}
	catch (NoSuchMethodException e) {
	    System.err.println("SCMakotoLoader error : Shiori module class \""+module.getName()+"\" doesn\'t have method checkIfUsable() .");
	}
	catch (Exception e) {
	    System.err.println("SCMakotoLoader error : Exception has occured during accesing makoto module class \""+module.getName()+"\".");
	    e.printStackTrace();
	}
	return false;
    }
    
    public static SCMakotoAccessor newAccessor(Class module,File makotofile) {
	try {
	    Constructor con = module.getConstructor(new Class[] {File.class});
	    return new SCMakotoAccessor( con.newInstance(new Object[] {makotofile}) );
	}
	catch (NoSuchMethodException e) {
	    System.out.println("SCMakotoLoader error : Makoto module class \""+module.getName()+"\" doesn\'t have some needed methods.");
	    e.printStackTrace();
	}
	catch (Exception e) {
	    System.out.println("SCMakotoLoader error : Exception has occured during accesing makoto module class \""+module.getName()+"\".");
	    e.printStackTrace();
	}
	return null;
    }
    
    protected static String getModuleName(File makotofile) {
        String module_name = null;
        
	final int n_MAKOTO_MODULES = MAKOTO_MODULES.size();
	for (int i = 0;i < n_MAKOTO_MODULES;i++) {
	    Class current_module = (Class)MAKOTO_MODULES.elementAt(i);
	    if (checkIfUsable(current_module,makotofile)) {
		module_name = getModuleName(current_module);
		break;
	    }
	}
        
        return module_name;
    }
}
