/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;

public class SCNSKeywordToWordChains
{
    SCNiseShiori niseshiori;
    Vector elements; // content : (SCNSKeywordToWordChains.Element)vf
    
    public SCNSKeywordToWordChains(SCNiseShiori niseshiori)
    {
	this.niseshiori = niseshiori;
	elements = new Vector();
    }
    
    public void add(Vector chain_elements,String keyword)
    {
	elements.add(new Element(chain_elements,keyword));
    }
    
    public void chainIfMatches(String sentence)
    {
	// sentenceɃqbgL[[hvf΁Ã`FCSĎs܂B
	final int n_elements = elements.size();
	for (int i = 0;i < n_elements;i++)
	{
	    Element e = (Element)elements.elementAt(i);
	    e.chainIfMatches(sentence);
	}
    }
    
    private class Element
    {
	Vector chain_elements; // content : (SCNSWord)P
	String keyword;
	
	public Element(Vector chain_elements,String keyword)
	{
	    this.chain_elements = chain_elements;
	    this.keyword = keyword;
	}
	
	public void chainIfMatches(String sentence)
	{
	    if (sentence.indexOf(keyword) == -1) return; // no hit
	    
	    int sel = (int)((Math.random() * Integer.MAX_VALUE) % chain_elements.size());
	    SCNSWord word = (SCNSWord)chain_elements.elementAt(sel);
	    SCNSWordCategory cat = niseshiori.getWordDictionary().getCategory(word.getCategory());
	    
	    int age = (int)Math.round(cat.countWords(word.getType()) * SCNSWordDictionary.RATE_AGE);
	    int prob = word.getProb() + age;
	    
	    if (prob < 3) prob = 3; // Œł2ageB
	    if (prob > age) prob = age; // 
	    
	    word.setProb(prob);
	}
    }
}
