/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;

public class SCNSWordDictionary
{
    public static final double RATE_AGE = 7.0; // `FCɑImage䗦B̃JeS/^Cv̑SPꐔRATE_AGE{B
    public static final double RATE_SAGE = 0.45; // PIɑSP̑Imsage䗦BȎImRATE_SAGE{B
    Hashtable categories; // key : (String)JeS^JeS΋󔒕 , value : (SCNSWordCategory)P̕ޏW
    
    public SCNSWordDictionary()
    {
	categories = new Hashtable();
    }
    
    public void addEntriesWithLine(String line)
    {
	// line : t@CɂsB
	int sep_comma_pos = line.indexOf(',');
	String destination = line.substring(0,sep_comma_pos);
	
	String category = parseCategory(destination);
	String type = parseType(destination);
	if (category == null) category = ""; // JeSw薳
	if (type == null) type = ""; // ^Cvw薳
	
	String data = line.substring(sep_comma_pos+1).trim();
	StringTokenizer st = new StringTokenizer(data,",");
	while (st.hasMoreTokens())
	{
	    addWord(category,type,st.nextToken().trim());
	}
    }
    
    public void addWord(String category,String type,String word)
    {
	addWord(new SCNSWord(category,type,word));
    }
    
    public void addWord(SCNSWord word)
    {
	SCNSWordCategory cat = (SCNSWordCategory)categories.get(word.getCategory());
	if (cat == null) // ߂ČꂽJeS
	{
	    cat = new SCNSWordCategory();
	    categories.put(word.getCategory(),cat);
	}
	
	cat.addWord(word);
    }
    
    public SCNSWordCategory getCategory(String category)
    {
	// ݂ȂJeS^ꂽꍇnullԂ܂B
	return (SCNSWordCategory)categories.get(category);
    }
    
    public SCNSWord chooseOne(String category,String type)
    {
	// JeScategory = "",^Cvtype = "",^CvwiŚ͈jȂtype = nullŃR[ĉB
	sage();
	
	SCNSWordCategory cat = (SCNSWordCategory)categories.get(category);
	if (cat == null) return null;
	
	SCNSWord word = cat.chooseOne(type);
	if (word == null) return null;
	
	// IꂽPꂪWordToWord`FCĂ΁AЕ̑ImageB
	SCNSWord chain_target = word.getChainTarget();
	if (chain_target != null)
	{
	    int age = (int)Math.round(cat.countWords(type) * RATE_AGE);
	    int prob = chain_target.getProb() + age;
	    
	    if (prob < 3) prob = 3; // Œł2ageB
	    if (prob > age) prob = age; // 
	    
	    chain_target.setProb(prob);
	}
	
	return word;
    }
    
    public void sage()
    {
	// SJeS̑S^Cv̑SP̑ImsageB
	Object[] cats = categories.entrySet().toArray(); // content : Map.Entry[(SCNSWordCategory)JeS]
	for (int i = 0;i < cats.length;i++)
	{
	    SCNSWordCategory cat = (SCNSWordCategory)((Map.Entry)cats[i]).getValue();
	    Object[] lists = cat.getWordLists(); // content : Map.Entry[(Vector)e^CvɑP̃Xg]
	    
	    for (int j = 0;j < lists.length;j++)
	    {
		Vector words = (Vector)((Map.Entry)lists[j]).getValue();
		final int n_words = words.size();
		
		for (int k = 0;k < n_words;k++)
		{
		    SCNSWord word = (SCNSWord)words.elementAt(k);
		    
		    int prob = (int)Math.round(word.getProb() * RATE_SAGE);
		    if (prob == word.getProb()) prob--; // Œł1sageB
		    word.setProb(prob);
		}
	    }
	}
    }
    
    public static String parseCategory(String src)
    {
	// \ms[],%ms[],%[]̌`JeS𒊏o܂B
	// JeSw肳ĂȂnullԂ܂B
	int blockstart = src.indexOf('[');
	int blockend = src.indexOf(']');
	if (blockstart == -1) // ^Cvw薳
	{
	    return src.substring(1);
	}
	else
	{
	    if (blockstart == 1) // JeSw薳
	    {
		return null;
	    }
	    else
	    {
		return src.substring(1,blockstart);
	    }
	}
    }
    
    public static String parseType(String src)
    {
	// \ms[],%ms[],%[]̌`^Cv𒊏o܂B
	// ^Cvw肳ĂȂnullԂ܂B
	int blockstart = src.indexOf('[');
	int blockend = src.indexOf(']');
	if (blockstart == -1) // ^Cvw薳
	{
	    return null;
	}
	else
	{
	    return src.substring(blockstart+1,blockend);
	}
    }
}
