/*
    $Id: SCNetworkUpdater.java,v 1.6 2003/08/02 02:58:04 phonohawk Exp $
    ----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;

public class SCNetworkUpdater extends Thread {
    private static final int TIMEOUT = 50 * 1000;
    
    volatile boolean flagTerm = false;
    SCSession session;
    
    public SCNetworkUpdater(SCSession session) {
	// session : lbg[NXVsZbV
	this.session = session;
    }
    
    public void run() {
	if (session.isInPassiveMode()) return;
	int pool = NSAutoreleasePool.push();
	
	postNotification("networkupdater","begin");
	
	SCStatusWindowController stat = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	stat.setTypeToText();
	stat.show();
	stat.texttype_print("Online Updater started...\n");
	
	final File ghostdir = new File(SCFoundation.getParentDirOfBundle(),session.getGhostPath());
	
	// lbg[NXVJn̎|SHIORIɓ`
	session.doShioriEvent("OnUpdateBegin");
	
	// ƗpfBNgAhome/_system/updating_temp/[ghostname]
	String dirname = NSPathUtilities.lastPathComponent(session.getGhostPath());
	File tmpdir = new File(SCFoundation.getParentDirOfBundle(),"home/_system/updating_temp/"+dirname);
	if (tmpdir.exists()) {
	    SCFileUtils.deleteRecursively(tmpdir);
	}
	tmpdir.mkdir();
	
	// [gURL擾
	String homeurl = session.getStringFromShiori("homeurl");
	if (homeurl == null) { // 擾s
	    SCFileUtils.deleteRecursively(tmpdir);
	    NSAutoreleasePool.pop(pool);
	    return;
	}
	if (!homeurl.endsWith("/")) homeurl = homeurl + '/'; // XbVŏIĂȂΕt
	stat.texttype_println("url : %[color,orange]"+homeurl+"%[color,default]");

	// [gupdates2.dau_E[hBupdates.txt_E[h
	try {
	    File outfile = new File(tmpdir,"updates2.dau");
	    outfile.delete();
	    SCFileDownloader.download(homeurl+"updates2.dau",outfile,TIMEOUT);
	    // _E[hɂ͐Ainfoseek̂₤200ŃG[ԂIɛRਂɂ
	    // Up[XĂ݂ăG[oȂm߂KvB
	    // mother fucker!
	    new SCUpdates2Dau(outfile);
	}
	catch (Exception e) {
	    new File(tmpdir, "updates2.dau").delete();
	    stat.texttype_print("%[color,yellow]Couldn\'t download the updates2.dau.\n");
	    stat.texttype_print("Trying to get updates.txt...%[color,default]\n");
	    
	    try {
		File outfile = new File(tmpdir,"updates.txt");
		if (outfile.exists()) outfile.delete();
		SCFileDownloader.download(homeurl+"updates.txt",outfile,TIMEOUT);
		new SCUpdatesTxt(outfile);
	    }
	    catch (SCCannotDownloadException ex) {
		new File(tmpdir, "updates.txt").delete();
		session.doShioriEvent("OnUpdateFailure",new String[] {Integer.toString(ex.getRespCode())});
		stat.texttype_print("%[color,red]Couldn\'t download the updates.txt.%[color,default]");
		stat.closeWindow();
		SCFileUtils.deleteRecursively(tmpdir);
		postNotification("networkupdater","end");
		NSAutoreleasePool.pop(pool);
		return;
	    }
	    catch (Exception ex) {
		stat.texttype_print("%[color,red]Couldn\'t download the updates.txt.%[color,default]");
		stat.closeWindow();
		SCFileUtils.deleteRecursively(tmpdir);
		postNotification("networkupdater","end");
		NSAutoreleasePool.pop(pool);
		return;
	    }
	}
	
	// home/ghost/[ghostname]/ghost/master/updates2.dau΂ƔrB΁A
	// home/ghost/[ghostname]/ghost/master/updates.txt΂ƔrB
	final File local_updatestxt = new File(SCFoundation.getParentDirOfBundle(),session.getGhostPath()+"/ghost/master/updates.txt");
	final File local_dau = new File(SCFoundation.getParentDirOfBundle(),session.getGhostPath()+"/ghost/master/updates2.dau");
	final File remote_updatestxt = new File(tmpdir,"updates.txt");
	final File remote_dau = new File(tmpdir,"updates2.dau");
	File localdau,remotedau;
	if (remote_dau.exists()) { // [gupdates2.dauȂupdates2.dau[hɂȂB
	    localdau = local_dau;
	    remotedau = remote_dau;
	}
	else {
	    localdau = local_updatestxt;
	    remotedau = remote_updatestxt;
	}
	
	stat.texttype_println("local "+localdau.getName()+' '+(localdau.exists() ? "%[color,orange]exists%[color,default]" : "not exists"));
	if (localdau.exists() && remotedau.exists()) {
	    try {
		if (SCFileUtils.sameFiles(localdau,remotedau)) {
		    // XV
		    stat.texttype_println("%[color,white]There was not any updated files.%[color,default]");
		    stat.closeWindow();
		    session.doShioriEvent("OnUpdateComplete",new String[] {"none"});
		    SCFileUtils.deleteRecursively(tmpdir);
		    postNotification("networkupdater","end");
		    NSAutoreleasePool.pop(pool);
		    return;
		}
	    }
	    catch (Exception e) {
		stat.texttype_println("%[color,red]Error in comparing "+localdau.getName()+"...%[color,default]");
		stat.closeWindow();
		SCFileUtils.deleteRecursively(tmpdir);
		postNotification("networkupdater","end");
		NSAutoreleasePool.pop(pool);
		return;
	    }
	}
	
	/*
	  updates.txtႵupdates2.dauǂ݂Ȃt@C𗎂ƂĂB
	  [Jɓt@C邩ǂ𒲂ׁA
	  Õt@C΂MD5updates2.dauMD5rA
	  Ίɑ݂t@CȂ̂ŖAłȂ
	  ƂĂMD5`FbNsAsv΂ōXVfB
	  
	  ܂͎ۂɍXVׂt@C̃XgSCUpdatesLisť`ō쐬B
	  ܂XLbvׂڂeĂB
	*/
	stat.texttype_println("preparing to update...");
	
	SCUpdatesList dau;
	if (remotedau.getName().equals("updates.txt")) dau = new SCUpdatesTxt(remotedau);
	else dau = new SCUpdates2Dau(remotedau);
	
	final SCUpdatesList filesToUpdate = new SCUpdatesTxt(); // SCUpdatesList͒ۃNXȂ̂ŃCX^XȂB
	final int n_files = dau.size();
	for (int i = 0;i < n_files;i++) {
	    try {
		String filename = dau.getFile(i);
		String dau_md5 = dau.getMD5(i);
		
		File localfile = new File(ghostdir,DESTFILE_FILTER(filename));
		if (localfile.exists()) {
		    // [Jɓ̃t@C
		    String local_md5 = SCFileUtils.getMD5AsString(localfile);
		    if (local_md5.equals(dau_md5)) { // MD5v
			continue; // XLbv
		    }
		}
		
		filesToUpdate.addFile(filename,dau_md5);
	    }
	    catch (Exception e) {
		SCFileUtils.deleteRecursively(tmpdir);
		postNotification("networkupdater","end");
		NSAutoreleasePool.pop(pool);
		return;
	    }
	}
	
	
	final int n_filesToUpdate = filesToUpdate.size();
	final String n_filesToUpdate_as_string = Integer.toString(n_filesToUpdate); // SHIORIɓ`ׁB
	session.doShioriEvent("OnUpdateReady",new String[] {Integer.toString(n_filesToUpdate)});
	
	stat.texttype_print("%[color,white]"+n_filesToUpdate+" files%[color,orange] will be updated.%[color,default]\n");
	
	SCStatusWindowController prog_update = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	prog_update.setTypeToProgressBar();
	prog_update.show();
	prog_update.pbartype_setText1("Downloading...");
	
	for (int i = 0;i < n_filesToUpdate;i++) {
	    prog_update.pbartype_setText2("["+(i+1)+"/"+n_filesToUpdate+"] "+filesToUpdate.getFile(i));
	    prog_update.pbartype_setVal((double)i / (double)n_filesToUpdate);
	    
	    try {
		String filename = filesToUpdate.getFile(i);
		String dau_md5 = filesToUpdate.getMD5(i);
		
		File outfile = new File(tmpdir,filename);
		outfile.getParentFile().mkdirs();
		if (outfile.exists()) outfile.delete();
		
		// _E[h
		session.doShioriEvent("OnUpdate.OnDownloadBegin",new String[] {filename,Integer.toString(i+1),n_filesToUpdate_as_string});
		SCFileDownloader.download(homeurl+filename,outfile,TIMEOUT);
		
		// MD5r
		session.doShioriEvent("OnUpdate.OnMD5CompareBegin",new String[] {filename});
		String downloaded_md5 = SCFileUtils.getMD5AsString(outfile);
		if (dau_md5.equals(downloaded_md5)) {
		    // v
		    session.doShioriEvent("OnUpdate.OnMD5CompareComplete",new String[] {filename,dau_md5,downloaded_md5});
		}
		else {
		    // sv
		    session.doShioriEvent("OnUpdate.OnMD5CompareFailure",new String[] {filename,dau_md5,downloaded_md5});
		    session.doShioriEvent("OnUpdateFailure",new String[] {"md5 miss"});
		    prog_update.pbartype_setText1("MD5 mismatch");
		    prog_update.closeWindow();
		    stat.texttype_println("%[color,yellow]MD5 mismatch : "+filename+"%[color,default]");
		    stat.closeWindow();
		    SCFileUtils.deleteRecursively(tmpdir);
		    postNotification("networkupdater","end");
		    NSAutoreleasePool.pop(pool);
		    return;
		}
	    }
	    catch (InterruptedIOException e) { // ^CAEg
		session.doShioriEvent("OnUpdateFailure",new String[] {"timeout"});
		prog_update.pbartype_setText1("Timed Out.");
		prog_update.closeWindow();
		stat.texttype_print("%[color,yellow]Timed Out.%[color,default]\n");
		stat.closeWindow();
		SCFileUtils.deleteRecursively(tmpdir);
		postNotification("networkupdater","end");
		NSAutoreleasePool.pop(pool);
		return;
	    }
	    catch (SCCannotDownloadException e) { // _E[hs
		session.doShioriEvent("OnUpdateFailure",new String[] {Integer.toString(e.getRespCode())});
		prog_update.pbartype_setText1("["+e.getRespCode()+"]");
		prog_update.closeWindow();
		stat.texttype_print("The server returned %[color,yellow]"+e.getRespCode()+"%[color,default].\n");
		stat.closeWindow();
		SCFileUtils.deleteRecursively(tmpdir);
		postNotification("networkupdater","end");
		NSAutoreleasePool.pop(pool);
		return;
	    }
	    catch (Exception e) {
		prog_update.pbartype_setText1("Error!");
		prog_update.closeWindow();
		stat.texttype_print("%[color,red]Error in downloading.%[color,default]\n");
		stat.closeWindow();
		SCFileUtils.deleteRecursively(tmpdir);
		postNotification("networkupdater","end");
		NSAutoreleasePool.pop(pool);
		return;
	    }
	    
	    if (flagTerm) {
		prog_update.pbartype_setText1("Terminated.");
		prog_update.closeWindow();
		stat.texttype_print("%[color,yellow]Terminated.%[color,default]\n");
		stat.closeWindow();
		SCFileUtils.deleteRecursively(tmpdir);
		postNotification("networkupdater","end");
		NSAutoreleasePool.pop(pool);
		return;
	    }
	}
	prog_update.pbartype_setVal(1.0);
	prog_update.pbartype_setText1("Done.");
	prog_update.pbartype_setText2(null);
	prog_update.closeWindow();
	
	// ㏑ړ
	stat.texttype_print("updating files...\n");
	
	SCStatusWindowController prog_move = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	prog_move.setTypeToProgressBar();
	prog_move.show();
	prog_move.pbartype_setText1("Updating...");
	
	StringBuffer files_updated = new StringBuffer();
	for (int i = 0;i < n_files;i++) {
	    prog_move.pbartype_setVal((double)i / (double)n_files);
	    prog_move.pbartype_setText2(dau.getFile(i));
	    
	    File src = new File(tmpdir,dau.getFile(i));
	    File dest = new File(ghostdir,DESTFILE_FILTER(dau.getFile(i)));
	    if (!src.exists()) continue; // ۂɂ͍XVĂȂt@C̓_E[hĂȂB
	    
	    dest.getParentFile().mkdirs();
	    if (dest.exists()) dest.delete();
	    
	    src.renameTo(dest);
	    
	    files_updated.append(dau.getFile(i)+',');
	}
	if (files_updated.length() > 0) files_updated.deleteCharAt(files_updated.length()-1); // Ōɗ]ȃJ}tĂB
	prog_move.pbartype_setVal(1.0);
	prog_move.pbartype_setText1("Done.");
	prog_move.pbartype_setText2(null);
	prog_move.closeWindow();
	
	// updates.txtႵupdates2.dauړ
	File remoteDauDest = new File(ghostdir,"ghost/master/"+remotedau.getName());
	if (remoteDauDest.exists()) remoteDauDest.delete();
	remotedau.renameTo(remoteDauDest);
	stat.texttype_print("updated %[color,orange]ghost/master/"+remotedau.getName()+"%[color,default].\n");
	
	// delete.txtΓǂŎsB
	try {
	    File deltxt = new File(tmpdir,"delete.txt");
	    if (deltxt.exists()) deltxt.delete();
	    SCFileDownloader.download(homeurl+"delete.txt",deltxt,TIMEOUT);
	    
	    // ̖Ȃ_E[hꂽ
	    stat.texttype_print("%[color,yellow]delete.txt exists.%[color,default]");
	    SCDeletesList dlist = new SCDeletesList(deltxt);
	    final int n_dfiles = dlist.size();
	    
	    SCStatusWindowController prog_del = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	    prog_del.setTypeToProgressBar();
	    prog_del.show();
	    prog_del.pbartype_setText1("Deleting...");
	    for (int i = 0;i < n_dfiles;i++) {
		prog_del.pbartype_setVal((double)i / (double)n_dfiles);
		prog_del.pbartype_setText2(dlist.getFile(i));
		
		File fToDel = new File(ghostdir,dlist.getFile(i));
		if (fToDel.exists()) SCFileUtils.deleteRecursively(fToDel);
	    }
	    prog_del.pbartype_setVal(1.0);
	    prog_del.pbartype_setText1("Done.");
	    prog_del.pbartype_setText2(null);
	    prog_del.closeWindow();
	    stat.texttype_print("%[color,yellow]deleted "+n_dfiles+" files.%[color,default]\n");
	}
	catch (Exception e) {}
	
	// N[Abv
	stat.texttype_print("%[color,orange]Online Update succeeded.%[color,default]\n");
	session.doShioriEvent("OnUpdateComplete",new String[] {"changed",files_updated.toString()});
	
	// SHIORI/MAKOTÕ[h
	stat.texttype_print("%[color,orange]Reloading SHIORI/MAKOTO subsystems... ");
	session.getMasterSpirit().reloadAll();
	stat.texttype_print("%[color,white]Done.%[color,default]");
	stat.closeWindow();
	
	SCFileUtils.deleteRecursively(tmpdir);
	postNotification("networkupdater","end");
	NSAutoreleasePool.pop(pool);
    }
    
    public void terminate() {
	flagTerm = true;
	while (isAlive()) {}
    }
    
    private void postNotification(String name,String subinfo) {
	NSMutableDictionary userinfo = new NSMutableDictionary();
	userinfo.setObjectForKey(session,"session");
	NSNotificationCenter.defaultCenter().postNotification(name,subinfo,userinfo);
    }
    
    public static String DESTFILE_FILTER(String src) {
	if (src.startsWith("ghost/") || src.startsWith("shell/")) return src; // fʂ
	if (src.startsWith("surface/")) return "shell/master/"+src.substring(8);
	return "ghost/master/"+src;
    }
}
