/*
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import java.io.*;
import java.util.*;

public class SCNiseShiori
{
    public static String PLATFORM = "NiseRingo.app"; // %platform͂̒lgpB
    
    SCNSWordDictionary words;
    Vector array_sentences;
    // eGg̃XgłB
    
    SCNSDtx dtx;
    SCNSConditionEntries events;
    SCNSConditionEntries responces;
    SCNSConditionEntries teachentries;
    SCNSKeywordToWordChains keywordChains;
    SCNSResourceEntries resources;
    SCNSSystemVariables sysVars;
    SCNSJudgement judgement;
    SCNSConfig config;
    
    //----------- ȉ̏NOTIFYőĂ܂B------------//
    String ownerGhostName;
    Vector otherGhostNames; // g͌܂łȂStringB
    //------------------------------------------------------------//
    
    String ghostToSendMessage = null; // ꂪnullłȂɁA̖ÕS[XgɌĂт͕ԓ܂B
    int talkCount = 0; // g[NJE^
    String lastPastTime = null; // Ōɕωۂ̌oߎԁBnull͋N\B
    boolean inTeachNameSession = false; // ꂪtrue̊ԂɗTEACHNGXǵAuOoāvƉ߂܂B
    
    public SCNiseShiori(File ghost_dir)
    {
        File[] files = ghost_dir.listFiles();
        boolean found = false;
	
        words = new SCNSWordDictionary();
        array_sentences = new Vector();
		events = new SCNSConditionEntries(this);
		responces = new SCNSConditionEntries(this);
		teachentries = new SCNSConditionEntries(this);
		keywordChains = new SCNSKeywordToWordChains(this);
		resources = new SCNSResourceEntries();
		sysVars = new SCNSSystemVariables();
		dtx = new SCNSDtx();
		judgement = new SCNSJudgement(this);
		otherGhostNames = new Vector();
		
		config = new SCNSConfig(new File(ghost_dir,"nsconf.txt"));
		if (!config.exists("speech.frequency"))
		{
			config.put("speech.frequency",0);
			config.synchronize();
		}
		else if (config.getInt("speech.frequency") <= 3)
		{
			// CB
			switch (config.getInt("speech.frequency"))
			{
			case	1:
				config.put("speech.frequency",7 * 60);
				break;
			
			case	2:
				config.put("speech.frequency",3 * 60);
				break;
			
			case	3:
				config.put("speech.frequency",1 * 60);
				break;
			}
			config.synchronize();
		}
        
        // ai*.dtx
        for (int i = 0;i < files.length;i++)
        {
            String fname = files[i].getName();
            if (fname.startsWith("ai") && fname.endsWith("dtx"))
            {
                found = true;
                
                loadFile(files[i]);
            }
        }
        if (found) return; // dtxAB
        
        for (int i = 0;i < files.length;i++)
        {
            String fname = files[i].getName();
            if (fname.startsWith("ai") && fname.endsWith("txt"))
            {
                loadFile(files[i]);
            }
        }
    }
    
    public static boolean checkIfUsable(File ghost_dir)
    {
        // UxgĂ邩ǂ𒲂ׂ܂B
        
        // ܂ai*.dtxTAȂai*.txtT܂B
        // ai*.dtxłai*.txt͖܂BiUx̎dlj
        // ai*.txtƂĂUx̎Ƃ͌܂񂪁Ag`FbN͖̂ʓ|̂
        // ̂܂ܓǂݍł܂܂傤B
        
        File[] files = ghost_dir.listFiles();
		if (files == null) return false;
        boolean found = false;
        
        for (int i = 0;i < files.length;i++)
        {
            String fname = files[i].getName();
            if (fname.startsWith("ai") && fname.endsWith(".dtx"))
            {
                found = true;
                break;
            }
        }
        if (found) return true;
        
        
        // ܂Ȃ
        
        for (int i = 0;i < files.length;i++)
        {
            String fname = files[i].getName();
            if (fname.startsWith("ai") && fname.endsWith(".txt"))
            {
                found = true;
                break;
            }
        }
        return found;
    }
    
    /*private void loadFile(File file)
    {
        // f[^x[Xɓǂݍނׂdtxt@Ctxtt@CłB
		try{
			BufferedReader br = null;
			if (file.getName().endsWith("dtx"))
			{
			br = new BufferedReader(new InputStreamReader(dtx.decodeDtx(file)));
			}
			else
			{
			br = new BufferedReader(new InputStreamReader(new FileInputStream(file)));
			}
			
			// ǂݍ݊Jn
			StringBuffer oneline = new StringBuffer();
			boolean in_blockcomment = false;
			int line_counter = 0;
			String charset = "SJIS";
			while (true)
			{
			String line = br.readLine();
			if (line == null) break;
			line_counter++;
			
			if (line.length() == 0) continue;
			if (line_counter == 1 && line.startsWith("#Charset:"))
			{
				charset = line.substring(9).trim();
				continue;
			}
			if (line.charAt(0) == '#') continue;
			if (line.startsWith("//")) continue;
			if (line.startsWith("/*")) {in_blockcomment = true; continue;}*/
			//if (line.startsWith("*/")) {in_blockcomment = false; continue;}
			/*if (in_blockcomment) continue;
			
			line = convertBackslashToYen(new String(line.getBytes(),charset)); // obNXbVu & K؂ȃR[hɕϊ
			
			if (line.charAt(0) != ' ' && line.charAt(0) != '\t' && oneline.length() > 0) // O̍s̑łȂ
			{
				evaluateDictionaryLine(oneline.toString()); // flush
				oneline.setLength(0);
			}
			oneline.append(line.trim());
			}
			if (oneline.length() > 0) evaluateDictionaryLine(oneline.toString()); // flush
			br.close();
		}
		catch (Exception e){}
    }*/
    private void loadFile(File file)
    {
        // f[^x[Xɓǂݍނׂdtxt@Ctxtt@CłB
		try{
			InputStream is;
			if (file.getName().endsWith(".dtx"))
			{
				is = dtx.decodeDtx(file);
			}
			else
			{
				is = new FileInputStream(file);
			}
			BufferedReader br = new BufferedReader(new InputStreamReader(is,"SJIS"));
			String firstline = br.readLine();
			if (firstline == null) return;
			if (firstline.startsWith("#Charset:"))
			{
				String charset = firstline.substring(9).trim();
				
				br.close();
				InputStream is2;
				if (file.getName().endsWith(".dtx"))
				{
					is2 = dtx.decodeDtx(file);
				}
				else
				{
					is2 = new FileInputStream(file);
				}
				br = new BufferedReader(new InputStreamReader(is2,charset));
			}
			
			// ǂݍ݊Jn
			StringBuffer oneline = new StringBuffer();
			boolean in_blockcomment = false;
			while (true)
			{
				String line = (firstline != null ? firstline : br.readLine());
				firstline = null;
				if (line == null) break;
				
				if (line.length() == 0) continue;
				if (line.charAt(0) == '#') continue;
				if (line.startsWith("//")) continue;
				if (line.startsWith("/*")) {in_blockcomment = true; continue;}
				if (line.startsWith("*/")) {in_blockcomment = false; continue;}
				if (in_blockcomment) continue;
				
				line = convertBackslashToYen(line); // obNXbVu
				
				if (line.charAt(0) != ' ' && line.charAt(0) != '\t' && oneline.length() > 0) // O̍s̑łȂ
				{
					evaluateDictionaryLine(oneline.toString()); // flush
					oneline.setLength(0);
				}
				oneline.append(line.trim());
			}
			if (oneline.length() > 0) evaluateDictionaryLine(oneline.toString()); // flush
			br.close();
		}
		catch (Exception e){}
    }
    
    public static String convertBackslashToYen(String src)
    {
		// obNXbVɒu
		StringBuffer buf = new StringBuffer();
		final int len = src.length();
		for (int i = 0;i < len;i++)
		{
			char c = src.charAt(i);
			int n = (int)c;
			buf.append(c == 0x005c ? 0x00a5 : c);
		}
		return buf.toString();
    }
    
    private void evaluateDictionaryLine(String line)
    {
		int first_comma_pos = line.indexOf(',');
		if (first_comma_pos == -1) return;
		String type = line.substring(0,first_comma_pos).trim();
		
		if (type.startsWith("\u00a5m") || type.startsWith("\u00a5u") ||
			type.startsWith("\u00a5d") || type.startsWith("\u00a5k") ||
			type.startsWith("\u00a5dms") || type.startsWith("\u00a5["))
		{
			words.addEntriesWithLine(line);
		}
		else if (type.equals("\u00a5e"))
		{
			// ŏ̃J}܂ł폜
			line = line.substring(line.indexOf(',')+1).trim(); // J}Ő󔒂
			
			array_sentences.add(line); // o^
		}
		else if (type.equals("\u00a5ev")) // \re,\ev,\tc͍\B
		{
			// ŏ̃J}܂ł폜
			line = line.substring(line.indexOf(',')+1).trim(); // J}Ő󔒂
			
			String condition = line.substring(0,line.indexOf(',')).trim();
			String script = line.substring(line.indexOf(',')+1).trim();
			events.addEntry(condition,script);
		}
		else if (type.equals("\u00a5re"))
		{
			// ŏ̃J}܂ł폜
			line = line.substring(line.indexOf(',')+1).trim(); // J}Ő󔒂
			
			String condition = line.substring(0,line.indexOf(',')).trim();
			String script = line.substring(line.indexOf(',')+1).trim();
			responces.addEntry(condition,script);
		}
		else if (type.equals("\u00a5tc"))
		{
			// ŏ̃J}܂ł폜
			line = line.substring(line.indexOf(',')+1).trim(); // J}Ő󔒂
			
			String condition = line.substring(0,line.indexOf(',')).trim();
			String script = line.substring(line.indexOf(',')+1).trim();
			teachentries.addEntry(condition,script);
		}
		else if (type.equals("\u00a5id"))
		{
			// ŏ̃J}܂ł폜
			line = line.substring(line.indexOf(',')+1).trim(); // J}Ő󔒂
			
			String id = line.substring(0,line.indexOf(',')).trim();
			String value = line.substring(line.indexOf(',')+1).trim();
			resources.addEntry(id,value);
		}
		else if (type.equals("\u00a5ch"))
		{
			line = line.substring(line.indexOf(',')+1).trim(); // J}Ő󔒂
			
			// g[N̐4@@WordAndWord^Cv
			// ȊOiA3ȏŊj@@SentenceToWord^Cv
			StringTokenizer tokens = new StringTokenizer(line,",");
			final int n_tokens = tokens.countTokens();
			if (n_tokens == 4)
			{
				// 1,P1,2,P2
				String destination,word;
				String category1,category2,type1,type2;
				SCNSWord word1,word2;
				
				// ꂼp[X
				destination = tokens.nextToken().trim();
				word = tokens.nextToken().trim();
				category1 = SCNSWordDictionary.parseCategory(destination);
				type1 = SCNSWordDictionary.parseType(destination);
				if (category1 == null) category1 = "";
				if (type1 == null) type1 = "";
				word1 = new SCNSWord(category1,type1,word);
				
				destination = tokens.nextToken().trim();
				word = tokens.nextToken().trim();
				category2 = SCNSWordDictionary.parseCategory(destination);
				type2 = SCNSWordDictionary.parseType(destination);
				if (category2 == null) category2 = "";
				if (type2 == null) type2 = "";
				word2 = new SCNSWord(category1,type1,word);
				
				// ݂N
				word1.setChainTarget(word2);
				word2.setChainTarget(word1);
				
				// o^
				words.addWord(word1);
				words.addWord(word2);
			}
			else
			{
				Vector chain_elements = new Vector(); // content : (SCNSWord)P
				for (int i = 0;i < n_tokens-1;i += 2)
				{
					// p[X
					String destination = tokens.nextToken().trim();
					String word = tokens.nextToken().trim();
					
					String category = SCNSWordDictionary.parseCategory(destination);
					String wordtype = SCNSWordDictionary.parseType(destination);
					if (category == null) category = "";
					if (wordtype == null) wordtype = "";
					SCNSWord chain_element = new SCNSWord(category,wordtype,word);
					
					// ageP̌ɒǉ
					chain_elements.add(chain_element);
					
					// ʂɓo^
					words.addWord(chain_element);
				}
				String keyword = tokens.nextToken().trim();
				
				keywordChains.add(chain_elements,keyword);
			}
		}
	}
		
	public void terminate()
	{
		
	}
	
	public static String getModuleName()
	{
		return "\u507d\u681e"; // Ux
	}
	
	public String getaistringrandom()
	{
		int n_sentences = array_sentences.size();
		if (n_sentences <= 0)
		{
			return null;
		}
			
		int id = (int)((Math.random() * 10000) % n_sentences);
        return resolveRefs( (String)array_sentences.elementAt(id) );
    }
    
    private String resolveRefs(String sentence)
    {
        /*
            xuP̓v[ĂAɂxꂽ瓯PŒu܂B
            ɕtꍇ͂ꂼʂɃv[܂B
        */
		keywordChains.chainIfMatches(sentence); // KeywordToWord`FCs
        
        StringBuffer buf = new StringBuffer(sentence);
        Hashtable pool = new Hashtable(); // L[ms2,mz9,dms[ZZZ]3...@IuWFNgSCNSWordB
        
        int pos = 0;
        while (pos < buf.length())
        {
            if (buf.charAt(pos) != '%') {pos++; continue;}
            
            String category;
			String type;
            
            int index_pos; // %msȂpos+3,%dmsȂpos+4
			int tag_end_pos;
            if (buf.charAt(pos+1) == 'm' && "szlchtep".indexOf( buf.charAt(pos+2) ) != -1) // JeSwLA^Cvws
            {
                category = buf.substring(pos+1,pos+3);
		
				int blockstart = pos+3; // ʂ݂\̗Lꏊ
				if (blockstart < buf.length() && buf.charAt(blockstart) == '[') // ^CvwL
				{
					int blockend = buf.toString().indexOf(']',pos);
					type = buf.substring(blockstart+1,blockend);
					index_pos = blockend+1;
					tag_end_pos = blockend;
				}
				else
				{
					type = null; // ^Cvw聨S͈
					index_pos = pos+3;
					tag_end_pos = pos+2;
				}
            }
			else if (buf.charAt(pos+1) == 'd' || buf.charAt(pos+1) == 'k') // JeSwLA^Cvws
			{
				if (buf.toString().startsWith("%keroname",pos))
				{
					// %keroname͋Ă܂Ȃ悤ɔBFuckin'dlB
					pos++;
					continue;
				}
				
				category = buf.substring(pos+1,pos+2);
				
				int blockstart = pos+2; // ʂ݂\̗Lꏊ
				if (blockstart < buf.length() && buf.charAt(blockstart) == '[') // ^CvwL
				{
					int blockend = buf.toString().indexOf(']',pos);
					type = buf.substring(blockstart+1,blockend);
					index_pos = blockend+1;
					tag_end_pos = blockend;
				}
				else
				{
					type = null; // ^Cvw聨S͈
					index_pos = pos+2;
					tag_end_pos = pos+1;
				}
			}
			else if (buf.toString().startsWith("%[",pos)) // JeSw薳A^CvwL
			{
				category = "";
				
				int blockstart = pos+1;
				int blockend = buf.toString().indexOf(']',blockstart);
				type = buf.substring(blockstart+1,blockend); // []͊܂܂ȂB
				index_pos = blockend+1;
				tag_end_pos = blockend;
			}
            else if (buf.charAt(pos+1) == 'u' && buf.charAt(pos+2) >= 'a' && buf.charAt(pos+2) <= 'z') // %u[a-z]:obsolete
            {
				if (buf.toString().startsWith("%username",pos))
				{
					// %username͋Ă܂Ȃ悤ɔBFuckin'dlB
					pos++;
					continue;
				}
                category = buf.substring(pos+1,pos+3);
				type = ""; // ^Cv͏ɖ
                index_pos = pos+3;
				tag_end_pos = pos+2;
            }
            else if (buf.toString().startsWith("%dms",pos)) // JeSdms,^CvwsB
            {
                category = "dms";
		
				// 炭^Cv͕tȂƂɂȂĂƎvAÔ߁B
				int blockstart = pos+4;
				if (blockstart < buf.length() && buf.charAt(blockstart) == '[') // ^CvwL
				{
					int blockend = buf.toString().indexOf(']',pos);
					type = buf.substring(blockstart+1,blockend);
					index_pos = blockend+1;
					tag_end_pos = blockend;
				}
				else
				{
					type = null; // ^Cvw聨S͈
					index_pos = pos+4;
					tag_end_pos = pos+3;
				}
            }
			else if (buf.toString().startsWith("%rand",pos) && Character.isDigit(buf.charAt(pos+5)))
			{
				buf.replace(pos,pos+6,sysVars.get("rand"+buf.charAt(pos+5)));
				continue;
			}
			else if (buf.toString().startsWith("%ref",pos) && Character.isDigit(buf.charAt(pos+4)))
			{
				buf.replace(pos,pos+5,sysVars.get("ref"+buf.charAt(pos+4)));
				continue;
			}
			else if (buf.toString().startsWith("%sender",pos))
			{
				buf.replace(pos,pos+7,sysVars.get("sender"));
				continue;
			}
			else if (buf.toString().startsWith("%word",pos))
			{
				buf.replace(pos,pos+5,sysVars.get("word"));
				continue;
			}
            else
            {
                // Uxł͖`%^OB
                pos++;
                continue;
            }
	    
			String pool_entry;
            if (index_pos < buf.length())
			{
				char index_char = buf.charAt(index_pos);
				if (Character.isDigit(index_char))
				{
					pool_entry = (type == null ? category+index_char : category+'['+type+']'+index_char);
					tag_end_pos++;
				}
				else
				{
					pool_entry = (type == null ? category : category+'['+type+']');
				}
            }
            else
            {
                pool_entry = (type == null ? category : category+'['+type+']');
            }
            
			SCNSWord newword;
            // Ƃ肠v[̒TA炻ŒuB
            newword = (SCNSWord)pool.get(pool_entry);
            if (newword != null)
            {
                buf.replace(pos,tag_end_pos+1,newword.getWord());
                continue;
            }
            
            // v[ĂȂ̂Ń_ɑI
			newword = words.chooseOne(category,type);
            if (newword == null) // Ȃ
            {
                buf.delete(pos,tag_end_pos+1);
                continue;
            }
            buf.replace(pos,tag_end_pos+1,newword.getWord());
            
            // v[B
            pool.put(pool_entry,newword);
        }
        
        return buf.toString();
    }
    
    public String evaluateNiseShioriExtTag(String src)
    {
		// \ns_ce , \ns_st[] , \ns_jp[]]ʂԂ܂B
		//StringBuffer buf = new StringBuffer(convertBackslashToYen(src));
		StringBuffer buf = new StringBuffer(src);
		int pos = 0;
		while (pos < buf.length())
		{
			if (buf.charAt(pos) != '\u00a5')
			{
				pos++;
				continue;
			}
			else if (buf.toString().startsWith("\u00a5ns_jp",pos))
			{
				int blockstart = pos+6;
				int blockend = buf.toString().indexOf(']',pos);
				String arg = buf.substring(blockstart+1,blockend);
		
				// %jpentryɐݒ肵ăCxgXLB
				sysVars.put("jpentry",arg);
				Vector hitEvents = SCNSConditionEntries.pickupMaxPriority(events.findEntries("OnNSJumpEntry"));
				if (hitEvents.size() > 0)
				{
					int id = (int)((Math.random() * 10000) % hitEvents.size());
					String hit_script = ((SCNSConditionEntry)hitEvents.elementAt(id)).script();
					buf.replace(0,buf.length(),evaluateNiseShioriExtTag(hit_script)); // ċAďIB
					break;
				}
				else // qbgȂ
				{
					buf.delete(pos,blockend+1); // \ns_jp[]^O
				}
			}
			else if (buf.toString().startsWith("\u00a5ns_ce",pos))
			{
				ghostToSendMessage = null;
				buf.delete(pos,pos+6);
			}
			else if (buf.toString().startsWith("\u00a5ns_st[",pos))
			{
				try{
					int blockstart = pos+6;
					int blockend = buf.toString().indexOf(']',pos);
					int arg = Integer.parseInt(buf.substring(blockstart+1,blockend));
					// nsconf.txtɏ
					int seconds;
					switch (arg)
					{
						case	0:
							seconds = 0; // IɒȂ
							break;
							
						case	1:
							seconds = 7 * 60;
							break;
						
						case	2:
							seconds = 3 * 60;
							break;
						
						case	3:
							seconds = 1 * 60;
							break;
						
						default:
							seconds = arg; // ̂܂܂̕b
							break;
					}
					config.put("speech.frequency",seconds);
					config.synchronize();
					
					buf.delete(pos,blockend+1);
				}
				catch (Exception e) {pos++;}
			}
			else if (buf.toString().startsWith("\u00a5ns_tn",pos))
			{
				inTeachNameSession = true;
				buf.replace(pos,pos+6,"\\__t");
			}
			else if (buf.toString().startsWith("\u00a5ns_tc[",pos))
			{
				int blockstart = pos+6;
				int blockend = buf.toString().indexOf(']',pos);
				String arg = buf.substring(blockstart+1,blockend);
				
				if (arg.equals("name"))
				{
					// nsconf.txtɕۑB
					config.put("username",sysVars.get("word"));
					config.synchronize();
				}
		
				buf.delete(pos,blockend+1);
			}
			else
			{
				pos++;
				continue;
			}
		}
		return buf.toString();
	}
    
	public SCNSWordDictionary getWordDictionary()
	{
		return words;
	}

	public SCNSSystemVariables getSysVars()
	{
		return sysVars;
	}
    
    public SCNSJudgement getJudgement()
    {
		return judgement;
    }
    
    public String request(String req)
    {
		BufferedReader br = new BufferedReader(new StringReader(req));
		
		// ghostToSendMessageZbgB
		ghostToSendMessage = null;
		
		// ܂̓wb_ǂ
		String header = null;
		try{ header = br.readLine(); }catch (Exception e){}
		//System.out.println(header);
		
		// NOTIFY OtherGhostName͑ĂGgdĂBN\I
		if (header.startsWith("NOTIFY OtherGhostName"))
		{
			otherGhostNames.clear();
			
			String line = null;
			while (true)
			{
				try{ line = br.readLine(); }catch (Exception e){}
				if (line == null) break;
				//try{System.out.println(new String(line.getBytes("SJIS")));}catch(Exception e){}
				if (!line.startsWith("Ghost: ")) continue;
				
				otherGhostNames.add( line.substring(line.indexOf(':')+2) ); // R̎̃Xy[X͖
			}
	    
			try{ br.close(); }catch(IOException e){}
			return "SHIORI/2.3 204 No Content\r\n\r\n"; 
		}
		
		// NGXgŜǂ
		Hashtable hash = new Hashtable();
		String line = null;
		while (true)
		{
			try{ line = br.readLine(); }catch (Exception e){}
			if (line == null) break;
			if (line.indexOf(':') == -1) continue;
			
			String label = line.substring(0,line.indexOf(':'));
			String data = line.substring(line.indexOf(':')+2); // R̎̃Xy[X͖
	    
			hash.put(label,data);
		}
		
		try{ br.close(); }catch(IOException e){}
		
		// KvȃVXeϐZbg
		if (hash.get("Sender") != null)
		{
			sysVars.put("sender",(String)hash.get("Sender"));
		}
		
		// ߊJnB
		if (header.startsWith("GET Sentence"))
		{
			if (hash.get("Event") != null) // Cxgt
			{
				String event = (String)hash.get("Event");
				StringBuffer eventname = new StringBuffer(event);
				
				// Reference0 -> %ref0 o^
				final int numOfReferencesToSearch = 8;
				for (int i = 0;i < numOfReferencesToSearch;i++)
				{
					String data = (String)hash.get("Reference"+i);
					if (data == null) continue;
					
					sysVars.put("ref"+i,data);
					eventname.append('_'+data); // Ux̐݌v~X̂[EventName]_[Ref0]_[Ref1]̂悤ɂȂ΂ȂȂB
				}
				
				if (event.equals("OnSecondChange"))
				{
					// OnSecondChangeꍇAJE^g[N̑sB
					if (lastPastTime == null)
					{
						lastPastTime = (String)hash.get("Reference0");
					}
					
					if (!lastPastTime.equals((String)hash.get("Reference0")))
					{
						// CxgOnNSPastTimeChange𔭍s
						lastPastTime = (String)hash.get("Reference0");
						Vector hits = SCNSConditionEntries.pickupMaxPriority(events.findEntries("OnNSPastTimeChange"));
						if (hits.size() > 0)
						{
							int id = (int)((Math.random() * 10000) % hits.size());
							return generateResponce200( resolveRefs( ((SCNSConditionEntry)hits.elementAt(id)).script() ) , hash );
						}
					}
					else if (((String)hash.get("Reference1")).equals("1"))
					{
						// ؂ĂB
						// CxgOnNSMikireHappen𔭍s
						try
						{
							sysVars.put("mikire",Integer.toString(Integer.parseInt(sysVars.get("mikire")) + 1)); // %mikireCNg
						}catch(Exception e){}
						Vector hits = SCNSConditionEntries.pickupMaxPriority(events.findEntries("OnNSMikireHappen"));
						if (hits.size() > 0)
						{
							int id = (int)((Math.random() * 10000) % hits.size());
							return generateResponce200( resolveRefs( ((SCNSConditionEntry)hits.elementAt(id)).script() ) , hash );
						}
					}
					else if (((String)hash.get("Reference2")).equals("1"))
					{
						// dȂĂB
						// CxgOnNSKasanariHappen𔭍s
						try
						{
							sysVars.put("kasanari",Integer.toString(Integer.parseInt(sysVars.get("kasanari")) + 1)); // %kasanariCNg
						}catch(Exception e){}
						Vector hits = SCNSConditionEntries.pickupMaxPriority(events.findEntries("OnNSKasanariHappen"));
						if (hits.size() > 0)
						{
							int id = (int)((Math.random() * 10000) % hits.size());
							return generateResponce200( resolveRefs( ((SCNSConditionEntry)hits.elementAt(id)).script() ) , hash );
						}
					}
					else
					{
						if (!sysVars.get("mikire").equals("0")) // O܂Ō؂Ă
						{
							// CxgOnNSMikireSolve𔭍s
							sysVars.put("mikire","0");
							Vector hits = SCNSConditionEntries.pickupMaxPriority(events.findEntries("OnNSMikireSolve"));
							if (hits.size() > 0)
							{
								int id = (int)((Math.random() * 10000) % hits.size());
								return generateResponce200( resolveRefs( ((SCNSConditionEntry)hits.elementAt(id)).script() ) , hash );
							}
						}
						else if (!sysVars.get("kasanari").equals("0")) // O܂ŏdȂĂ
						{
							// CxgOnNSKasanariSolve𔭍s
							sysVars.put("kasanari","0");
							Vector hits = SCNSConditionEntries.pickupMaxPriority(events.findEntries("OnNSKasanariSolve"));
							if (hits.size() > 0)
							{
								int id = (int)((Math.random() * 10000) % hits.size());
								return generateResponce200( resolveRefs( ((SCNSConditionEntry)hits.elementAt(id)).script() ) , hash );
							}
						}
						else if (config.getInt("speech.frequency") > 0)
						{
							talkCount++;
							if (talkCount >= config.getInt("speech.frequency"))
							{
								talkCount = 0;
								
								// \eGggpmF40%
								// OnNSRandomTalkCxgsmF60%
								// OnNSRandomTalkCxg`Ώ\eGggpB
								// \eGgOnNSRandomTalkCxg`gpB
								Vector ev_randomtalk = SCNSConditionEntries.pickupMaxPriority(events.findEntries("OnNSRandomTalk"));
								int prob = (int)((Math.random() * 10000) % 100);
								if (prob >= 60)
								{
									if (ev_randomtalk.size() > 0)
									{
										int id = (int)((Math.random() * 10000) % ev_randomtalk.size());
										return generateResponce200( resolveRefs( ((SCNSConditionEntry)ev_randomtalk.elementAt(id)).script() ) , hash );
									}
								}
								String sentence = getaistringrandom();
								if (sentence == null)
								{
									int id = (int)((Math.random() * 10000) % ev_randomtalk.size());
									return generateResponce200( resolveRefs( ((SCNSConditionEntry)ev_randomtalk.elementAt(id)).script() ) , hash );
								}
								return (sentence != null ? generateResponce200(sentence,hash) : "SHIORI/2.0 204 No Content\r\n\r\n");
							}
						}
					}
					return "SHIORI/2.0 204 No Content\r\n\r\n";
				}
				else
				{
					Vector hitEvents = SCNSConditionEntries.pickupMaxPriority(events.findEntries(eventname.toString()));
					if (hitEvents.size() > 0)
					{
						int id = (int)((Math.random() * 10000) % hitEvents.size());
					
						return generateResponce200( resolveRefs( ((SCNSConditionEntry)hitEvents.elementAt(id)).script() ) , hash );
					}
					else // qbgȂ
					{
						return "SHIORI/2.0 204 No Content\r\n\r\n";
					}
				}
			}
			else if (hash.get("Sentence") != null) // ZeXt
			{
				// AgeghostToSendMessageSenderɃZbgBłȂnull̂܂܁B
				if (hash.get("Age") != null)
				{
					ghostToSendMessage = (String)hash.get("Sender");
				}
				
				Vector hitResponces = SCNSConditionEntries.pickupMaxPriority(responces.findEntries((String)hash.get("Sentence")));
				if (hitResponces.size() > 0) // ׂ
				{
					int id = (int)((Math.random() * 10000) % hitResponces.size());
					
					return generateResponce200( resolveRefs( ((SCNSConditionEntry)hitResponces.elementAt(id)).script() ) , hash );
				}
				else
				{
					// Ȃ̂ŁAƂ肠nohitŌB
					Vector nohitReEntries = responces.findEntries("nohit");
					if (nohitReEntries.size() > 0) // nohitڂ
					{
						int id = (int)((Math.random() * 10000) % nohitReEntries.size());
				
						return generateResponce200( resolveRefs( ((SCNSConditionEntry)nohitReEntries.elementAt(id)).script() ) , hash );
					}
					else
					{
						// nohitȂ̂204B
						return "SHIORI/2.0 204 No Content\r\n\r\n";
					}
				}
			}
			else // CxgZeX
			{
				String sentenceToReturn = getaistringrandom();
				return (sentenceToReturn == null ? "SHIORI/2.0 204 No Content\r\n\r\n" : generateResponce200(sentenceToReturn,hash));
			}
		}
		else if (header.startsWith("GET Word"))
		{
			String type = (String)hash.get("Type");
			String sentence = (String)hash.get("Sentence");
			if (type != null)
			{
				SCNSWord word = words.chooseOne(type.substring(1),null); // ^Cvw薳BRB
				return (word == null ? "SHIORI/2.0 204 No Content\r\n\r\n" : "SHIORI/2.0 200 OK\r\nWord: "+evaluateNiseShioriExtTag(word.getWord())+"\r\n\r\n");
			}
			else if (sentence != null)
			{
				// GET Word with SentencéÂƂ^ʖڂɏC͖B
				return "SHIORI/2.0 204 No Content\r\n\r\n";
			}
			else
			{
				return "SHIORI/2.3 400 Bad Request\r\n\r\n";
			}
		}
		else if (header.startsWith("GET String"))
		{
			String id = (String)hash.get("ID");
			if (id.equals("username"))
			{
				if (config.exists("username"))
				{
					return "SHIORI/2.0 200 OK\r\nString: "+config.getStr("username")+"\r\n\r\n";
				}
				else
				{
					return "SHIORI/2.0 204 No Content\r\n\r\n";
				}
			}
			else
			{
				Vector strings = resources.findEntries(id);
				if (strings == null)
				{
					return "SHIORI/2.0 204 No Content\r\n\r\n";
				}
				
				int n_strings = strings.size();
				int select = (int)((Math.random() * 10000) % n_strings);
				
				return "SHIORI/2.5 200 OK\r\nString: " + (String)strings.elementAt(select) + "\r\n\r\n";
			}
		}
		else if (header.startsWith("NOTIFY OwnerGhostName"))
		{
			ownerGhostName = (String)hash.get("Ghost");
			return "SHIORI/2.3 204 No Content\r\n\r\n";
		}
		else if (header.startsWith("TEACH"))
		{
			// Word -> %word o^
			sysVars.put("word",(String)hash.get("Word"));
			
			// Reference0 -> %ref0 o^
			for (int i = 0;;i++)
			{
				String data = (String)hash.get("Reference"+i);
				if (data == null) break;
				
				sysVars.put("ref"+i,data);
			}
			
			if (inTeachNameSession)
			{
				Vector hits = SCNSConditionEntries.pickupMaxPriority(teachentries.findEntries("name"));
				if (hits.size() == 0)
				{
					// o邱Ƃ͊o邪ȂB
					return "SHIORI/2.0 200 OK\r\nSentence: \\e\r\n\r\n";
				}
				else
				{
					int id = (int)((Math.random() * 10000) %  hits.size());
					return generateResponce200( resolveRefs( ((SCNSConditionEntry)hits.elementAt(id)).script() ) , hash );
				}
			}
			else
			{
				return "SHIORI/2.0 500 Internal Server Error\r\n\r\n"; // ŁB
			}
		}
		else
		{
			return "SHIORI/2.0 500 Internal Server Error\r\n\r\n";
		}
    }
    
    private String generateResponce200(String sentence,Hashtable requestTable)
    {
		// requestTable̓S[XgԃR~jP[g邽߁B
		talkCount = 0; // 点鎞ɂ̓g[NJE^̓ZbgB
		sentence = evaluateNiseShioriExtTag(sentence);
		if (requestTable.get("Age") != null) // Age
		{
			if (ghostToSendMessage == null) // \ns_cesꂽ̂ŉbI
			{
				return "SHIORI/2.0 200 OK\r\nSentence: "+sentence+"\r\n\r\n";
			}
			else
			{
				// 
				try
				{
					int oldAge = Integer.parseInt( (String)requestTable.get("Age") );
					
					StringBuffer resp = new StringBuffer("SHIORI/2.3 200 OK\r\n");
					resp.append("Sender: "+ownerGhostName+"\r\n");
					resp.append("To: "+(String)requestTable.get("Sender")+"\r\n");
					resp.append("Age: "+Integer.toString(oldAge+1)+"\r\n");
					resp.append("Sentence: "+sentence+"\r\n");
					resp.append("\r\n"); // X|XB
					return resp.toString();
				}
				catch (Exception e)
				{
					return "SHIORI/2.3 400 Bad Request\r\n\r\n";
				}
			}
		}
		else // Age
		{
			if (ghostToSendMessage != null) // VɃS[XgԃR~jP[VJn
			{
				StringBuffer resp = new StringBuffer("SHIORI/2.3 200 OK\r\n");
				resp.append("Sender: "+ownerGhostName+"\r\n");
				resp.append("To: "+ghostToSendMessage+"\r\n");
				resp.append("Age: 0\r\n");
				resp.append("Sentence: "+sentence+"\r\n");
				resp.append("\r\n"); // X|X
				return resp.toString();
			}
			else
			{
				return "SHIORI/2.0 200 OK\r\nSentence: "+sentence+"\r\n\r\n";
			}
		}
    }
}
