/*
	$Id: SCOldTypeConverter.java,v 1.4 2002/12/08 16:10:05 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;

public class SCOldTypeConverter
{
    private static final String[] SHELL_DESC_ENTRIES_TO_COPY_WHICH_STARTS_WITH =
	{
		"sakura.balloon",
		"sakura.bindgroup",
		"sakura.menuitem",
		"kero.balloon",
		"kero.bindgroup",
		"kero.menuitem"
	};
    private static final String[] SPIRIT_DESC_ENTRIES_TO_COPY_WHICH_STARTS_WITH =
	{
		"name",
		"sakura.name",
		"kero.name",
		"user.defaultname",
		"sstp.allowsakura",
		"shiori.logo",
		"icon",
		"cursor"
	};
    private static final String[] SPIRIT_CONVERT_EXCEPTIONS = // ]̃S[Xg̃[gghost/master/ɈړȂ
	{
		"ghost",
		"shell",
		"install.txt",
		"readme.txt",
		"profile.txt",
		"thumbnail.png"
	};
    
    public static void convertAll()
    {
		String bundleDir = SCFoundation.sharedFoundation().getParentDirOfBundle();
		
		// ghost
		File home_ghost = new File(bundleDir,"home/ghost");
		File[] ghosts = home_ghost.listFiles();
		for (int i = 0;i < ghosts.length;i++)
		{
			if (!ghosts[i].isDirectory()) continue;
			
			if (haveToConvertThis(ghosts[i]))
			{
				convertThis(ghosts[i]);
			}
		}
	
		// shell
		/*File home_shell = new File(bundleDir,"home/shell");
		File[] shells = home_shell.listFiles();
		for (int i = 0;i < shells.length;i++)
		{
			if (!shells[i].isDirectory()) continue;
			
			if (haveToConvertThis(shells[i]))
			{
				convertThis(shells[i]);
				
				// home/ghost/Ɉړ
				File dest = new File(home_ghost,shells[i].getName());
				shells[i].renameTo(dest);
			}
		}*/
	}
    
    private static boolean haveToConvertThis(File dir)
    {
		// ghost/master΋^CvƌȂB
		// descript.txtfalseԂĖB
		File ghost_master = new File(dir,"ghost/master");
		if (!ghost_master.exists())
		{
			File descript_txt = new File(dir,"descript.txt");
			if (!descript_txt.exists()) return false;
			else return true;
		}
		else
		{
			return false;
		}
    }
    
    private static void convertThis(File dir)
    {
		File ghostDescFile = new File(dir,"descript.txt");
		SCDescription ghostDesc = new SCDescription(ghostDescFile);
		
		// ܂̓VFB
		// shellfBNg쐬B
		File shellroot = new File(dir,"shell");
		shellroot.mkdir();
		
		String defaultSurfaceDirName;
		defaultSurfaceDirName = ghostDesc.getStrValue("seriko.defaultsurfacedirectoryname");
		if (defaultSurfaceDirName == null) defaultSurfaceDirName = "surface";
		
		File alias_txt = new File(dir,"alias.txt");
		File surfaceset_txt = new File(dir,"surface.txt");
		if (surfaceset_txt.exists()) // surface.txt
		{
			SCDescription setDefinition = new SCDescription(surfaceset_txt);
			Vector sets = setDefinition.getAllKeys();
			final int n_sets = sets.size();
			for (int i = 0;i < n_sets;i++)
			{
				String ssName = (String)sets.elementAt(i);
				String ssDirName = setDefinition.getStrValue(ssName);
				// seriko.defaultsurfacedirectorynameŒ`ꂽfBNgAsurfaceƖ̂fBNǵA
				// surface.txt̒`Ɋւ炸fBNgmasterƂB
				convertSurfaceDir(
					dir,shellroot,ghostDesc,alias_txt,ssName,
					ssDirName,(ssDirName.equals(defaultSurfaceDirName) ? "master" : ssDirName)
					);
			}
		}
		else // surface.txt
		{
			// shell/ɈڂׂT[tBXfBNg߂B
			// ghostDescseriko.defaultsurfacedirectoryname`Ă΂ɏ]A"surface"ߑłB
			
			convertSurfaceDir(dir,shellroot,ghostDesc,alias_txt,"master",defaultSurfaceDirName,"master");
		}
		// VF̃Ro[gB
		// alias.txt͂svȂ̂ŏB
		if (alias_txt.exists()) alias_txt.delete();
		
		// MASTER SPIRITB
		// ghost/masterfCNg쐬B
		File masterSpiritRoot = new File(dir,"ghost/master");
		masterSpiritRoot.mkdirs();
		// OXgɊYĂȂڂSghost/master/ɈړB
		File[] items = dir.listFiles();
		for (int i = 0;i < items.length;i++)
		{
			// OXgɓĂXLbvB
			boolean isInExceptionsList = false;
			for (int j = 0;j < SPIRIT_CONVERT_EXCEPTIONS.length;j++)
			{
				if (SPIRIT_CONVERT_EXCEPTIONS[j].equals(items[i].getName()))
				{
					isInExceptionsList = true;
					break;
				}
			}
			if (isInExceptionsList) continue;
			
			// ghost/master/ɈړB
			File dest = new File(masterSpiritRoot,items[i].getName());
			items[i].renameTo(dest);
		}
		// ghost/master/descript.txt쐬
		SCDescription masterSpiritDesc = new SCDescription();
		// type`
		masterSpiritDesc.setStrValue("type","ghost");
		// KvȃGgRs[
		for (int j = 0;j < SPIRIT_DESC_ENTRIES_TO_COPY_WHICH_STARTS_WITH.length;j++)
		{
			Vector entsToCopy = ghostDesc.getKeysStartsWith(SPIRIT_DESC_ENTRIES_TO_COPY_WHICH_STARTS_WITH[j]);
			final int n_entsToCopy = entsToCopy.size();
			for (int k = 0;k < n_entsToCopy;k++)
			{
				String key = (String)entsToCopy.elementAt(k);
				masterSpiritDesc.setStrValue(key,ghostDesc.getStrValue(key));
			}
		}
		// t@C쐬ĕۑ
		try{ masterSpiritDesc.save( new File(masterSpiritRoot,"descript.txt") ); }catch(Exception e){}
		
		// install.txtƓKwɂÂdescript.txt͍폜B
		ghostDescFile.delete(); 
    }
    
    private static void convertSurfaceDir(
	    File dir, // home/(ghost|shell)/[ghostname]
	    File shellroot, // home/(ghost|shell)/[ghostname]/shell
	    SCDescription ghostDesc,
	    File alias_txt,
	    String ssName, // ex: 3rd edition , master
	    String ssDirName, // ex: surface3 , surface
	    String ssDestDirName) // ex: surface3 , master
    {
		File src = new File(dir,ssDirName);
		File dest = new File(shellroot,ssDestDirName);
		src.renameTo(dest);
		
		// alias.txt΃Rs[
		if (alias_txt.exists())
		{
			File alias_dest = new File(dest,"alias.txt");
			try{ SCFileUtils.cp(alias_txt,alias_dest); }catch(Exception e){}
		}
		
		// descript.txt쐬
		SCDescription shellDesc = new SCDescription();
		// nametype`
		shellDesc.setStrValue("name",ssName);
		shellDesc.setStrValue("type","shell");
		// bindnGgballoonnGg݂΃Rs[
		for (int j = 0;j < SHELL_DESC_ENTRIES_TO_COPY_WHICH_STARTS_WITH.length;j++)
		{
			Vector entsToCopy = ghostDesc.getKeysStartsWith(SHELL_DESC_ENTRIES_TO_COPY_WHICH_STARTS_WITH[j]);
			final int n_entsToCopy = entsToCopy.size();
			for (int k = 0;k < n_entsToCopy;k++)
			{
				String key = (String)entsToCopy.elementAt(k);
				shellDesc.setStrValue(key,ghostDesc.getStrValue(key));
			}
		}
		// t@C쐬ĕۑ
		try{ shellDesc.save( new File(dest,"descript.txt") ); }catch(Exception e){}
	}
}
