/*  $Id: SCPlugin.java,v 1.4 2004/02/11 12:22:14 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.lang.reflect.*;
import java.io.*;

public class SCPlugin {
    Class plugin;
    String type;
    String name;
    File plugin_root;
    
    protected SCPlugin(
	Class plugin, String type, String name, File plugin_root) {
	this.plugin = plugin;
	this.type = type;
	this.name = name;
	this.plugin_root = plugin_root;
    }
    
    public static SCPlugin newInstance(Class pluginClass,File plugin_root) {
	// ^Cv擾
	String pluginType = null,pluginName = null;
	try {
	    Method getPluginType = pluginClass.getMethod("getPluginType",new Class[] {});
	    pluginType = (String)getPluginType.invoke(null,new Object[] {});
	    
	    Method getPluginName = pluginClass.getMethod("getPluginName",new Class[] {});
	    pluginName = (String)getPluginName.invoke(null,new Object[] {});
	}
	catch (NoSuchMethodException e) {
	    System.err.println("SCPlugin : Class "+pluginClass.getName()+" doesn\'t have some required method.");
	    e.printStackTrace();
	}
	catch (Exception e) {
	    System.err.println("SCPlugin : An exception has occured in accessing class "+pluginClass.getName()+".");
	    e.printStackTrace();
	}
	
	// ^CvɉăANZbT쐬
	if (pluginType.equals("hlsensor")) {
	    return new SCHLSensorPlugin(pluginClass,pluginType,pluginName,plugin_root);
	}
	else if (pluginType.equals("makoto")) {
	    // public static void notifyRootDir(File)ĂԁBΖŗǂB
	    try {
		Method notifyRootDir = pluginClass.getMethod("notifyRootDir",new Class[] {File.class});
		notifyRootDir.invoke(null,new Object[] {plugin_root});
	    }
	    catch (Exception e) {}
	    
	    // SCMakotoLoaderɃCXg[
	    SCMakotoLoader.instalMakotoModule(pluginClass);
	    return new SCPlugin(pluginClass,pluginType,pluginName,plugin_root);
	}
	else if (pluginType.equals("shiori")) {
	    // public static void notifyRootDir(File)ĂԁBΖŗǂB
	    try {
		Method notifyRootDir = pluginClass.getMethod("notifyRootDir",new Class[] {File.class});
		notifyRootDir.invoke(null,new Object[] {plugin_root});
	    }
	    catch (Exception e) {}

	    // public static void notifySaoriPath(String)ĂԁBΖŗǂB
	    try {
		String path = SCFoundation.getParentDirOfBundle()+"/home/saori";
		
		Method notifySaoriPath = pluginClass.getMethod("notifySaoriPath", new Class[] {String.class});
		notifySaoriPath.invoke(null, new Object[] {path});
	    }
	    catch (Exception e) {}
	    
	    // SCShioriLoaderɃCXg[
	    SCShioriLoader.installShioriModule(pluginClass);
	    return new SCPlugin(pluginClass,pluginType,pluginName,plugin_root);
	}
	else {
	    return new SCPlugin(pluginClass,pluginType,pluginName,plugin_root);
	}
    }
    
    public String getType() {
	return type;
    }
    
    public String getName() {
	return name;
    }
    
    public File getRootDir() {
	return plugin_root;
    }
    
    public String getDirName() {
	return plugin_root.getName();
    }
    
    public Class getPluginClass() {
	return plugin;
    }
}
