/*  $Id: SCSeriko.java,v 1.8 2005/04/28 19:10:28 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
    SCSeriko
    
    SERIKȎSĂ̓̊Ǘs܂B
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;
import util.*;

public class SCSeriko {
    private SCSerikoLibrary seriko_lib;
    private Hashtable current_group; // (Integer)scope => group(SCSerikoSeqGroup)
    private SCSerikoBindCenter bindCenter;
    private Vector runners; // SCSerikoSequenceRunner
    private boolean exclusive_locked = false; // option[exclusive]̃V[PX쒆̎trueBexecute\bh̃R[֎~܂B
    
    SCSession session;
    SCShell shell;
    
    public SCSeriko(SCSession session,SCShell shell,File shelldir) {
	this.session = session;
	this.shell = shell;
	
	seriko_lib = new SCSerikoLibrary(shell);
	current_group = new Hashtable();
	runners = new Vector();
	bindCenter = new SCSerikoBindCenter(session,shell,this);
	
	//dumpLibrary();
    }
    
    public void dumpLibrary() {
	seriko_lib.dump();
    }

    public void stop(int scope) {
	// ꎞ~B
	terminateAllRunnersThread(scope);
    }

    public void restart(int scope) {
	// ĊJB
	SCSerikoSeqGroup group = getCurrentSeqGroup(scope);
	if (group == null) {
	    return;
	}

	execute(group.makeSequenceArray("runonce"), scope);
	execute(group.makeSequenceArray("always"), scope);
	execute(group.makeSequenceArray("random"), scope);
    }

    public SCSerikoSeqGroup getCurrentSeqGroup(int scope) {
	return (SCSerikoSeqGroup)current_group.get(new Integer(scope));
    }
    
    public void surfaceChanged(int new_id, int scope) {
	// T[tBXςꂽɌĂ΂܂B
	// ܂ł̃Aj[VN[AbvAVȃV[PXO[v̏펞NnGgN܂B
	// T[tBXIDƃV[PXO[vID́ARłB
	
	// N[Abv
	stop(scope);
	bindCenter.disableAll();
	
	// JgO[vύX
	SCSerikoSeqGroup new_group = seriko_lib.findSeqGroup(new_id);
	if (new_group == null) {
	    current_group.remove(new Integer(scope));
	}
	else {
	    current_group.put(new Integer(scope), new_group);
	}

	restart(scope);
	bindCenter.enableCheckedBindGroups();
    }
    
    public void execute(Vector sequences, int scope) {
	int n_sequences = sequences.size();
	for (int i = 0;i < n_sequences;i++) {
	    SCSerikoSequence seq = (SCSerikoSequence)sequences.elementAt(i);
	    execute(seq.id(), scope);
	}
    }
    
    public void execute(int seqid, int scope) {
	// ݂̃O[v̎w肳ꂽV[PX𑖂点܂B
	// V[PX^Cvbindꍇł삵܂B
	if (SCFoundation.STOP_SERIKO) return;
	//if (isExclusiveLocked()) return;
	
	SCSerikoSeqGroup group = getCurrentSeqGroup(scope);
	if (group == null) return;
	SCSerikoSequence seq = group.findSequence(seqid);
	if (seq == null) return;
	
	// ɏIĂ郉i[̓Xg폜B
	synchronized (runners) {
	    int n_runners = runners.size();
	    for (int i = 0;i < n_runners;i++) {
		SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.elementAt(i);
		if (!runner.isAlive()) {
		    runners.removeElementAt(i);
		    n_runners--; // 1B
		    i--; // iςɂ܂[vB
		}
	    }
	}
	SCSerikoSequenceRunner runner = new SCSerikoSequenceRunner(
	    this, shell, seq, scope, session);
	runners.add(runner);
	runner.start();
    }
    
    public void terminateAllRunnersOverlay() {
	Vector pool = new Vector();
	synchronized (runners) {
	    int n_runners = runners.size();
	    for (int i = 0;i < n_runners;i++) {
		SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.get(i);
		pool.add(runner);
	    }
	}
	for (Iterator ite = pool.iterator(); ite.hasNext();) {
	    ((SCSerikoSequenceRunner)ite.next()).terminateOverlay();
	}
    }
    
    public void terminateAllRunnersOverlay(int scope) {
	Vector pool = new Vector();
	synchronized (runners) {
	    int n_runners = runners.size();
	    for (int i = 0;i < n_runners;i++) {
		SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.get(i);
		if (runner.getScope() == scope) {
		    pool.add(runner);
		}
	    }
	}
	for (Iterator ite = pool.iterator(); ite.hasNext();) {
	    ((SCSerikoSequenceRunner)ite.next()).terminateOverlay();
	}
    }

    public void interruptAllRunners(int scope) {
	Vector pool = new Vector();
	synchronized (runners) {
	    int n_runners = runners.size();
	    for (int i = 0;i < n_runners;i++) {
		SCSerikoSequenceRunner runner =
		    (SCSerikoSequenceRunner)runners.get(i);
		if (runner.getScope() == scope) {
		    pool.add(runner);
		}
	    }
	}
	for (Iterator ite = pool.iterator(); ite.hasNext();) {
	    ((SCSerikoSequenceRunner)ite.next()).interrupt();
	}
    }
    
    public void terminateAllRunnersThread() {
	Vector pool = new Vector();
	synchronized (runners) {
	    int n_runners = runners.size();
	    for (int i = 0;i < n_runners;i++) {
		SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.get(i);
		pool.add(runner);
	    }
	}
	for (Iterator ite = pool.iterator(); ite.hasNext();) {
	    ((SCSerikoSequenceRunner)ite.next()).terminateThread();
	}
    }
    
    public void terminateAllRunnersThread(int scope) {
	Vector pool = new Vector();
	synchronized (runners) {
	    int n_runners = runners.size();
	    for (int i = 0;i < n_runners;i++) {
		SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.elementAt(i);
		if (runner.getScope() == scope) {
		    pool.add(runner);
		}
	    }
	}
	for (Iterator ite = pool.iterator(); ite.hasNext();) {
	    ((SCSerikoSequenceRunner)ite.next()).terminateThread();
	}
    }
    
    public void terminateTargetRunner(int target_id, int scope) {
	Vector pool = new Vector();
	synchronized (runners) {
	    int n_runners = runners.size();
	    for (int i = 0;i < n_runners;i++) {
		SCSerikoSequenceRunner runner = (SCSerikoSequenceRunner)runners.elementAt(i);
		if (runner.getSeqID() == target_id && runner.getScope() == scope) {
		    pool.add(runner);
		}
	    }
	}
	for (Iterator ite = pool.iterator(); ite.hasNext();) {
	    ((SCSerikoSequenceRunner)ite.next()).terminateThread();
	}
    }
    
    public void setExclusiveLocked(boolean b) {
	exclusive_locked = b;
    }
    
    public boolean isExclusiveLocked() {
	return exclusive_locked;
    }
    
    public void terminate() {
	// SERIKOI܂B
	seriko_lib = null;
	current_group = null;
	bindCenter.terminate(); bindCenter = null;
	
	terminateAllRunnersOverlay();
	terminateAllRunnersThread();
	runners.clear();

	session = null;
	shell = null;
    }
    
    public SCSerikoBindCenter getBindCenter() {
	// ւj[݂ȂnullB
	return bindCenter;
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("session: {").append(session).append('}');
	buf.append("; shell: {").append(shell).append('}');
	if (runners.size() > 0) {
	    buf.append("; runners: [");
	    for (Iterator ite = runners.iterator(); ite.hasNext(); ) {
		buf.append('{').append(ite.next()).append('}');
		if (ite.hasNext()) {
		    buf.append(", ");
		}
	    }
	    buf.append(']');
	}
	if (exclusive_locked) {
	    buf.append("; exclusive locked");
	}
	return buf.toString();
    }

    protected void finalize() {
	//Logger.log(this, Logger.DEBUG, "finalized");
    }
}
