/*  $Id: SCSerikoBindCenter.java,v 1.10 2005/04/28 19:10:28 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2005 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;
import util.*;

/*
    SERIKO bind̑SĂ𑩂˂NXłB
    SCSerikoCX^XĂ܂B
*/

public class SCSerikoBindCenter {
    private SCSession session;
    private SCShell shell;
    private SCSeriko seriko;
    
    private boolean hasBindGroupSubMenu = false;
    private NSMenu bindGroupMenu; // ւf[^ȂꍇnullB
    private String bindGroupMenuTitle;
    
    private Hashtable sakura_bindgroups; // <Integer,SCSerikoBindCenter.Bindgroup> id,bindgroup
    private Hashtable kero_bindgroups; // <Integer,SCSerikoBindCenter.Bindgroup> id,bindgroup
    private Vector enabledGroups; // <SCSerikoEnabledBindGroup>
    
    public SCSerikoBindCenter(SCSession session,SCShell shell,SCSeriko seriko) {
	this.session = session;
	this.shell = shell;
	this.seriko = seriko;
	
	sakura_bindgroups = new Hashtable();
	kero_bindgroups = new Hashtable();
	enabledGroups = new Vector();
	
	// seriko.${shellDirName}.{sakura|kero}.bindgroupGg݂΂ɎgpbindgroupIDJ}؂ŕۑĂB
	NSDictionary ghostDefaults = SCGhostManager.sharedGhostManager().getGhostDefaults(session.getGhostPath());
	String shellDirName = shell.getDirName();
	Vector sakuraBindGroupsToEnable = SCMiscUtils.split((String)ghostDefaults.objectForKey("seriko."+shellDirName+".sakura.bindgroup"),",");
	Vector keroBindGroupsToEnable = SCMiscUtils.split((String)ghostDefaults.objectForKey("seriko."+shellDirName+".kero.bindgroup"),",");
	
	// bindgroupĂ璅ւj[쐬B
	SCDescription descm = shell.getDescManager();
	if (session.getMasterSpirit().getName() == null) return; // name݂ȂΒւ͏oȂB
	String shellName = descm.getStrValue("name");
	bindGroupMenuTitle = session.getMasterSpirit().getName() + (shellName == null ? "" : " - "+shellName);
	
	Vector sakura_bindgroup = descm.getKeysStartsWith("sakura.bindgroup");
	Vector kero_bindgroup = descm.getKeysStartsWith("kero.bindgroup");
	Vector sakura_menuitem = descm.getKeysStartsWith("sakura.menuitem");
	Vector kero_menuitem = descm.getKeysStartsWith("kero.menuitem");
	if (sakura_bindgroup.size() > 0 || kero_bindgroup.size() > 0) { // ւΉB
	    hasBindGroupSubMenu = true;
	    bindGroupMenu = SCMenuController.sharedMenuController().makeNewBindGroupSubMenu(bindGroupMenuTitle);
	    
	    String hontai_name = descm.getStrValue("sakura.name");
	    if (hontai_name == null) hontai_name = "[SAKURA]";
	    String unyuu_name = descm.getStrValue("kero.name");
	    if (unyuu_name == null) unyuu_name = "[KERO]";
	    
	    constructBindMenu(bindGroupMenu,descm,hontai_name,0,sakuraBindGroupsToEnable,sakura_bindgroup,sakura_menuitem,sakura_bindgroups);
	    constructBindMenu(bindGroupMenu,descm,unyuu_name,1,keroBindGroupsToEnable,kero_bindgroup,kero_menuitem,kero_bindgroups);
	}
    }
    
    protected void constructBindMenu(NSMenu bindGroupMenu,SCDescription descm,String name,int scope,Vector bindgroups_to_enable,Vector desc_bindgroups,Vector desc_menuitems,Hashtable bindgroups) {
	String sakura_or_kero = (scope == 0 ? "sakura" : "kero");
	
	int n_bindgroups = desc_bindgroups.size();
	if (n_bindgroups > 0) {
	    NSMenuItem mi = new NSMenuItem(name,null,""); // {̃x
	    mi.setEnabled(false);
	    bindGroupMenu.addItem(mi);
	}
	for (int i = 0;i < n_bindgroups;i++) {
	    String key = (String)desc_bindgroups.elementAt(i);
	    if (!key.endsWith(".name")) continue; // .nameGgłȂ΃XLbvB
	    
	    String bindgroup_data = descm.getStrValue(key);
	    // bindgroup_datǎ͎`B
	    //
	    // sakura.bindgroup0.name,,GvhX,apron
	    // 
	    // sakura.bindgroup0.name,,GvhX
	    //
	    // ̂Ƃ̓TlCiŌ̃p[^j͖܂̂ŗLĂĂ\܂B
	    int idblock_start = 16;
	    int idblock_end = key.indexOf('.',idblock_start);
	    int id = 0;
	    try{ id = Integer.parseInt(key.substring(idblock_start,idblock_end)); }catch(Exception e){}
	    
	    StringTokenizer st = new StringTokenizer(bindgroup_data,",");
	    String category = st.nextToken();
	    String bindname = st.nextToken();
	    String thumbnail_name = (st.hasMoreTokens() ? st.nextToken() : "");
	    bindgroups.put(new Integer(id),new Bindgroup(id,category,bindname,thumbnail_name));
	}
	final int n_menuitems = desc_menuitems.size();
	if (n_menuitems == 0) {
	    for (Enumeration e = bindgroups.elements(); e.hasMoreElements(); ) {
		Bindgroup bind = (Bindgroup)e.nextElement();
		
		NSMenuItem mitem = new NSMenuItem(bind.getCategory()+"  "+bind.getBindname(),new NSSelector("toggleBindGroup",new Class[] {NSMenuItem.class}),"");
		mitem.setTarget(this);
		mitem.setTag(scope == 0 ? bind.getId()+1 : (bind.getId()+1) * -1);
		mitem.setEnabled(true);
		
		if (bindgroups_to_enable == null) {
		    // sakura.bindgroup[id].default1`FbNԂɂB
		    mitem.setState(descm.getIntValue(sakura_or_kero+".bindgroup"+bind.getId()+".default") == 1 ? NSCell.OnState : NSCell.OffState);
		}
		else {
		    // idړɊ܂܂Ă`FbNԂɂB
		    mitem.setState(bindgroups_to_enable.contains(""+bind.getId()) ? NSCell.OnState : NSCell.OffState);
		}
		
		bindGroupMenu.addItem(mitem);
	    }
	}
	else {
	    for (int i = 0; i < n_menuitems; i++) {
		for (int j = 0; j < n_menuitems; j++) {
		    String key = (String)desc_menuitems.elementAt(j);
		    if (key.equals(sakura_or_kero+".menuitem"+i)) {
			String value = (String)descm.getStrValue(key);
			if (value.indexOf("-") != -1) {
			    // Zp[^
			    bindGroupMenu.addItem((NSMenuItem)NSMenuItem.protocolSeparatorItem());
			}
			else {
			    try {
				int bind_id = Integer.parseInt(value);
				Bindgroup bind = (Bindgroup)bindgroups.get(new Integer(bind_id));
				
				NSMenuItem mitem = new NSMenuItem(bind.getCategory()+"  "+bind.getBindname(),new NSSelector("toggleBindGroup",new Class[] {NSMenuItem.class}),"");
				mitem.setTarget(this);
				mitem.setTag(scope == 0 ? bind.getId()+1 : (bind.getId()+1) * -1);
				mitem.setEnabled(true);
				
				if (bindgroups_to_enable == null) {
				    // sakura.bindgroup[id].default1`FbNԂɂB
				    mitem.setState(descm.getIntValue(sakura_or_kero+".bindgroup"+bind.getId()+".default") == 1 ? NSCell.OnState : NSCell.OffState);
				}
				else {
				    // idړɊ܂܂Ă`FbNԂɂB
				    mitem.setState(bindgroups_to_enable.contains(""+bind.getId()) ? NSCell.OnState : NSCell.OffState);
				}
				
				bindGroupMenu.addItem(mitem);
			    } catch (Exception e) {}
			}
		    }
		}
	    }
	}
    }
    
    public void enableCheckedBindGroups() {
	// j[Ń`FbN}[NtĂbind𗧂グ܂B
	// ւΉłȂꍇ͖܂B
	if (bindGroupMenu == null) return;
	
	NSArray items = bindGroupMenu.itemArray();
	int n_items = items.count();
	for (int i = 0;i < n_items;i++) {
	    NSMenuItem mi = (NSMenuItem)items.objectAtIndex(i);
	    if (mi.state() != NSCell.OnState) continue;
	    int tag = mi.tag();
	    
	    if (tag > 0) { // {
		enable(tag - 1, 0);
	    }
	    else { // ɂイ
		enable((-1 * tag) - 1, 1);
	    }
	}
    }
    
    public void toggleBindGroup(NSMenuItem sender) {
	// j[ActionƂČĂ΂܂B
	int tag = sender.tag();
	
	if (sender.state() == NSCell.OffState) {
	    // ON
	    sender.setState(NSCell.OnState);
	    if (tag > 0) { // {
		enable(tag - 1, 0);
	    }
	    else { // ɂイ
		enable((-1 * tag) - 1, 1);
	    }
	}
	else {
	    // OFF
	    sender.setState(NSCell.OffState);
	    if (tag > 0) { // {
		disable(tag - 1, 0);
	    }
	    else { // ɂイ
		disable((-1 * tag) - 1, 1);
	    }
	}
    }
    
    private void enable(int seqid, int scope) {
	if (scope != 0 && scope != 1) {
	    throw new RuntimeException(
		"seriko-bind-center does not support that scope: "+scope);
	}
	
	// JeSɑ鑼bindgroup͑SdisableB
	Hashtable bindgroups = (scope == 0 ? sakura_bindgroups : kero_bindgroups);
	Bindgroup bindgroup = (Bindgroup)bindgroups.get(new Integer(seqid));
	
	for (int i = 0; i < enabledGroups.size(); i++) {
	    SCSerikoEnabledBindGroup group = (SCSerikoEnabledBindGroup)enabledGroups.elementAt(i);
	    
	    if (group.getScope() == scope) {
		Bindgroup group_info = (Bindgroup)bindgroups.get(new Integer(group.seqid()));
		if (group_info.getCategory().equals(bindgroup.getCategory())) {
		    // JeSɑĂBdisableB
		    bindGroupMenu
			.itemWithTag((group.seqid()+1) * (scope == 0 ? 1 : -1))
			.setState(NSCell.OffState);
		    group.disable();
		    enabledGroups.remove(i);
		    i--;
		}
	    }
	}
	
	enabledGroups.add(
	    new SCSerikoEnabledBindGroup(
		session, shell, seriko, seqid, scope));
    }
    
    private void disable(int seqid, int scope) {
	int n_groups = enabledGroups.size();
	for (int i = 0;i < n_groups;i++) {
	    SCSerikoEnabledBindGroup group =
		(SCSerikoEnabledBindGroup)enabledGroups.elementAt(i);
	    
	    if (group.seqid() == seqid && group.getScope() == scope) {
		group.disable();
		enabledGroups.removeElementAt(i);
		break;
	    }
	}
    }
    
    public void disableAll() {
	int n_groups = enabledGroups.size();
	for (int i = 0;i < n_groups;i++) {
	    SCSerikoEnabledBindGroup group =
		(SCSerikoEnabledBindGroup)enabledGroups.elementAt(i);
	    group.disable();
	}
	enabledGroups.clear();
    }
    
    public void terminate() {
	// SERIKOI鎞ɓǂŉB
	// oChZ^[N[Abv܂B
	
	// Ԃۑ
	StringBuffer sakura_bindgroup = new StringBuffer();
	StringBuffer kero_bindgroup = new StringBuffer();
	final int n_groups = enabledGroups.size();
	for (int i = 0;i < n_groups;i++) {
	    SCSerikoEnabledBindGroup group =
		(SCSerikoEnabledBindGroup)enabledGroups.elementAt(i);
	    StringBuffer target =
		(group.getScope() == 0 ? sakura_bindgroup : kero_bindgroup);
	    target.append(Integer.toString(group.seqid()));
	    target.append(',');
	}
	if (sakura_bindgroup.length() > 0) {
	    // ŌɕtʂȃJ}
	    sakura_bindgroup.setLength(sakura_bindgroup.length()-1);
	}
	if (kero_bindgroup.length() > 0) {
	    kero_bindgroup.setLength(kero_bindgroup.length()-1);
	}
	
	NSMutableDictionary ghostDefaults =
	    SCGhostManager.sharedGhostManager().getGhostDefaults(
		session.getGhostPath());
	String shellDirName = shell.getDirName();
	
	String entryname;
	entryname = "seriko."+shellDirName+".sakura.bindgroup";
	if (sakura_bindgroup.length() == 0) {
	    ghostDefaults.removeObjectForKey(entryname);
	}
	else {
	    ghostDefaults.setObjectForKey(
		sakura_bindgroup.toString(), entryname);
	}
	
	entryname = "seriko."+shellDirName+".kero.bindgroup";
	if (kero_bindgroup.length() == 0) {
	    ghostDefaults.removeObjectForKey(entryname);
	}
	else {
	    ghostDefaults.setObjectForKey(
		kero_bindgroup.toString(), entryname);
	}
	
	SCGhostManager.sharedGhostManager().setGhostDefaults(session.getGhostPath(),ghostDefaults);
	
	// N[Abv
	disableAll();
	if (hasBindGroupSubMenu) {
	    SCMenuController.sharedMenuController().removeBindGroupSubMenu(bindGroupMenuTitle);
	}
	session = null;
	shell = null;
	seriko = null;
	bindGroupMenu = null;
	sakura_bindgroups.clear();
	kero_bindgroups.clear();
	enabledGroups.clear();
    }
    
    public NSMenu getBindMenu() {
	return bindGroupMenu;
    }

    protected void finalize() {
	Logger.log(this, Logger.DEBUG, "finalized");
    }
    
    class Bindgroup {
	int id;
	String category;
	String bindname;
	String thumbnail_name;
	
	public Bindgroup(int id,String category,String bindname,String thumbnail_name) {
	    this.id = id;
	    this.category = category;
	    this.bindname = bindname;
	    this.thumbnail_name = thumbnail_name;
	}
	
	public int getId() { return id; }
	public String getCategory() { return category; }
	public String getBindname() { return bindname; }
	public String getThumbnail_name() { return thumbnail_name; }
    }
}
