/*
    $Id: SCSerikoSeqGroup.java,v 1.5 2004/01/30 06:30:31 phonohawk Exp $
    ----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
    SCSerikoSeqGroup
    
    IDɊ܂܂SẴV[PXf[^Ǘ܂B
    ܂surface[id]a.txtt@C̈̃NXɑΉ܂B
*/

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;
import java.util.regex.*;

public class SCSerikoSeqGroup {
    Vector sequences; // gSCSerikoSequence
    int seqGroupId;
    
    public SCSerikoSeqGroup(File f,int seqGroupId) {
	// f : *a.txt
	sequences = new Vector();
	this.seqGroupId = seqGroupId;
	if (!f.exists() || f.isDirectory()) return; // 肦ȂǁB
	
	try {
	    BufferedReader br = null;
	    br = new BufferedReader(new InputStreamReader(new FileInputStream(f),"SJIS"));
	    
	    Vector definitions = new Vector();
	    while(true) {
		String line = br.readLine();
		
		if (line == null) break; // EOF
		if (line.length() == 0) continue;
		if (!Character.isDigit(line.charAt(0))) continue; // Ŏn܂Ȃs̓XLbvB
		
		definitions.add(line);
	    }
	    load(0, definitions); // *a.txt椂񂾏ꍇ͏pSERIKOB
	    
	    br.close();
	}
	catch(Exception e) {
	    throw new RuntimeException(
		"Load failed: "+f.getName(), e);
	}
    }
    
    public void dump() {
	System.out.println("*************");
	System.out.println("SequenceGroup ID : "+seqGroupId);
	final int n_sequences = sequences.size();
	for (int i = 0;i < n_sequences;i++) {
	    SCSerikoSequence seq = (SCSerikoSequence)sequences.elementAt(i);
	    seq.dump();
	}
	System.out.println("");
    }
    
    public SCSerikoSeqGroup(int version, Vector definitions, int seqGroupId) {
	// definitions : <String>V[PX`s̏W
	// V[PX`łȂڂ܂܂Ă琳B
	sequences = new Vector();
	this.seqGroupId = seqGroupId;
		
	Vector valid_defs = new Vector();
	final int n_defs = definitions.size();
	for (int i = 0;i < n_defs;i++) {
	    String def = (String)definitions.elementAt(i);

	    if (version == 0) {
		// lŎn܂Ă΃V[PX`sƌ􂷁B
		if (Character.isDigit(def.charAt(0))) {
		    valid_defs.add(def);
		}
	    }
	    else {
		// animationŎn܂Ă΃V[PX`sƌ􂷁B
		if (def.startsWith("animation")) {
		    valid_defs.add(def);
		}
	    }
	}

	load(version, valid_defs);
    }

    static final Pattern pat_seqid = Pattern.compile("^animation(\\d+)\\.");
    protected void load(int version, Vector definitions) {
	// definitions : <String>V[PX`s̏W
	final int n_lines = definitions.size();
	for (int i = 0;i < n_lines;i++) {
	    String line = (String)definitions.elementAt(i);

	    if (version == 0) {
		// V[PXIDoB
		// 擪琔A̓V[PXIDłB
		int seq_id_length = 0;
		while (Character.isDigit(line.charAt(seq_id_length))) seq_id_length++;
		
		int seqId = -1;
		try{ seqId = Integer.parseInt(line.substring(0,seq_id_length)); }catch(Exception e){}
		
		// V[PXIDɑΉSCSerikoSequenceɊi[B
		SCSerikoSequence seq = findSequence(seqId,true); // ߂ČV[PXIDȂVɍ쐬B
		seq.add(version, line.substring(seq_id_length));
	    }
	    else {
		// V[PXIDoB
		Matcher matcher = pat_seqid.matcher(line);
		if (matcher.find()) {
		    try {
			int seqId = Integer.parseInt(matcher.group(1));

			// V[PXIDɑΉSCSerikoSequenceɊi[B
			SCSerikoSequence seq = findSequence(seqId,true); // ߂ČV[PXIDȂVɍ쐬B
			seq.add(version, line.substring(matcher.end()));
		    }
		    catch (Exception e) {
			System.err.println("Warning: invalid sequence ["+line+"]");
			e.printStackTrace();
		    }
		}
	    }
	}
    }
    
    public int groupId() {
	return seqGroupId;
    }
    
    public SCSerikoSequence findSequence(int seqid) {
	// V[PXIDSCSerikoSequenceԂ܂B
	// ȂnullԂ܂B
	return findSequence(seqid,false);
    }
    
    private SCSerikoSequence findSequence(int seqid,boolean makenew) {
	// V[PXIDSCSerikoSequenceA
	// ȂmakenewtrueȂVɍ쐬ăXgɒǉĂԂA
	// falseȂnullԂ܂B
	int n_sequences = sequences.size();
	for (int i = 0;i < n_sequences;i++) {
	    SCSerikoSequence seq = (SCSerikoSequence)sequences.elementAt(i);
	    if (seq.id() == seqid) return seq;
	}
	
	// Not Found
	if (makenew) {
	    SCSerikoSequence new_seq = new SCSerikoSequence(seqid);
	    sequences.add(new_seq);
	    return new_seq;
	}
	else {
	    return null;
	}
    }
    
    public Vector makeSequenceArray(String interval) {
	// w肳ꂽinterval^CvSẴV[PXiSCSerikoSequenceNXjԂ͍lɕׂVector쐬ĕԂ܂B
	// runoncebindŎg܂B
	Vector result = new Vector();
		
	int n_sequences = sequences.size();
	for (int i = 0;i < n_sequences;i++) {
	    SCSerikoSequence seq = (SCSerikoSequence)sequences.elementAt(i);
	    try {
		if (seq.interval().type().equals(interval)) {
		    result.add(seq);
		}
	    } catch (Exception e) {
		// ̂ȎNB
		e.printStackTrace();
	    }
	}
	
	return result;
    }
}
