/*  $Id: SCSession.java,v 1.33 2006/03/12 06:30:05 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2005 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;
import java.net.*;
import util.*;

public class SCSession extends Thread {
    //public static final int MAX_QUEUE_SIZE = 20;
    
    public static final int UNAVAILABLE = 1;
    // f[^̃[h̗RŁAꎞIɃZbVɃANZXłȂԂ\܂B
    
    public static final int CLOSED = 2;
    // ZbVɕꂽԂ\܂B̏Ԃł̓ANZXĂ͂܂B
    
    public static final int AVAILABLE = 3;
    // ZbVNŁAÕANZXĂԂ\܂B
    
    volatile boolean flagClosing = false; // trueȂZbV悤ƂĂ܂B
    
    SCShell currentShell;
    SCSpirit masterSpirit;
    //Vector slaveSpirits; // gSCSpiritB
    
    SCBalloonSkinServer balserver;
    Hashtable shells; // (Integer)scope => (SCShellWindowController)shell
    Hashtable balloons; // (Integer)scope => (SCSafetyBalloonController)balloon
    SCScriptRunner scrrunner;
    SCScriptServer tmpScriptServer; // SSTP̑IpBi[xI閈sweepAway()܂B
    SCCommunicateBoxController comBox;
    SCVanishWindowController vanishDialog;
    SCShellContextMenuMaker shellContextMenuMaker;
    SCMenuAppearanceServer menuAppearance;
    SCShellChangingSession lastShellChangingSession; // ŌɋNꂽVFύXZbVB
    SCNetworkUpdater lastNetworkUpdater; // ŌɋNꂽlbg[NAbvf[^B
    SCTeachSession lastTeachSession; // ŌɋNꂽTeachZbVB
    SCInputBoxSession lastInputBoxSession; // ŌɋNꂽINPUTZbVB
    SCSessionCloser closer; // ꂪNďIɂ̓ZbVB
	
    private Vector queue; // SHIORItH[h|[g̃L[BgStringB
    
    String currentSelfName;
    String currentKeroName;
    
    File ghost_dir;
    String ghost_path;
    File readmeFile;

    private int status = UNAVAILABLE;
    private long boottime;
    private boolean passive_mode = false;
    
    final boolean light_mode; // Cg[hŋNǂB
    final boolean special_shell_mode; // VFw胂[h(Cg[hp)ŋNB
    
    public SCSession(String ghost_path, String balloon_path) {
	this(ghost_path, null, balloon_path, false);
    }
    public SCSession(
	String ghost_path, String balloon_path, boolean light_mode) {
	this(ghost_path, null, balloon_path, light_mode);
    }
    public SCSession(
	String ghost_path, String shelldir_name,
	String balloon_path, boolean light_mode) {
	// ghost_path : home/ghost/[ghostname]
	// shelldir_name: shell/̃fBNgBnullȂݒ肳ꂽVFgB
	// light_mode : trueȂ烉Cg[hŋNB
	
	long boot_begin_time = System.currentTimeMillis();
	this.light_mode = light_mode;

	if (shelldir_name != null) {
	    // VFw̓Cg[hpB
	    if (light_mode) {
		special_shell_mode = true;
	    }
	    else {
		Logger.log(
		    this, Logger.WARN,
		    "Special shell-dir was specified in constructor while light-mode is disabled. "+
		    "shell-dir will be ignored.");
		shelldir_name = null;
		special_shell_mode = false;
	    }
	}
	else {
	    special_shell_mode = false;
	}
	
	SCStatusWindowController stat = null;
	if (!SCFoundation.isHereMainThread() && !light_mode) {
	    stat = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	    stat.setTypeToText();
	    stat.show();
	    stat.texttype_print("%[color,yellow]Materializing ghost...%[color,default]\n");
	}
	
	boottime = System.currentTimeMillis();
        this.ghost_path = ghost_path;
	ghost_dir = new File(SCFoundation.getParentDirOfBundle(),ghost_path);
        
        NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
	NSDictionary ghostDefaults = SCGhostManager.sharedGhostManager().getGhostDefaults(ghost_path);
	
	readmeFile = new File(ghost_dir,"readme.txt");
	
        // master spirit N
	masterSpirit = new SCSpirit(this,"master",stat);

        // \0\1p̃EChE쐬
	shells = new Hashtable();
	openShell(0);
	openShell(1);

	// shell N
	currentShell = new SCShell(
	    this,
	    shelldir_name != null ? shelldir_name : getShellDirName(),
	    stat);
	currentShell.start();
        
        // ʒu
	getShell(0).setHorizLoc(getHorizontalLocationOfShell(currentShell.getDirName(), 0));
	getShell(1).setHorizLoc(getHorizontalLocationOfShell(currentShell.getDirName(), 1));
	
	// o[T[o[N
        balserver = SCFoundation.sharedFoundation().getBalloonServer(balloon_path,stat);
        
        // o[
	balloons = new Hashtable();
	openBalloon(0);
	openBalloon(1);
	
	// o[x
	double balloon_transparency = defaults.doubleForKey("display_slider_transparency"); // `Ȃ[̂܂܁B
	getBalloon(0).setTransparency(balloon_transparency);
	getBalloon(1).setTransparency(balloon_transparency);
	
	// o[tF[hAEg
	if (defaults.objectForKey("display.balloon.fadeout") == null) {
	    getBalloon(0).setDoesFadeOut(true); // ftHgŃtF[hAEgs
	    getBalloon(1).setDoesFadeOut(true);
	}
	else {
	    boolean bool = (defaults.integerForKey("display.balloon.fadeout") == 1);
	    getBalloon(0).setDoesFadeOut(bool);
	    getBalloon(1).setDoesFadeOut(bool);
	}
        
        // ʒu
        recalcBalloonsLoc();
        
        // x
        int level = defaults.integerForKey("display_levelselect");
        // Gg݂Ȃ0Ԃ遨NSWindow.NormalWindowLevel0łB
        getShell(0).setLevel(level);
        getShell(1).setLevel(level);
        getBalloon(0).setLevel(level);
        getBalloon(1).setLevel(level);
        
        // tHg
        String fontname = (String)defaults.objectForKey("display_fontname");
        float fontsize = defaults.floatForKey("display_fontsize");
        if (fontname == null) fontname = "Osaka";
        if (fontsize == 0) fontsize = 9.0f;
        getBalloon(0).requestChangeFont(NSFont.fontWithNameAndSize(fontname,fontsize));
        getBalloon(1).requestChangeFont(NSFont.fontWithNameAndSize(fontname,fontsize));
        
	// ꎞXNvg(SSTP/1.2p)
	tmpScriptServer = new SCScriptServer();
	
	if (!light_mode) {
	    // COMMUNICATE BOX [h
	    comBox = new SCCommunicateBoxController(this);
	    
	    // SHIORIJ[lNOTIFY OwnerGhostName𑗐M
	    // ̎_ł͂܂FORWARD PORTNĂȂ̂forwardĂ͂ȂB
	    if (masterSpirit.getShioriProtocolVersion() == 2) {
		masterSpirit.doShioriSession(
		    "NOTIFY OwnerGhostName SHIORI/2.3\r\nSender: "+
		    SCFoundation.STRING_FOR_SENDER+"\r\nGhost: "+
		    masterSpirit.getSelfName()+"\r\n\r\n");
	    }
	    
	    // ReNXgj[ Look&Feel
	    menuAppearance = new SCMenuAppearanceServer(this);
	    
	    // ReNXgj[
	    shellContextMenuMaker = new SCShellContextMenuMaker(this);
	}
	
	long elapsed_time_to_materialize = System.currentTimeMillis() - boot_begin_time;
	if (stat != null) {
	    stat.texttype_print(
		"%[color,orange]ghost \"%[color,white]"+
		masterSpirit.getName()+
		"%[color,orange]\" materialized.\n");
	    stat.texttype_print(
		"%[color,orange]"+
		(elapsed_time_to_materialize / 1000.0)+
		" sec elapsed.");
	    stat.closeWindow();
	}
	else {
	    Logger.log(
		this, Logger.NOTICE,
		(elapsed_time_to_materialize / 1000.0)+
		" sec elapsed to materialize.");
	}
	
	queue = new Vector();
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("path: ").append(ghost_path);

	buf.append("; status: ");
	if (status == UNAVAILABLE) {
	    buf.append("unavailable");
	}
	else if (status == CLOSED) {
	    buf.append("closed");
	}
	else if (status == AVAILABLE) {
	    buf.append("available");
	}
	else {
	    buf.append("*unknown*");
	}
	
	buf.append("; uptime: ").append(
	    System.currentTimeMillis() - boottime).append("ms");

	if (flagClosing) {
	    buf.append("; closing");
	}
	if (passive_mode) {
	    buf.append("; passive");
	}
	if (light_mode) {
	    buf.append("; light");
	}
	if (special_shell_mode) {
	    buf.append("; special-shell");
	}
	
	return buf.toString();
    }

    protected void finalize() {
	Logger.log(this, Logger.DEBUG, "finalized");
    }
    
    private volatile boolean flagTerm = false;
    public void run() {
	int pool = NSAutoreleasePool.push();
	
	status = AVAILABLE;
	
	while (!flagTerm) {
	    if (queue.size() > 0) {
		String req = (String)queue.elementAt(0); // 擪oB
		queue.removeElementAt(0);

		int inner_pool = NSAutoreleasePool.push();
		shioriResponceWork(masterSpirit.doShioriSession(req));
		NSAutoreleasePool.pop(inner_pool);
	    }
	    else {
		if (flagTerm) break;
		
		try {
		    sleep(30 * 1000); // KBL[ɃvbVinterrupt()鎖B
		} catch (InterruptedException e) {
		    if (flagTerm) break;
		}
	    }
	}
	
	NSAutoreleasePool.pop(pool);
    }
    public void forwardToShioriKernel(String request) {
	// SHIORI/2.xNGXg̃ZbVɃtHA[h܂B
	// ʂ͕Ԃ܂B

	//if (queue.size() < MAX_QUEUE_SIZE) {
	//if (scrrunner == null ||
	//    !scrrunner.isAlive() ||
	//    scrrunner.interruptAllowed()) {
	    // NeBJZbV̓L[ɗ߂ȂB
	    queue.add(request);
	    //    System.out.println("QUEUE: "+queue.size());
	    //}
	interrupt();
    }
    public void clearQueue() {
	queue.clear();
	//System.out.println("QUEUE CLEARED");
    }

    public SCShellWindowController openShell(int scope) {
	SCShellWindowController swc = new SCShellWindowController(this, scope);
	if (scope != 0) {
	    // \0̐ݒRs[
	    SCShellWindowController src = getShell(0);
	    swc.setLevel(src.getLevel());
	}

	shells.put(new Integer(scope), swc);
	
	if (currentShell != null) {
	    swc.setHorizLoc(
		getHorizontalLocationOfShell(currentShell.getDirName(), scope));
	}
	return swc;
    }

    public SCSafetyBalloonController openBalloon(int scope) {
	SCSafetyBalloonController sbc = new SCSafetyBalloonController(this, scope);
	sbc.setBalloonServer(balserver);
	if (scope != 0) {
	    // \0po[̐ݒRs[
	    SCSafetyBalloonController src = getBalloon(0);
	    sbc.setTransparency(src.getTransparency());
	    sbc.setDoesFadeOut(src.getDoesFadeOut());
	    sbc.setLevel(src.getLevel());
	    sbc.requestChangeFont(src.getFont());
	}

	balloons.put(new Integer(scope), sbc);

	getShell(scope).setBalloon(sbc);

	return sbc;
    }
    
    public final boolean isLightMode() {
	return light_mode;
    }
    
    public final boolean isInPassiveMode() {
	return passive_mode;
    }
    
    public void setPassiveMode(boolean bool) {
	passive_mode = bool;
	
	if (passive_mode) {
	    comBox.close(); // COMMUNICATE BOX
	    if (lastTeachSession != null && lastTeachSession.isAlive()) {
		lastTeachSession.terminate(); // TEACHZbVNȂ狭I
	    }
	}
		
	NSMutableDictionary userinfo = new NSMutableDictionary();
	userinfo.setObjectForKey(this,"session");
	NSNotificationCenter.defaultCenter().postNotification(
	    "passivemode", passive_mode ? "enter" : "leave", userinfo);
    }
    
    public int hoursFromBootTime() {
	// ZbVNĂ̌oߎԂԂ܂B
	return (int)Math.round((double)(System.currentTimeMillis() - boottime) / (1000.0 * 60.0 * 60.0));
    }
    
    public void changeSurface(int id, int scope) {
	SCShellWindowController iwc = getShell(scope);
	
	iwc.changeSurface(currentShell.getSurfaceServer(),id);
	currentShell.getSeriko().surfaceChanged(id, scope);

	doShioriEvent(
	"OnSurfaceChange", new String[] {
		Integer.toString(getShell(0).currentSurfaceId()),
		Integer.toString(getShell(1).currentSurfaceId())});
	}
    
    public void changeShell() {
	// JgVFύX܂B
	// ݒdefaultsǂݍ݂܂B

	if (special_shell_mode) {
	    // VFŒB
	    return;
	}
	
	// ݃VFύXZbVNȂ牽ɏIB
	if (lastShellChangingSession != null && lastShellChangingSession.isAlive()) return;

	lastShellChangingSession = new SCShellChangingSession(this);
	lastShellChangingSession.start();
    }
    
    public void changeShell(SCShell newShell) {
	// JgVFύX܂B
	// ̃\bhSHIORIɃCxg𑗐MɃJgVFύX݂̂łB
	// ۂɕύXɂchangeShell()gpĂB
	if (status != AVAILABLE) return;
	
	status = UNAVAILABLE;
	currentShell.close();
	currentShell = newShell;
	currentShell.start();
	status = AVAILABLE;

	double scale = SCGhostManager.sharedGhostManager().
	    getScaleOfGhost(ghost_path);
	resizeShell(scale);
    }
    
    public void doNetworkUpdate() {
	if (status != AVAILABLE) return;
	if (lastNetworkUpdater != null && lastNetworkUpdater.isAlive()) return;
		
	lastNetworkUpdater = new SCNetworkUpdater(this);
	lastNetworkUpdater.start();
    }
    
    public Object getGhostDefaults(String entry) {
	// plist̃S[Xgdefaultsf[^擾܂B
	// ȂnullԂ܂B
	NSMutableDictionary defaults =
	    SCGhostManager.sharedGhostManager().getGhostDefaults(ghost_path);
	return defaults.objectForKey(entry);
    }
    
    public void setGhostDefaults(String entry,Object obj) {
	// plist̃S[XgdefaultsɃf[^ݒ肵܂B
	NSMutableDictionary defaults =
	    SCGhostManager.sharedGhostManager().getGhostDefaults(ghost_path);
	defaults.setObjectForKey(obj,entry);
	SCGhostManager.sharedGhostManager().setGhostDefaults(ghost_path,defaults);
    }
    
    public void doFirstBootEvent() {
	// OnFirstBootCxg𔭍s܂B
	NSMutableDictionary defaults = SCGhostManager.sharedGhostManager().getGhostDefaults(ghost_path);
	Object vanish_count = defaults.objectForKey("vanish_count");
	if (vanish_count instanceof Integer) {
	    doShioriEvent("OnFirstBoot",new String[] {Integer.toString(vanish_count == null ? 0 : ((Integer)vanish_count).intValue())});
	}
	else {
	    doShioriEvent("OnFirstBoot",new String[] {Long.toString(vanish_count == null ? 0 : ((Long)vanish_count).longValue())});
	}
    }
    
    public void mouseEventOccuredOnShell(String type,String x,String y,String wheel,String owner,String collision) {
	// SCShellWindowpB

	//if (type.equals("OnMouseDoubleClick")) {
	    // _uNbNȂL[NAB
	    //clearQueue();
	//}
	
	if (SCFoundation.sharedFoundation().isThisInVanishEvent(this) && type.equals("OnMouseDoubleClick")) {
	    // ~߂B
	    SCFoundation.sharedFoundation().holdVanishSession();
	    clearQueue();
	    forceTerminateScriptRunnder();
	    
	    doShioriEvent("OnVanishButtonHold");
	}
	else {
	    doShioriEvent(type,new String[] {x,y,wheel,owner,collision});
	}
    }
    
    public boolean hasBootedBefore() {
	// ̃S[XgߋɈxłNƂLtrueԂ܂B
	String flag = (String)getGhostDefaults("has_booted_before");
	return (flag != null && flag.equals("true"));
    }
    
    public void doTeach() {
	if (status != AVAILABLE) return;
	if (isInPassiveMode()) return;
	if (lastTeachSession != null && lastTeachSession.isAlive()) return;
	
	lastTeachSession = new SCTeachSession(this);
	lastTeachSession.start();
    }
    
    public void startInputBoxSession(String symbol,int timeout) {
	if (status != AVAILABLE) return;
	if (isInPassiveMode()) return;
	if (lastInputBoxSession != null && lastInputBoxSession.isAlive()) return;
	
	lastInputBoxSession = new SCInputBoxSession(this,symbol,timeout);
	lastInputBoxSession.start();
    }
    
    public void doHLSensing(SCHLSensorPlugin plugin) {
	SCHeadlineSession s = new SCHeadlineSession(this,plugin);
	s.start();
    }
    
    public void openVanishDialog() {
	if (status != AVAILABLE) return;
	if (vanishDialog != null && vanishDialog.window().isVisible()) return;
	
	if (vanishDialog == null) {
	    vanishDialog = new SCVanishWindowController(this);
	}
	vanishDialog.show();
    }
    
    public synchronized SCScriptRunner runScript(String script,boolean useMakoto) {
	return runScript(script,null,useMakoto);
    }
    public synchronized SCScriptRunner runScript(String script,Hashtable options,boolean useMakoto) {
	// ܂SHIORIŃgX[g܂B
        // useMakotofalseȂ炻̂܂܁AłȂmakotołgX[g܂B
        // i[NŃC^vgĂȂnullԂ܂B
	// AvP[VBĂԂł͏ɒ܂B
	if (script == null || script.length() == 0) return null;
	if (NSApplication.sharedApplication().isHidden()) return null;
	String s = masterSpirit.translateWithShiori(script);
        if (useMakoto) s = masterSpirit.translateWithMakoto(s);
	
        if (scrrunner == null || !scrrunner.isAlive()) {
            scrrunner = new SCScriptRunner(this,s,options);
            scrrunner.start();
            return scrrunner;
        }
        else if (scrrunner.interruptAllowed()) {
            scrrunner.terminate();
            
            scrrunner = new SCScriptRunner(this,s,options);
            scrrunner.start();
            return scrrunner;
        }
        else
        {
            return null;
        }
    }
    
    public void forceTerminateScriptRunnder() {
	// XNvgi[sɁA^CNeBJZbVɓĂ悤
	// I낤ƁAIterminate()s܂B
	if (scrrunner != null && scrrunner.isAlive()) {
	    scrrunner.terminate();
	}
    }
    
    public void doShioriRandomTalk() {
	if (masterSpirit.getShioriProtocolVersion() == 2) {
	    forwardToShioriKernel(
		"GET Sentence SHIORI/2.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\n\r\n");
	}
    }
    
    public void doShioriEvent(String eventType) {
	doShioriEvent(eventType,null);
    }
    
    public void doShioriEvent(String eventType,String[] references) {
	// SHIORIɃCxg𑗂܂B
	if (SCFoundation.LOCK_SHIORI_EVENTS) return;
	if (status != AVAILABLE) return;
	if (masterSpirit.getShiori() == null) return; // SHIORINĂȂΉȂB
	
	// ܂̓NGXg쐬B
	StringBuffer sb = new StringBuffer();
	if (masterSpirit.getShioriProtocolVersion() == 2) {
	    sb.append("GET Sentence SHIORI/2.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\n");
	    sb.append("SecurityLevel: local\r\n");
	    sb.append("Event: "+eventType+"\r\n");
	}
	else {
	    sb.append("GET SHIORI/3.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\n");
	    sb.append("ID: "+eventType+"\r\n");
	}
	
	if (references != null) {
	    for (int i = 0;i < references.length;i++) {
		sb.append("Reference"+i+": "+references[i]+"\r\n");
	    }
	}
	sb.append("\r\n"); // NGXgB
	
	forwardToShioriKernel(sb.toString());
    }
    
    public void doShioriCommunicateFromUser(String message) {
	// SHIORISender: UserSentencetGET Sentence𑗂܂B
	if (masterSpirit.getShioriProtocolVersion() == 2) {
	    forwardToShioriKernel(
		"GET Sentence SHIORI/2.0\r\nSender: User\r\nSentence: "+message+"\r\n\r\n");
	}
	else {
	    forwardToShioriKernel(
		"GET SHIORI/3.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+
		"\r\nID: OnCommunicate\r\nReference0: User\r\nReference1: "+message+"\r\n\r\n");
	}
    }
    
    public void shioriResponceWork(SCShioriSessionResponce resp) {
	shioriResponceWork(resp,true);
    }
    
    public void shioriResponceWork(SCShioriSessionResponce resp,boolean wait) {
	// ̃\bh̓ZbVSHIORI FORWARD PORT,SCShellChangingSessionSCTeachSessionĂяo܂B
	// ăCXbh璼ڌĂł͂܂B
	
	// ̃\bh̓i[A
	// 1) wait == trueȂDONEɂȂ܂ŁA
	// 2) wait == falseȂSCRIPT_ENDɂȂ0.5bo߂܂ŃubN܂B
	if (status != AVAILABLE) return;
	if (resp == null) return;
	if (masterSpirit.getShiori() == null || resp == null) return;
	if (resp.getHeader().indexOf("200 OK") == -1 &&
	    resp.getHeader().indexOf("311 Not Enough") == -1 &&
	    resp.getHeader().indexOf("312 Advice") == -1) return;
	
	String script = (resp.getHeader().startsWith("SHIORI/2.") ? resp.getRespForKey("Sentence") : resp.getRespForKey("Value"));
	SCScriptRunner runner = runScript(script,true);
	if (runner == null) return;

	//if (!runner.interruptAllowed()) {
	    // C^vg֎~ȃXNvgł΁AI܂ő҂B
	    
	    while (runner.isAlive() && // i[񂾂eɊp[v߁B
		   runner.getStatus() != SCScriptRunner.DONE &&
		   runner.getStatus() != SCScriptRunner.TERMINATED) {
		try {
		    sleep((long)0.25 * 1000); // l̈buɃXe[^XB
		}
		catch (InterruptedException e) {
		    if (flagTerm) break;
		}
	    }
	    //}
	
	if (runner.getStatus() == SCScriptRunner.TERMINATED) {
	    // i[Iꂽ҂ɔB
	    return;
	}
	
	if (!wait) {
	    // 0.5bҋ@BłȂƑI߂B
	    try {
		sleep(500);
	    }
	    catch (Exception e){}
	}
	
	String to,age,sender;
	if (resp.getHeader().startsWith("SHIORI/2.")) {
	    // b鑤2.x
	    to = resp.getRespForKey("To");
	    age = resp.getRespForKey("Age");
	    sender = resp.getRespForKey("Sender");
	}
	else {
	    to = resp.getRespForKey("Reference0"); // bdl炵B
	    age = null;
	    sender = masterSpirit.getSelfName();
	}
	
	if (to != null) {
	    SCSession destSession = SCFoundation.sharedFoundation().getSession(to,false); // toZbVTĂ݂B
	    if (destSession != null && destSession != this) {
		// 瑗MBgȂ疳B
		StringBuffer buf = new StringBuffer();
		if (destSession.getMasterSpirit().getShioriProtocolVersion() == 2) {
		    // b|鑤2.x
		    buf.append("GET Sentence SHIORI/2.3\r\n");
		    buf.append("Sender: "+sender+"\r\n");
		    buf.append("Age: "+age+"\r\n");
		    buf.append("Surface: "+getShell(0).baseSurfaceId()+","+getShell(1).baseSurfaceId()+"\r\n");
		    buf.append("Sentence: "+script+"\r\n");
		    for (int i = 0;i <= 7;i++) {
			// Reference
			String ref = resp.getRespForKey("Reference"+i);
			if (ref != null) buf.append("Reference"+i+": "+ref+"\r\n");
		    }
		    buf.append("\r\n"); // NGXg
		}
		else {
		    // b|鑤3.0
		    buf.append("GET SHIORI/3.0\r\n");
		    buf.append("Sender: "+SCFoundation.STRING_FOR_SENDER+"\r\n");
		    buf.append("ID: OnCommunicate\r\n");
		    buf.append("Reference0: "+sender+"\r\n");
		    buf.append("Reference1: "+script+"\r\n");
		    buf.append("\r\n");
		}
		destSession.forwardToShioriKernel(buf.toString()); // MZbVɃNGXg𓊂B
	    }
	}
    }
    
    public String getWordFromShiori(String type) {
	// typeɎw肷̂́ms,mž`B
	// ̓obNXbVł͂ȂA\u00a5Ŏw肵ĉB
	// 炩̗RŒPꂪ擾oȂnullԂ܂B
	if (masterSpirit.getShioriProtocolVersion() != 2) return null; // SHIORI/3.0ł͔p~ꂽB
	
	SCShioriSessionResponce resp = masterSpirit.doShioriSession(
	    "GET Word SHIORI/2.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nType: "+type+"\r\n\r\n");
	if (resp == null) return null;
	if (resp.getHeader().indexOf("200 OK") == -1) return null;
	
	return (String)resp.getResponce().get("Word");
    }
    
    public final String getStringFromShiori(String id) {
	// SHIORIGET String𔭍s܂B
	// 擾ɎsnullԂ܂B
	return masterSpirit.getStringFromShiori(id);
    }
    
    public final void resetSurfaces() {
	changeSurface(0, 0);
	changeSurface(10, 1);
    }
    
    public void hideBalloons() {
	for (Iterator ite = getShellIterator(); ite.hasNext(); ) {
	    ((SCSafetyBalloonController)ite.next()).hide();
	}
    }
    
    public void showCommunicateBox() {
	if (isInPassiveMode()) {
	    return;
	}
	comBox.show();
    }
    
    public void setStatusClosing() {
	// SCSessionChanger,SCSessionVanisherȊO͌ČĂł͂Ȃ܂B
	
	/*
	  {͂ȂƂSCSessionChangerZbVɂ邱Ƃo邪A
	  SCSessionChanger͏L҂łZbVIĂ܂΂肩
	  ̃ZbVNƂŝŁAZbVɂ邱Ƃ͕sKłB
	  ȂSCSessionChangerNotification𔭍sƂ邪Aobserver̓o^/ʓ|łB
	*/
	flagClosing = true;
		
	// N
	if (!hasBootedBefore()) {
	    setGhostDefaults("has_booted_before","true");
	}
    }
    
    public void clearStatusClosing() {
	// SCSessionChanger,SCSessionVanisherȊO͌ČĂł͂Ȃ܂B
	// friend class~B
	flagClosing = false;
    }
    
    public final boolean isStatusClosing() {
	return flagClosing;
    }
    
    public void performClose() {
	// OnClose𔭍sĒIĂZbV܂B
	if (closer != null && closer.isAlive()) return;
	
	// N
	if (!hasBootedBefore()) {
	    setGhostDefaults("has_booted_before","true");
	}
	
	flagClosing = true;
	closer = new SCSessionCloser(this);
	closer.start();
    }
    
    public void close() {
        // J[lIđSẴEChE܂B
	if (status == CLOSED) return;
	status = CLOSED;
	
	flagTerm = true; interrupt(); while(isAlive()) {}
	masterSpirit.close(); masterSpirit = null;
	currentShell.close(); currentShell = null;
	balserver = null;
	if (scrrunner != null && scrrunner.isAlive()) {
	    scrrunner.terminate();
	}
	scrrunner = null;
	tmpScriptServer = null;
	if (comBox != null) {
	    comBox.close();
	}
	comBox = null;
	if (vanishDialog != null) {
	    vanishDialog.close();
	    vanishDialog = null;
	}
	menuAppearance = null;
	if (lastShellChangingSession != null && lastShellChangingSession.isAlive()) {
	    lastShellChangingSession.terminate();
	}
	lastShellChangingSession = null;
	if (lastNetworkUpdater != null && lastNetworkUpdater.isAlive()) {
	    lastNetworkUpdater.terminate();
	}
	lastNetworkUpdater = null;
	if (lastTeachSession != null && lastTeachSession.isAlive()) {
	    lastTeachSession.terminate();
	}
	lastTeachSession = null;
	if (lastInputBoxSession != null && lastInputBoxSession.isAlive()) {
	    lastInputBoxSession.terminate();
	}
	lastInputBoxSession = null;
	for (Iterator ite = getShellIterator(); ite.hasNext(); ) {
	    ((SCShellWindowController)ite.next()).close();
	}
	shells = null;
	for (Iterator ite = getBalloonIterator(); ite.hasNext(); ) {
	    ((SCSafetyBalloonController)ite.next()).close();
	}
	balloons = null;
	// SCSessionCloser͂ł͕ĒuB
	queue.clear();
    }
    
    public final int getStatus() {
        return status;
    }

    public String getSurfaceOpt(SCSurface surface, String key) {
	String ret = null;
	Map defs = surface.getComprehensiveDefs();
	if (defs != null) {
	    ret = (String)defs.get(key);
	}
	if (ret == null) {
	    ret = currentShell.getDescManager().getStrValue(key);
	}
	return ret;
    }
    
    public void recalcBalloonsLoc() {
        // o[̈ʒuČvZĈړ܂B
        final int screenBottom = (int)NSScreen.mainScreen().visibleFrame().y();

	for (Iterator ite = getBalloonIterator(); ite.hasNext(); ) {
	    SCSafetyBalloonController balloon = (SCSafetyBalloonController)ite.next();
	    int scope = balloon.getScope();
	    SCShellWindowController shell = getShell(scope);

	    String wpos_x = balloon.getSkinOpt("windowposition.x");
	    String wpos_y = balloon.getSkinOpt("windowposition.y");

	    String key =
		(scope == 0 ? "sakura.balloon.offsety" : "kero.balloon.offsety");
	    int offsety = 0;
	    
	    if (shell.currentSurface() != null) {
		try {
		    String opt = getSurfaceOpt(shell.currentSurface(), key);
		    if (opt != null) {
			offsety = Integer.parseInt(opt);
		    }
		}
		catch (NumberFormatException e) {
		    e.printStackTrace();
		}
	    }
	    else {
		offsety = currentShell.getDescManager().getIntValue(key);
	    }

	    if (wpos_y != null) {
		try {
		    offsety += Integer.parseInt(wpos_y);
		}
		catch (NumberFormatException e) {
		    e.printStackTrace();
		}
	    }
	    
	    balloon.checkWentOut();
	    int x = simulateHorizLoc(scope, balloon.isAtLeft());
	    int y = (int)shell.height() - offsety; // MacOS X̍Wn͈ʓIPĈYtB
	    if (y < (int)balloon.height() + screenBottom) {
		y = (int)balloon.height() + screenBottom; // ɂ͂ݏoȂ悤ɁB
	    }

	    if (wpos_x != null && wpos_x.equals("center")) {
		// FIXME: ̓삪ǂȂA
		// ÿʒuo[̍̕グB
		y += (int)balloon.height();
	    }

	    /*System.out.println("recalcBalloonsLoc: scope="+scope+" x="+x+" y="+y);
	    System.out.println("   offsety="+offsety+" shell.height="+shell.height());
	    System.out.println("   screenBottom="+screenBottom);*/
	    
	    balloon.setLoc(new NSPoint(x, y));
	}
    }

    public int simulateHorizLoc(int scope, boolean left) {
	// o[ɒuꍇitruej܂͉Eɒuꍇifalsejł
	// o[xWvZĕԂ܂B
	SCShellWindowController shell = getShell(scope);
	SCSafetyBalloonController balloon = getBalloon(scope);

	String wpos_x = balloon.getSkinOpt("windowposition.x");
	if (wpos_x != null && wpos_x.equals("center")) {
	    return
		(int)shell.x() +
		(int)shell.width() / 2 -
		(int)balloon.width() / 2;
	}

	String key =
	    (scope == 0 ? "sakura.balloon.offsetx" : "kero.balloon.offsetx");
	int offsetx = 0;

	if (shell.currentSurface() != null) {
	    try {
		String opt = getSurfaceOpt(shell.currentSurface(), key);
		if (opt != null) {
		    offsetx = Integer.parseInt(opt);
		}
	    }
	    catch (NumberFormatException e) {
		e.printStackTrace();
	    }
	}
	else {
	    offsetx = currentShell.getDescManager().getIntValue(key);
	}

	if (wpos_x != null) {
	    try {
		offsetx += Integer.parseInt(wpos_x);
	    }
	    catch (NumberFormatException e) {
		e.printStackTrace();
	    }
	}

	/*System.out.println("simulateHorizLoc: scope="+scope+" offsetx="+offsetx);
	  System.out.println("   shell.x="+shell.x()+" shell.width="+shell.width()+" balloon.width="+balloon.width());*/

	if (left) {
	    return (int)shell.x() - (int)balloon.width() + offsetx;
	}
	else {
	    return (int)shell.x() + (int)shell.width() - offsetx;
	}
    }
    
    public void restartBalloonSkinServer(String balloon_path) {
        // balloon_path : home/balloon/...
	SCStatusWindowController stat = null;
	if (!SCFoundation.isHereMainThread()) {
	    stat = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	    stat.setTypeToText();
	    stat.show();
	    stat.texttype_print("restarting balloon server...\n");
	}
	
	NSUserDefaults defaults = NSUserDefaults.standardUserDefaults();
		
        // o[XLT[o[ċNāASo[setBalloonServer𑗂B
        balserver = SCFoundation.sharedFoundation().getBalloonServer(balloon_path,stat);
	for (Iterator ite = getBalloonIterator(); ite.hasNext(); ) {
	    ((SCSafetyBalloonController)ite.next()).setBalloonServer(balserver);
	}
        
        recalcBalloonsLoc();
		
	if (stat != null) {
	    stat.texttype_print("%[color,white]restarted.%[color,default]");
	    stat.closeWindow();
	}
    }
    
    public void resizeShell(double ratio) {
        currentShell.getSurfaceServer().resizeSurfaces(ratio);

	for (Iterator ite = getShellIterator(); ite.hasNext(); ) {
	    ((SCShellWindowController)ite.next()).surfaceResized(
		currentShell.getSurfaceServer(), ratio);
	}

        recalcBalloonsLoc();
    }
    
    public boolean isScriptRunnerProtected() {
        // ݃XNvgi[NĂāA^CNeBJZbVA
        // ύXsƂtrueԂ܂B
        
        if (scrrunner != null) {
            return (scrrunner.isAlive() && !scrrunner.interruptAllowed());
        }
        
        return false;
    }
    
    public boolean checkMikire() {
	// \0T[tBXʂ甼ȏ͂ݏoĂtrueԂ܂B
	SCShellWindowController swc = getShell(0);
	if (swc == null) {
	    return false;
	}
	
	final int screenWidth = (int)NSScreen.mainScreen().frame().width();
	return (swc.x() < swc.width() / 2 || swc.x() + swc.width() - screenWidth > swc.width() / 2);
    }
    
    public boolean checkKasanari() {
	// dȂ蕔̕疔͂ɂイ̏80%zĂtrueԂ܂B
	SCShellWindowController sakura = getShell(0);
	SCShellWindowController unyuu = getShell(1);
	if (sakura == null || unyuu == null) {
	    return false;
	}
	
	float slimmer_width = (sakura.width() > unyuu.width() ? unyuu.width() : sakura.width());
	NSRect intersection = sakura.frame().rectByIntersectingRect(unyuu.frame());
	if (intersection == NSRect.ZeroRect) {
	    return false;
	}
	
	return (intersection.width() > slimmer_width * (80.0 / 100.0));
    }
    
    public void forceMovingNextToAnother(int scope) {
	// typeŎw肳ꂽT[tBẌׂ̗ʒu܂ŋړB
	// 4yс5̋@\BƂ̂̓͕ʂĂ̂낤B
	SCShellWindowController target = getShell(scope);
	SCShellWindowController against = getShell(scope == 0 ? 1 : 0); // FIXME: {cɂŗǂ̂
	
	// Ƃ肠ɓĂ݂āA؂ȂEɈړB
	float x = against.x() - target.width();
	if (x < target.width() / 2) {
	    x = against.x() + against.width();
	}
	target.setHorizLoc(x);
	
	// ړm
	shellWindowMoved(target);
    }
    
    public void shellWindowMoved(SCShellWindowController window) {
        // VFEChÊǂ炩hbOꂽɌĂ΂܂B
	String entry_name = "shell_window."+currentShell.getDirName()+"."+"scope"+window.getScope()+".x";
        
        SCGhostManager ghostManager = SCGhostManager.sharedGhostManager();
        NSMutableDictionary ghostDefaults = ghostManager.getGhostDefaults(getGhostPath());
        
        ghostDefaults.setObjectForKey(new Integer((int)window.x()),entry_name);
        
        ghostManager.setGhostDefaults(getGhostPath(),ghostDefaults);
    }
    
    public String getGhostMasterDirPath() {
        File ghost_root = new File(SCFoundation.getParentDirOfBundle(),ghost_path);
        File f = new File(ghost_root,"ghost/master");
        return f.getPath();
    }
    
    public String getShellDirName() {
	NSDictionary ghostDefaults = SCGhostManager.sharedGhostManager().getGhostDefaults(ghost_path);
	String shelldir = (String)ghostDefaults.objectForKey("shell_dirname");
	File ghost_root = new File(SCFoundation.getParentDirOfBundle(),ghost_path);
	
	if (shelldir == null || shelldir.length() == 0) {
	    File master = new File(ghost_root,"shell/master");
	    if (master.exists()) {
		return "master";
	    }
	    else { // shell/master̂œKȕIԁB
		File shell = new File(ghost_root,"shell");
		File[] shells = shell.listFiles();
		int choice;
		while (true) {
		    choice = (int)((Math.random() * 10000) % shells.length);
		    if (shells[choice].isDirectory()) break;
		}
		return shells[choice].getName();
	    }
	}
	else {
	    File dir = new File(ghost_root,"shell/"+shelldir);
	    if (!dir.exists() || !dir.isDirectory()) {
		File master = new File(ghost_root,"shell/master");
		if (master.exists()) {
		    return "master";
		}
		else { // shell/master̂œKȕIԁB
		    File shell = new File(ghost_root,"shell");
		    File[] shells = shell.listFiles();
		    int choice;
		    while (true) {
			choice = (int)((Math.random() * 10000) % shells.length);
			if (shells[choice].isDirectory()) break;
		    }
		    return shells[choice].getName();
		}
	    }
	    else {
		return shelldir;
	    }
	}
    }
    
    public int getHorizontalLocationOfShell(String shellDirName, int scope) {
	/*
	shellDirName: ʒu擾VF̃fBNg
	̏ŏ𓾂B
	1. defaultsA"shell_window.$(shellDirName).scope$(id).x"΁A̒lB
	2. "shell_window.$(shellDirName).{sakura|kero}.x"΁A̒lBAscope0܂1̏ꍇ̂݁B
	3. "shell_window {hontai|kero} x"΁A̒lBAscope0܂1̏ꍇ̂݁B
	4. scope0ȂÃ݂XN[ZoB
	5. Ⴂscopelŏ̃VFʒuZoB
	*/
	NSDictionary ghostDefaults = SCGhostManager.sharedGhostManager().getGhostDefaults(ghost_path);
	Object x;
	
	x = ghostDefaults.objectForKey("shell_window."+shellDirName+".scope"+scope+".x");
	if (x != null && x instanceof Number) {
	    return ((Number)x).intValue();
	}

	if (scope == 0 || scope == 1) {
	    x = ghostDefaults.objectForKey("shell_window."+shellDirName+"."+(scope == 0 ? "sakura" : "kero")+".x");
	    if (x != null && x instanceof Number) {
		return ((Number)x).intValue();
	    }

	    x = ghostDefaults.objectForKey("shell_window "+(scope == 0 ? "sakura" : "kero")+" x");
	    if (x != null && x instanceof Number) {
		return ((Number)x).intValue();
	    }
	}

	if (scope == 0) {
	    return (int)(NSScreen.mainScreen().frame().width() - getShell(0).width());
	}

	// scopeT
	for (int i = scope - 1; i >= 0; i--) {
	    SCShellWindowController lower = getShell(i);
	    if (lower != null) {
		// ᢌBğdňʒu𓾂B
		int lower_x = getHorizontalLocationOfShell(shellDirName, lower.getScope());
		return (int)(lower_x - getShell(scope).width());
	    }
	}

	// ɂ͘҂Ȃ
	throw new RuntimeException("Insane state: scope 0 is missing?");
    }
    
    public void changeToOtherGhostAtRandom() {
	// _ɑ̃S[XgƑւB
	// Ɉ΂IB
	String nextPath = SCFoundation.sharedFoundation().getAnyGhostPathInAsleep();
	if (nextPath == null) {
	    SCGhostManager.sharedGhostManager().forceHaltGhost(this);
	}
	else {
	    String nextBalloonPath = SCGhostManager.sharedGhostManager().getBalloonPathOfGhost(nextPath);
	    double nextScale = SCGhostManager.sharedGhostManager().getScaleOfGhost(nextPath);
	    
	    SCSessionChanger sc = new SCSessionChanger(this,nextPath,nextBalloonPath,nextScale);
	    sc.start();
	}
    }
    
    public final boolean isShellChangingSessionRunningNow() {
	return (lastShellChangingSession != null && lastShellChangingSession.isAlive());
    }
    
    public final boolean isNetworkUpdaterRunningNow() {
	return (lastNetworkUpdater != null && lastNetworkUpdater.isAlive());
    }
    
    public final boolean isSessionCloserRunningNow() {
	return (closer != null && closer.isAlive());
    }
    
    public final SCScriptServer getTempScriptServer() {
	return tmpScriptServer;
    }
    
    public final SCShellWindowController getShell(int scope) {
	return (SCShellWindowController)shells.get(new Integer(scope));
    }

    public final SCSafetyBalloonController getBalloon(int scope) {
	return (SCSafetyBalloonController)balloons.get(new Integer(scope));
    }

    public final Iterator getShellIterator() {
	return shells.values().iterator();
    }

    public final Iterator getBalloonIterator() {
	return balloons.values().iterator();
    }
    
    public final SCScriptRunner getScriptRunner() {
        return scrrunner;
    }
    
    public final SCBalloonSkinServer getBalloonServer() {
        return balserver;
    }
    
    public final String getGhostPath() {
        return ghost_path;
    }
    
    public final File getGhostDir() {
	return ghost_dir;
    }
    
    public final SCSpirit getMasterSpirit() {
	return masterSpirit;
    }
    
    public final SCShell getCurrentShell() {
	return currentShell;
    }
    
    public final SCShellContextMenuMaker getShellContextMenuMaker() {
	return shellContextMenuMaker;
    }
    
    public final SCMenuAppearanceServer getMenuAppearance() {
	return menuAppearance;
    }
    
    public final String getSelfName() {
	// VFŃI[o[ChĂ炻A
	// ĂȂmaster ghost擾ĕԂB
	return (currentShell.getSelfName() == null ?
		masterSpirit.getSelfName() : currentShell.getSelfName());
    }
    
    public final String getKeroName() {
	return (currentShell.getKeroName() == null ?
		masterSpirit.getKeroName() : currentShell.getKeroName());
    }

    public String getCurrentIdentification() {
	// ݎgp̃VFՎIDĂ΂A
	// ΃S[XgIDԂB
	String shell_id = currentShell.getIdentification();
	if (shell_id != null) {
	    return shell_id;
	}
	return masterSpirit.getIdentification();
    }
    
    public final File getReadmeFile() {
	return readmeFile;
    }
}
