/*  $Id: SCSessionStarter.java,v 1.3 2004/01/02 11:28:41 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import java.util.*;
// Singleton type

public class SCSessionStarter {
    protected static SCSessionStarter _shared_instance = null;
    Vector starters;
    
    public static SCSessionStarter sharedStarter() {
	if (_shared_instance == null) {
	    _shared_instance = new SCSessionStarter();
	}
	return _shared_instance;
    }
    
    protected SCSessionStarter() {
	starters = new Vector();
    }
    
    public void start(String ghost_path,String balloon_path,double scale) {
	new StarterThread(ghost_path,balloon_path,scale).start();
    }
    
    public boolean isThisGhostStartingNow(String ghost_path) {
	// w肳ꂽS[Xg݋NۂB
	for (Enumeration e = starters.elements();e.hasMoreElements();) {
	    StarterThread starter = (StarterThread)e.nextElement();
	    if (starter.getGhostPath().equals(ghost_path)) {
		return true;
	    }
	}
	return false;
    }
    
    protected class StarterThread extends Thread {
	String ghost_path,balloon_path;
	double scale;
	
	public StarterThread(String ghost_path,String balloon_path,double scale) {
	    this.ghost_path = ghost_path;
	    this.balloon_path = balloon_path;
	    this.scale = scale;
	}
	
	public void run() {
	    int pool = NSAutoreleasePool.push();
	    starters.add(this);
	    
	    postNotification("opening");
	    
	    SCSession s = SCFoundation.sharedFoundation().openSession(ghost_path,balloon_path,scale);
	    if (s.hasBootedBefore()) {
		s.doShioriEvent("OnBoot",new String[] {s.getCurrentShell().getShellName()});
	    }
	    else {
		s.doFirstBootEvent();
	    }
	    
	    postNotification("done");
	    
	    starters.remove(this);
	    NSAutoreleasePool.pop(pool);
	}
	
	public String getGhostPath() {
	    return ghost_path;
	}
	
	private void postNotification(String subinfo) {
	    NSMutableDictionary userinfo = new NSMutableDictionary();
	    userinfo.setObjectForKey(ghost_path,"path");
	    NSNotificationCenter.defaultCenter().postNotification("sessionstarter",subinfo,userinfo);
	}
    }
}
