/*  $Id: SCShellChangingSession.java,v 1.6 2004/01/02 11:28:41 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCShellChangingSession extends Thread {
    SCSession session;

    public SCShellChangingSession(SCSession session) {
	this.session = session;
    }
    
    public void run() {
	if (session.isInPassiveMode()) {
	    session = null;
	    return;
	}
	
	int pool = NSAutoreleasePool.push();
	postNotification("shellchanger","begin");
	
	SCStatusWindowController stat = SCFoundation.sharedFoundation().getStatusCenter().newStatusWindow();
	stat.setTypeToText();
	stat.show();
	stat.texttype_print("Changing the shell...\n");
	
	SCShell newShell = new SCShell(session,session.getShellDirName(),stat);
	
	String oldshell_name = session.getCurrentShell().getShellName();
	String name = newShell.getShellName();
	
	stat.texttype_print("old shell:"+oldshell_name+"\n");
	
	SCSpirit master_spirit = session.getMasterSpirit();
	String changing_req;
	if (master_spirit.getShioriProtocolVersion() == 2)
	    changing_req = "GET Sentence SHIORI/2.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nSecurityLevel: local\r\nEvent: OnShellChanging\r\nReference0: "+name+"\r\n\r\n";
	else
	    changing_req = "GET SHIORI/3.0\r\nSender: "+SCFoundation.STRING_FOR_SENDER+"\r\nSecurityLevel: local\r\nID: OnShellChanging\r\nReference0: "+name+"\r\n\r\n";
	
	session.shioriResponceWork(master_spirit.doShioriSession(changing_req)); // ĐI܂ŃubNB
	
	session.changeShell(newShell);
	session.doShioriEvent("OnShellChanged",new String[] {name,oldshell_name}); // ̓ubNȂB
	
	stat.texttype_print("changed.\n");
	stat.closeWindow();
	
	postNotification("shellchanger","end");
	session = null;
	NSAutoreleasePool.pop(pool);
    }
    
    private void postNotification(String name,String subinfo) {
	NSMutableDictionary userinfo = new NSMutableDictionary();
	userinfo.setObjectForKey(session,"session");
	NSNotificationCenter.defaultCenter().postNotification(name,subinfo,userinfo);
    }
    
    public void terminate() {
	// I͋ȂAZbṼXe[^XCLOSEDɂȂĂΑSĂ̓삪fʂ肷B
	// āAZbṼXe[^XAVAILABLȄԂŌĂł͂ȂB
	// AVAILABLEłȂȂ܂łĂ񂾃XbhقB
	while (isAlive()) {
	    try {
		Thread.sleep(100);
	    }
	    catch (Exception e) {}
	}
    }
}
