/*  $Id: SCShellWindow.java,v 1.5 2005/04/28 19:10:28 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;
import java.io.*;

public class SCShellWindow extends NSWindow {
    private SCSafetyBalloonController balloonBelongsTo = null; // ̃VFEChEɏo[BꏏɓB
    private int initial_shell_horiz_offset,initial_shell_vert;
    
    private static final long INTERVAL_BETWEEN_DOWN_AND_UP = 200; // msec
    private static final long INTERVAL_BETWEEN_CLICK_AND_CLICKEVENT = 200; // msec
    
    SCSession session;
    SCShellWindowController controller;
    
    boolean hasToNotifyMoving = false;
    
    long lastMouseDown,lastMouseUp;
    Timer clickTimer; // {NSTimer̕R[hZčςނA삪słB
    TimerTask timerClickTask;
    //NSTimer timerClickTask;
    
    public SCShellWindow(NSRect contentRect,int styleMask,int backingType,boolean defer) {
        super(
	    contentRect,
	    NSWindow.BorderlessWindowMask,
	    NSWindow.Buffered,false);
        setBackgroundColor(NSColor.clearColor());
        setOpaque(false);
        setHasShadow(false);
    }
	
    public boolean canBecomeKeyWindow() {
	return true;
    }
    
    public void initialize(SCSession s,SCShellWindowController c) {
        session = s;
        controller = c;
	
	clickTimer = new Timer();
	
	/*setAcceptsMouseMovedEvents(controller.getScope() == SCFoundation.HONTAI); // ̂Qȏ̃EChEɂݒ肵Ă
	// Ō̈ɂȂB*/
	setAcceptsMouseMovedEvents(true);
	
	NSMutableArray pboardTypes = new NSMutableArray();
	pboardTypes.addObject(NSPasteboard.FilenamesPboardType);
	pboardTypes.addObject(NSPasteboard.StringPboardType);
	registerForDraggedTypes(pboardTypes);
    }
    
    public void close() {
	super.close();
	
	balloonBelongsTo = null;
	session = null;
	controller = null;
	clickTimer = null;
	timerClickTask = null;
    }
    
    public void setBalloon(SCSafetyBalloonController balloon) {
        balloonBelongsTo = balloon;
    }
    
    public int draggingEntered(NSDraggingInfo draggingInfo) {
	// ̍ڂDnD悤ƂĂRB
	// passive modełRB
	if (session.isInPassiveMode()) return NSDraggingInfo.DragOperationNone;
	
	NSArray plist_files = (NSArray)draggingInfo.draggingPasteboard().propertyListForType(NSPasteboard.FilenamesPboardType);
	if (plist_files != null) {
	    if (plist_files.count() == 1) {
		return NSDraggingInfo.DragOperationGeneric;
	    }
	    else if (plist_files.count() > 1) {
		return NSDraggingInfo.DragOperationNone;
	    }
	}
	
	String str = draggingInfo.draggingPasteboard().stringForType(NSPasteboard.StringPboardType);
	if (str != null) {
	    return (str.startsWith("http://") ? NSDraggingInfo.DragOperationGeneric : NSDraggingInfo.DragOperationNone);
	}
	
	return NSDraggingInfo.DragOperationNone;
    }
    
    public int draggingUpdated(NSDraggingInfo draggingInfo) {
	return NSDraggingInfo.DragOperationGeneric;
    }
    
    public void draggingExited(NSDraggingInfo draggingInfo) {
	
    }
    
    public boolean prepareForDragOperation(NSDraggingInfo aDraggingInfo) {
	NSArray plist = (NSArray)aDraggingInfo.draggingPasteboard().propertyListForType(NSPasteboard.FilenamesPboardType);
	if (plist != null) {
	    String fpath = (String)plist.objectAtIndex(0);
	    File f = new File(fpath);
	    
	    if (f.isFile() && (fpath.toLowerCase().endsWith(".zip") || fpath.toLowerCase().endsWith(".nar"))) {
		SCFoundation.sharedFoundation().install(fpath,controller.session());
	    }
	    else if (f.isDirectory() && SCNarMaker.hasManifestFile(f)) {
		SCFoundation.sharedFoundation().makeNar(fpath,controller.session());
	    }
	    else if (f.isDirectory() && SCUpdateDataMaker.hasDauFile(f)) {
		SCFoundation.sharedFoundation().makeDau(fpath,controller.session());
	    }
	    return true;
	}
	
	String str = aDraggingInfo.draggingPasteboard().stringForType(NSPasteboard.StringPboardType);
	if (str != null) {
	    SCFoundation.sharedFoundation().downloadAndInstall(str,controller.session());
	}
	return false;
    }
    
    public boolean performDragOperation(NSDraggingInfo aDraggingInfo) {
	return true;
    }
    
    public void concludeDragOperation(NSDraggingInfo draggingInfo) {
	
    }
    
    public void mouseDown(NSEvent theEvent) {
	lastMouseDown = System.currentTimeMillis();
	
        // EChEړB
        NSPoint initial_pt = theEvent.window().convertBaseToScreen(theEvent.locationInWindow());
        
        initial_shell_horiz_offset = (int)(initial_pt.x() - theEvent.window().frame().x());
        initial_shell_vert = (int)theEvent.window().frame().y();
    }
    
    public void mouseDragged(NSEvent theEvent) {
	if (System.currentTimeMillis() - lastMouseDown < INTERVAL_BETWEEN_DOWN_AND_UP) {
	    // NbNԒȂhbO͍sȂB
	    return;
	}
	
        NSWindow window = theEvent.window();
        
        // EChEړB̂݁B
	hasToNotifyMoving = true;
        NSPoint new_loc = window.convertBaseToScreen(window.mouseLocationOutsideOfEventStream());
        
        int new_x;
        new_x = (int)(new_loc.x()) - initial_shell_horiz_offset;
	controller.absoluteSetLoc(new_x,initial_shell_vert);
        
	session.recalcBalloonsLoc();
    }
    
    public void mouseUp(NSEvent theEvent) {
	lastMouseUp = System.currentTimeMillis();
	if (System.currentTimeMillis() - lastMouseDown < INTERVAL_BETWEEN_DOWN_AND_UP) {
	    if (timerClickTask == null) { // NbNꂽB
		// _uNbNFԂ߂ɃNbN肪m肷B
		timerClickTask = new ClickTimerTask(theEvent);
		clickTimer.schedule(timerClickTask,INTERVAL_BETWEEN_CLICK_AND_CLICKEVENT);
		/*NSTimer open_timer = new NSTimer(
		  INTERVAL_BETWEEN_CLICK_AND_CLICKEVENT / 1000.0, // PʂsecɁB
		  this,
		  new NSSelector("clicked",new Class[] {NSEvent.class}),
		  new Object[] {theEvent},
		  false);
		  SCFoundation.sharedFoundation().getRunLoopOfMainThread().addTimerForMode(open_timer,NSRunLoop.DefaultRunLoopMode);*/
	    }
	    else { // _uNbNꂽB
		doubleClicked(theEvent);
	    }
	}
	
	if (hasToNotifyMoving) {
	    session.shellWindowMoved(controller);
	    hasToNotifyMoving = false;
	}
    }
    
    public void mouseMoved(NSEvent theEvent) {
	// {̂Ƃɂイ̂ǂ炪L[EChEɂȂĂĂAL[łȂłmouseMovedɔohackB
	// {ResponderChain̍{NSApplicationdelegateƂmouseMovedׂmȂ
	// NSApplicationdelegateɂ͉̂CxgBȂI

	if (controller == null) return;
	if (!frame().containsPoint(NSEvent.mouseLocation(),false)) return;

	sendMouseMovedEvent(controller.getScope());
    }
    private void sendMouseMovedEvent(int scope) {
	SCShellWindowController wc = session.getShell(scope);
	double ratio = wc.getRatio();
	NSPoint localLocForWindow = wc.getWindow().convertScreenToBase(NSEvent.mouseLocation());
	NSPoint localLocForSurface = new NSPoint((float)(localLocForWindow.x() / ratio),(float)(localLocForWindow.y() / ratio));
	String strX = Integer.toString((int)localLocForSurface.x());
	String strY = Integer.toString((int)wc.currentSurface().getOriginalSize().height() - (int)localLocForSurface.y());
	String wheel = "";
	String owner = Integer.toString(wc.getScope());
	String collision = wc.currentSurface().getCollisionNameAt(localLocForSurface);
	if (collision == null) collision = "";
	session.mouseEventOccuredOnShell("OnMouseMove",strX,strY,wheel,owner,collision);
    }
	
    public void scrollWheel(NSEvent theEvent) {
	if (controller == null) return;
	if (!frame().containsPoint(NSEvent.mouseLocation(),false)) return;

	sendMouseWheelEvent(controller.getScope(), theEvent.deltaY());
    }
    private void sendMouseWheelEvent(int scope, float deltaY) {
	if ((int)Math.abs(Math.round(deltaY)) <= 1) return; // Βl1ȉȂ疳B
	
	SCShellWindowController wc = session.getShell(scope);
	double ratio = wc.getRatio();
	NSPoint localLocForWindow = wc.getWindow().convertScreenToBase(NSEvent.mouseLocation());
	NSPoint localLocForSurface = new NSPoint((float)(localLocForWindow.x() / ratio),(float)(localLocForWindow.y() / ratio));
	String strX = Integer.toString((int)localLocForSurface.x());
	String strY = Integer.toString((int)wc.currentSurface().getOriginalSize().height() - (int)localLocForSurface.y());
	String wheel = Integer.toString((int)Math.round(deltaY));
	String owner = Integer.toString(wc.getScope());
	String collision = wc.currentSurface().getCollisionNameAt(localLocForSurface);
	if (collision == null) collision = "";
	
	//System.out.println(strX+","+strY+" wheel:"+wheel+" owner:"+owner+" collision:"+collision);
	session.mouseEventOccuredOnShell("OnMouseWheel",strX,strY,wheel,owner,collision);
    }
    
    private void clicked(NSEvent theEvent) {
	timerClickTask = null; // N[Abv
	
	sendMouseEvent("OnMouseClick",theEvent);
    }
    
    private void doubleClicked(NSEvent theEvent) {
	timerClickTask.cancel();
	//timerClickTask.invalidate();
	timerClickTask = null;
	
	if ((theEvent.modifierFlags() & NSEvent.AlternateKeyMask) != 0) {
	    // TEACHZbVJn
	    session.doTeach();
	}
	else if ((theEvent.modifierFlags() & NSEvent.CommandKeyMask) != 0) {
	    // COMMUNICATE{bNXJ
	    session.showCommunicateBox();
	}
	else {
	    sendMouseEvent("OnMouseDoubleClick",theEvent);
	}
    }
    
    private void sendMouseEvent(String type,NSEvent nsevent) {
	double ratio = controller.getRatio();
	NSPoint localLocForWindow = nsevent.locationInWindow();
	NSPoint localLocForSurface = new NSPoint((float)(localLocForWindow.x() / ratio),(float)(localLocForWindow.y() / ratio));
	String strX = Integer.toString((int)localLocForSurface.x());
	String strY = Integer.toString((int)controller.currentSurface().getOriginalSize().height() - (int)localLocForSurface.y());
	String wheel = "";
	String owner = Integer.toString(controller.getScope());
	String collision = controller.currentSurface().getCollisionNameAt(localLocForSurface);
	if (collision == null) collision = "";
	//session.doShioriEvent(type,new String[] {strX,strY,wheel,owner,collision});
	session.mouseEventOccuredOnShell(type,strX,strY,wheel,owner,collision);
    }
    
    private class ClickTimerTask extends TimerTask {
	NSEvent eventToPost;
	
	public ClickTimerTask(NSEvent eventToPost) {
	    super();
	    this.eventToPost = eventToPost;
	}
	
	public void run() {
	    int pool = NSAutoreleasePool.push();
	    clicked(eventToPost);
	    NSAutoreleasePool.pop(pool);
	}
    }
}
