/*
    $Id: SCSimpleLinesList.java,v 1.5 2003/12/24 06:02:13 phonohawk Exp $
    ----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.io.*;
import java.util.*;

public abstract class SCSimpleLinesList extends Vector {
    public SCSimpleLinesList() {
	super();
    }
    
    public SCSimpleLinesList(File f) {
	super();
	
	try {
	    BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(f),encodeType()));
	    
	    while (true) {
		String line = br.readLine();
		if (line == null || line.length() == 0) break;

		try {
		    addEntry(line);
		}
		catch (Exception ex) {
		    throw new Exception(line, ex);
		}
	    }
	    
	    br.close();
	}
	catch (Exception e) {
	    throw new RuntimeException(e);
	}
    }
    
    public SCSimpleLinesList(InputStream is) {
	super();
	
	try {
	    BufferedReader br = new BufferedReader(new InputStreamReader(is,encodeType()));
	    
	    while (true) {
		String line = br.readLine();
		if (line == null || line.length() == 0) break;

		try {
		    addEntry(line);
		}
		catch (Exception ex) {
		    throw new Exception(line, ex);
		}
	    }
	    
	    br.close();
	}
	catch (Exception e) {
	    throw new RuntimeException(e);
	}
    }
    
    public void saveToFile(File outfile) throws Exception {
	if (outfile.exists()) outfile.delete();
	OutputStreamWriter osw = new OutputStreamWriter(new FileOutputStream(outfile),encodeType());
	
	for (Enumeration e = elements() ; e.hasMoreElements() ; ) {
	    String line = toLineOfFile(e.nextElement()) + returnCode();
	    osw.write(line,0,line.length());
	}
	
	osw.flush();
	osw.close();
    }
    
    public abstract void addEntry(String line);
    public abstract String toLineOfFile(Object obj); // ۑKvnullԂĂB
    public abstract String returnCode(); // ۑKvnullԂĂB
    public abstract String encodeType(); // null֎~B
}
