/*  $Id: SCSurfaceServer.java,v 1.10 2006/02/25 08:07:10 phonohawk Exp $
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;
import java.util.*;
import util.*;

public class SCSurfaceServer {
    // T[tBX̉摜f[^̑[hāASCSurfaceێ܂B
    SCShell shell;
    File shelldir;
    Hashtable surfaces; // key : (Integer)ID , value : (SCSurface)T[tBX
    double ratio = 1.0;
    
    public SCSurfaceServer(SCShell shell,File shelldir) {
	surfaces = new Hashtable();
	this.shell = shell;
	this.shelldir = shelldir;
	
	if (SCFoundation.LOAD_WHOLE_SURFACES_ON_BOOTING_SURFACE_SERVER) loadAllSurfaces();
    }
    
    public boolean hasLoadAllSurfaces() {
	// SẴT[tBX[hĂ܂ĂtrueB
	return SCFoundation.LOAD_WHOLE_SURFACES_ON_BOOTING_SURFACE_SERVER;
    }
    
    public void loadAllSurfaces() {
	SCAliasManager alias = shell.getAliasManager();
		
	File[] files = shelldir.listFiles();
	for (int i = 0;i < files.length;i++) {
	    if (!files[i].isFile()) continue;
	    
	    String name = files[i].getName();
	    String lowercase_name = name.toLowerCase();
	    if (lowercase_name.startsWith("surface") &&
		(lowercase_name.endsWith(".png") || lowercase_name.endsWith(".dgp"))) {
		try {
		    String id_str = name.substring(7,name.length()-4);
		    loadSurface( Integer.parseInt(id_str) );
		}
		catch (NumberFormatException e) {}
	    }
	    else {
		String reg_name = alias.inverseSearch(name.substring(name.length()-4));
		if (reg_name != null) {
		    try {
			String id_str = reg_name.substring(7,reg_name.length());
			loadSurface( Integer.parseInt(id_str) );
		    }
		    catch (NumberFormatException e) {}
		}
	    }
	}
	
	// surfaces.txtelement`T[`B
	SCBlockedDescription descriptions = shell.getSurfaceDescriptions();
	if (descriptions != null) {
	    for (Enumeration keys = descriptions.keys();keys.hasMoreElements();) {
		String key = (String)keys.nextElement();
		Object obj = descriptions.get(key);
		if (!(obj instanceof Vector)) continue;
		Vector def = (Vector)obj;
		
		boolean found = false;
		final int n_lines = def.size();
		for (int i = 0;i < n_lines;i++) {
		    String line = (String)def.elementAt(i);
		    if (line.startsWith("element")) {
			found = true;
			break;
		    }
		}
		
		if (found) {
		    String reg_name = alias.inverseSearch(key);
		    try {
			String id_str = (reg_name != null ? reg_name : key).substring(7);
			loadSurface( Integer.parseInt(id_str) );
		    }
		    catch (NumberFormatException e) {}
		}
	    }
	}
    }
    
    public SCSurface findSurface(int id) {
	// _CNg͍s܂B
		
	Integer intId = new Integer(id);
	Object obj = surfaces.get(intId);
	if (obj == null) {
	    // [hĂȂA݂ȂB
	    loadSurface(id);
	    return (SCSurface)surfaces.get(intId); // ݂ȂnullԂ܂B
	}
	else {
	    return (SCSurface)obj; // Ƀ[hĂB
	}
    }
    
    public SCSurface findSurface(int id, int scope) {
	// _CNgs܂B
	// Ascope01̏ꍇ̂݁B
	
	SCSurface surface = findSurface(id);
	if (surface == null) {
	    if (scope == 0) {
		return findSurface(0);
	    }
	    else if (scope == 1) {
		return findSurface(10);
	    }
	    else {
		return null;
	    }
	}
	else {
	    return surface;
	}
    }
    
    public File findSurfacePngFile(int id) {
	return findSurfacePngFile(shelldir,id);
    }
    public static File findSurfacePngFile(File shelldir,int id) {
	// surface0*${id}\.(png|dgp)܂B
	// 0*̏ꍇA܂surface${id}.(png|dgp)̌`ɂȂĂꍇɍłǂsƂo܂B
	// ǌtȂnullԂ܂B
	File pngFile = new File(shelldir,"surface"+id+".png");
	if (pngFile.exists()) return pngFile;
	
	File dgpFile = new File(shelldir,"surface"+id+".dgp");
	if (dgpFile.exists()) return dgpFile;
	
	File[] files = shelldir.listFiles();
	for (int i = 0;i < files.length;i++) {
	    String fname = files[i].getName();
	    String lower_fname = fname.toLowerCase();
	    if (lower_fname.startsWith("surface") &&
		(lower_fname.endsWith(".png") || lower_fname.endsWith(".dgp"))) {
		try {
		    int id_of_current = Integer.parseInt(fname.substring(7,fname.length()-4));
		    if (id_of_current == id) {
			return files[i];
		    }
		}
		catch (Exception e){}
	    }
	}
	return null;
    }
    
    public void loadSurface(File pngFile,int id) {
	SCSurface surface = new SCSurface(pngFile,id,shell.getSurfaceDescriptions());
	surface.resize(ratio); // ݂̔䗦ɃTCYĂ
	surfaces.put(new Integer(id),surface);
    }
    
    public void loadSurface(int id) {
	// w肳ꂽԍ̃T[tBX[h܂B
	// Ƀ[hĂ葶݂ȂT[tBX疳܂B
	// ݂摜elementł̒`D悵܂B
	Integer intId = new Integer(id);
	if (surfaces.get(intId) != null) return;
		
	// surface${id}ŃGCAXf[^x[X猟A΂AȂsurface${id}.pngt@C[hB
	String surfaceName = shell.getAliasManager().resolveAlias("surface"+id);
	
	// element̉zsurfaceƂĒ`Ă\B
	SCBlockedDescription descriptions = shell.getSurfaceDescriptions();
	if (descriptions != null && descriptions.exists(surfaceName)) {
	    Object obj = descriptions.get(surfaceName);
	    if (!(obj instanceof Vector)) return;
	    Vector lines = (Vector)obj;
			
	    Vector elements = new Vector(); // <Object[]>elements : [0]=(NSImage)image, [1]=(Integer)x, [2]=(Integer)y
	    final int n_lines = lines.size();
	    for (int i = 0;i < n_lines;i++) {
		String line = (String)lines.elementAt(i);
		if (line.startsWith("element")) {
		    try {
			StringTokenizer st = new StringTokenizer(line,",");
			st.nextToken(); // element*
			st.nextToken(); // overlay
			String internal = st.nextToken(); // surface*.png
			String x_str = st.nextToken(); // x
			String y_str = st.nextToken(); // y

			// png[hč̍WŐFBɃAt@`lB
			File pngfile = new File(shelldir,internal);
			if (!pngfile.exists()) {
			    pngfile = new File(shelldir, internal + ".png");
			}
			if (!pngfile.exists()) {
			    pngfile = new File(shelldir, internal + ".dgp");
			}
			if (!pngfile.exists()) {
			    System.err.println("SCSurfaceServer : File "+internal+" specified as an element was not found.");
			    continue;
			}
			NSImage original_image;
			if (pngfile.getName().toLowerCase().endsWith(".dgp")) {
			    original_image = DGPLoader.load(pngfile);
			}
			else {
			    original_image = new NSImage(pngfile.getPath(),true);
			}
			NSImage image = SCAlphaConverter.convertImage(original_image);
			
			// pna݂邩H
			File pnaFile = new File(SCFileUtils.stringByDeletingExtension(pngfile.getPath()) + ".pna");
			if (pnaFile.exists()) {
			    // pna[hăAt@`lɃRs[
			    NSImage pna = new NSImage(pnaFile.getPath(),true);
			    SCAlphaConverter.attachAlphaToImage(pna,image);
			}
			
			Object[] entry = new Object[3];
			entry[0] = image;
			entry[1] = new Integer(Integer.parseInt(x_str));
			entry[2] = new Integer(Integer.parseInt(y_str));
			elements.add(entry);
		    }
		    catch (Exception e) {
			System.err.println("SCSurfaceServer : exception occured in synthesizing \"element\" images.");
			System.err.println("   The definition was "+line);
			e.printStackTrace();
		    }
		}
	    }
			
	    if (elements.size() > 0) {
		// ̉摜̃TCY߂B
		int synth_width = 0,synth_height = 0;
		
		final int n_elements = elements.size();
		for (int i = 0;i < n_elements;i++) {
		    Object[] entry = (Object[])elements.elementAt(i);
		    NSImage image = (NSImage)entry[0];
		    int x = ((Integer)entry[1]).intValue();
		    int y = ((Integer)entry[2]).intValue();
		    
		    int width = (int)image.size().width();
		    int height = (int)image.size().height();
		    
		    int current_width = x + width;
		    if (synth_width < current_width) synth_width = current_width;
		    
		    int current_height = y + height;
		    if (synth_height < current_height) synth_height = current_height;
		}
		
		// 摜쐬
		NSImage synthesized_image = new NSImage(new NSSize(synth_width,synth_height));
		synthesized_image.lockFocus();
		for (int i = 0;i < n_elements;i++) {
			Object[] entry = (Object[])elements.elementAt(i);
			NSImage image = (NSImage)entry[0];
			int x = ((Integer)entry[1]).intValue();
			int y = ((Integer)entry[2]).intValue();
			
			int width = (int)image.size().width();
			int height = (int)image.size().height();
			
			image.compositeToPoint(new NSPoint(x,synth_height - (height + y)),NSImage.CompositeSourceOver);
		}
		synthesized_image.unlockFocus();
		
		SCSurface surface = new SCSurface(synthesized_image,id,lines);
		surface.resize(ratio); // ݂̔䗦ɃTCYĂ
		surfaces.put(new Integer(id),surface);
		
		return;
	    }
	}
		
	// ɗĂƂ́AelementŒ`ĂȂB
	File pngFile = new File(shelldir,surfaceName+".png");
	File dgpFile = new File(shelldir,surfaceName+".dgp");
	if (pngFile.exists()) {
	    loadSurface(pngFile,id);
	    return;
	}
	else if (dgpFile.exists()) {
	    loadSurface(dgpFile,id);
	    return;
	}
	else {
	    pngFile = findSurfacePngFile(id);
	    if (pngFile != null) {
		loadSurface(pngFile,id);
		return;
	    }
	}
    }
    
    public void resizeSurfaces(double ratio) {
	this.ratio = ratio;
	
	Enumeration values = surfaces.elements();
	while (values.hasMoreElements()) {
	    Object elem = values.nextElement();
	    if (elem instanceof SCSurface) {
		((SCSurface)elem).resize(ratio);
	    }
	}
    }

    public String toString() {
	StringBuffer buf = new StringBuffer();
	buf.append("shell: {").append(shell).append('}');
	if (surfaces.size() > 0) {
	    buf.append("; surfaces: {");
	    for (Iterator ite = surfaces.keySet().iterator(); ite.hasNext(); ) {
		Object key = ite.next();
		buf.append(key).append(" => {").
		    append(surfaces.get(key)).append('}');
		if (ite.hasNext()) {
		    buf.append(", ");
		}
	    }
	    buf.append('}');
	}
	buf.append("; ratio: ").append(ratio);
	return buf.toString();
    }

    protected void finalize() {
	//Logger.log(this, Logger.DEBUG, "finalized");
    }
}
