/*
	$Id: SCUpdateChecker.java,v 1.2 2002/12/08 16:10:07 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.io.*;

public class SCUpdateChecker
{
    private static SCUpdateChecker _sharedInstance = null;
    
    SCUpdateCheckerController controller;
    SCUpdateCheckerDB db;
    SCUpdateCheckerThread last_executed_checker = null; // ŌɋN`FbJXbh
    String last_checking_time;
    
    File desc_file;
    SCDescription desc;
    
    public static SCUpdateChecker sharedUpdateChecker()
    {
		if (_sharedInstance == null)
		{
			_sharedInstance = new SCUpdateChecker();
		}
		return _sharedInstance;
    }
    
    private SCUpdateChecker()
    {
		desc_file = new File(SCFoundation.getParentDirOfBundle(),"home/_system/updatechecker_db/checker.dat");
		desc = new SCDescription(desc_file);
		last_checking_time = desc.getStrValue("last_checking_time");
		if (last_checking_time == null) last_checking_time = "";
		
		controller = new SCUpdateCheckerController(this);
		db = new SCUpdateCheckerDB();
		controller.getMainList().setDataSource(db);
		
		controller.setLastCheckingTimeField(last_checking_time);
    }
    
    public void showWindow()
    {
		controller.showWindow(null);
    }
    
	private static final String[] MONTH_STR =
	{"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
    public void doCheck()
    {
		// XV`FbNsB
		if (last_executed_checker != null && last_executed_checker.isAlive()) return;
		
		last_executed_checker = new SCUpdateCheckerThread(this);
		last_executed_checker.start();
		
		NSGregorianDate greg = new NSGregorianDate();
		last_checking_time = MONTH_STR[greg.monthOfYear()-1]+'/'+greg.dayOfMonth()+'/'+greg.yearOfCommonEra()+' '+greg.hourOfDay()+':'+greg.minuteOfHour();
		controller.setLastCheckingTimeField(last_checking_time);
		desc.setStrValue("last_checking_time",last_checking_time);
		try{ desc.save(desc_file); }catch(Exception e){}
    }
    
    public String getLastCheckingTime()
    {
		// ŏIXVԂB
		return last_checking_time;
    }
    
    public SCUpdateCheckerDB getDB()
    {
		return db;
    }
    
    public SCUpdateCheckerController getController()
    {
		return controller;
    }
    
    public void setEnabledOfButtons(boolean bool)
    {
		controller.setEnabledOfButtons(bool);
    }
    
    public void setStatusOfGhost(String ghost_path,int status)
    {
		// status : SCUpdateCheckerDB̒萔
		db.setStatusOfGhost(ghost_path,status);
		controller.getMainList().reloadData();
    }
    
    public void reloadAll()
    {
		db.reloadList(true);
		controller.getMainList().reloadData();
    }
}
