/*
	$Id: SCUpdateCheckerController.java,v 1.2 2002/12/08 16:10:07 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCUpdateCheckerController extends NSWindowController
{
    SCUpdateChecker checker;
    
    // IB Outlets
    NSButton btn_reload;
    NSButton btn_start_checker;
    NSButton btn_update;
    NSTableView list_main;
    NSTextField fld_last_checking_time;
    NSProgressIndicator progbar_main;
    
    public SCUpdateCheckerController(SCUpdateChecker checker)
    {
		super("UpdateChecker");
		window();
		this.checker = checker;
		
		window().setFrameAutosaveName("updatechecker.frame");
		
		list_main.setAutosaveName("updatechecker.maintable.columns");
		list_main.setAutosaveTableColumns(true);
    }
    
    public void setEnabledOfButtons(boolean bool)
    {
		btn_reload.setEnabled(bool);
		btn_start_checker.setEnabled(bool);
    }

    public void reload(Object sender)
    {
		checker.reloadAll();
    }

    public void start_checker(Object sender)
    {
		checker.doCheck();
    }

    public void update_ghost(Object sender)
    {
	
    }
    
    public NSTableView getMainList()
    {
		return list_main;
    }
    
    public void setLastCheckingTimeField(String str)
    {
		fld_last_checking_time.setStringValue(str);
    }
    
    public void setProgMin(double min) {progbar_main.setMinValue(min);}
    public void setProgMax(double max) {progbar_main.setMaxValue(max);}
    public void setProgVal(double val) {progbar_main.setDoubleValue(val);}
}
