/*
	$Id: SCUpdateCheckerThread.java,v 1.2 2002/12/08 16:10:07 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;
import java.io.*;

public class SCUpdateCheckerThread extends Thread
{
    SCUpdateChecker checker;
    
    public SCUpdateCheckerThread(SCUpdateChecker checker)
    {
		this.checker = checker;
    }
    
    public void run()
    {
		int pool = NSAutoreleasePool.push();
		
		SCUpdateCheckerController controller = checker.getController();
		
		// ꎞt@Cu
		String bundleDir = SCFoundation.getParentDirOfBundle();
		File tempDir = new File(bundleDir,"home/_system/updatechecker_temp");
		
		// {^ނdisable
		checker.setEnabledOfButtons(false);
		
		// XV\ȑSS[Xg̃pXURL擾
		Vector ghosts_to_check = checker.getDB().generateGhostListToCheck();
		final int n_ghosts = ghosts_to_check.size();
		
		// vOXo[ݒ
		controller.setProgMin(0.0);
		controller.setProgMax(n_ghosts);
		controller.setProgVal(0.0);
		
		for (int i = 0;i < n_ghosts;i++)
		{
			Hashtable elem = (Hashtable)ghosts_to_check.elementAt(i);
			String ghost_path = (String)elem.get("ghost_path");
			String url = (String)elem.get("url");
			if (!url.endsWith("/")) url = url + '/'; // XbVŏIĂȂΕt
			
			File remotedau = null;
			try
			{
				// [gupdates2.dauꎞt@CɗƂ
				remotedau = File.createTempFile("update",".dau",tempDir);
				SCFileDownloader.download(url+"updates2.dau",remotedau,30*1000);
				
				// [Jghost/master/updates2.dauƔr
				File localdau = new File(bundleDir,ghost_path+"/ghost/master/updates2.dau");
				if (localdau.exists())
				{
					if (SCFileUtils.sameFiles(localdau,remotedau))
						{
						// t@CB
						checker.setStatusOfGhost(ghost_path,SCUpdateCheckerDB.STATUS_NO_UPDATE); // uXVv
					}
					else
					{
						checker.setStatusOfGhost(ghost_path,SCUpdateCheckerDB.STATUS_UPDATED); // uXVLv
					}
				}
				else
				{
					checker.setStatusOfGhost(ghost_path,SCUpdateCheckerDB.STATUS_NOT_CHECKED_YET); // u`FbNv
				}
			}
			catch (Exception e) {}
			finally
			{
				// ꎞt@C폜
				remotedau.delete();
				
				controller.setProgVal(i);
			}
		}
		
		// {^ނenable
		checker.setEnabledOfButtons(true);
		
		// vOXo[0ɖ߂
		controller.setProgVal(0.0);
		
		NSAutoreleasePool.pop(pool);
    }
}
