/*
	$Id: SCVanishWindowController.java,v 1.2 2002/12/08 16:10:07 phonohawk Exp $
	----------
	
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class SCVanishWindowController extends NSWindowController
{
    SCSession session;
    
    NSTextField msgTextField;
    
    public SCVanishWindowController(SCSession session)
    {
		super("Vanish");
		this.session = session;
		window();
		
		window().setTitle(SCStringsServer.getStrFromMainDic("vanishdialog.title",new String[] {session.getSelfName()}));
		msgTextField.setStringValue(SCStringsServer.getStrFromMainDic("vanishdialog.message",new String[] {session.getSelfName()}));
    }
    
    public void cancel(Object sender)
    {
		window().orderOut(null);
		
		session.doShioriEvent("OnVanishCancel");
    }
    
    public void vanish(Object sender)
    {
		window().orderOut(null);
		
		SCFoundation.sharedFoundation().startVanishSession(session);
    }
    
    public void showWindow(Object sender)
    {
		// \ׂʒuvZB
		// ʒցB
		final int windowWidth = (int)window().frame().width();
		final int windowHeight = (int)window().frame().height();
		final int screenWidth = (int)NSScreen.mainScreen().frame().width();
		final int screenHeight = (int)NSScreen.mainScreen().frame().height();
		int x = (screenWidth - windowWidth) / 2;
		int y = (screenHeight - windowHeight) / 2;
		window().setFrameOrigin(new NSPoint(x,y));
		super.showWindow(sender);
    }
    
    public void show()
    {
		if (window().isVisible()) return;
		
		// OnVanishSelectings
		session.doShioriEvent("OnVanishSelecting");
		
			//windowCtrl.showWindow(null);
		NSTimer open_timer = new NSTimer(
					0.0,
					this,
					new NSSelector("showWindow",new Class[] {NSNull.class}),
					new Object[] {NSNull.nullValue()},
					false);
		SCFoundation.sharedFoundation().getRunLoopOfMainThread().addTimerForMode(open_timer,NSRunLoop.DefaultRunLoopMode);
		if (!Thread.currentThread().getName().equals("main")) while (!window().isVisible()) {} // ҋ@
    }
}
