/*
 "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
 Copyright (C) 2001-2003 phonohawk

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package aya.eval;
import aya.eval.*;
import aya.*;
import java.util.*;

public class Namespace
{
	Hashtable hash; // {変数名 => Variable}
	
	public Namespace() {
		hash = new Hashtable();
	}
	
	public Namespace(Namespace parent) {
		// 親名前空間を継承して作成。
		hash = new Hashtable(parent.getHashtable());
	}
	
	protected Hashtable getHashtable() {
		return hash;
	}
	
	public Namespace put(String name,Variable variable) {
		hash.put(name,variable);
		return this;
	}
	
	public Variable get(String name) {
		// 無ければnullを返す。
		return (Variable)hash.get(name);
	}
	
	public Variable define(String name) {
		// 無ければ作って返す。
		Variable v = (Variable)hash.get(name);
		if (v == null) {
			v = new Variable(new Value(""));
			hash.put(name,v);
		}
		return v;
	}
}
