/*
 "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
 Copyright (C) 2001-2003 phonohawk

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package aya.node;
import aya.*;
import aya.node.*;
import aya.eval.*;
import java.util.*;

public class Function
{
	Aya aya;
	String name;
	Block block;
	
	public Function(Aya aya,String name,Block block) {
		this.aya = aya;
		this.name = name;
		this.block = block;
	}
	
	public Aya getAya() {
		return aya;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public String getName() {
		return name;
	}
	
	public Value eval(Vector args) throws Exception {
		// args: vfVariablePointer܂ValuełzBnullłǂB
		// ߂l: nullłꍇB
		
		// OԂA_argv_argcݒ
		Namespace ns = new Namespace();
		if (args != null) {
			ns.put("_argv",new Variable(args));
			ns.put("_argc",new Variable(new Value(args.size())).lock());
		}
		else {
			ns.put("_argc",new Variable(new Value(0)).lock());
		}
		
		// ̖OԂpăubNʏ]
		try {
		        return block.eval(ns);
			
			/*System.out.println("+Func ["+name+"]: "+args);
			Value result = block.eval(ns);
			System.out.println("-Func ["+name+"]: "+result);
			return result;*/
		}
		catch (Statement.BreakOccurrence b) {
			throw new Exception("'break' used in function.");
		}
		catch (Statement.ContinueOccurrence b) {
			throw new Exception("'continue' used in function.");
		}
		catch (Exception e) {
			throw new Exception("Couldn't evaluate function "+name,e);
		}
	}
}
