/*
 "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
 Copyright (C) 2001-2003 phonohawk

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package aya.node;
import aya.*;
import aya.node.*;
import aya.eval.*;
import java.util.*;

public class VariableReference
{
	String name;
	Expression index; // nullであれば、添字が無い。
	
	public VariableReference(String name)
	{
		this.name = name;
		this.index = null;
	}
	
	public VariableReference setIndex(Expression index)
	{
		this.index = index;
		return this;
	}
	
	public boolean isGlobal() {
		return name.charAt(0) != '_';
	}
	
	public String getName() {
		return name;
	}
	
	public Expression getIndex() {
		return index;
	}
	
	public int evalIndex(Namespace ns) throws Exception {
		// 簡易配列の添字がある。
		Value idx = index.eval(ns);
		if (idx.isInteger()) {
			return (int)idx.getInteger();
		}
		else {
			throw new Exception("Index of pseudo-array must be numeric value : "+idx);
		}
	}
	
	public String toString() {
		if (index == null) {
			return name;
		}
		else {
			return name+'['+index.toString()+']';
		}
	}
}
