/*  $Id: Variable.java,v 1.4 2004/02/11 12:22:14 phonohawk Exp $
    
    "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
    Copyright (C) 2001-2004 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package satori;
import satori.*;
import java.io.*;
import java.util.*;

public class Variable {
    File file;
    Hashtable vars; // key : (String)ϐ , value : (String)e
    
    public Variable(File file) {
	this.file = file;
	vars = new Hashtable();
    }
    
    public void close() {
	synchronize();
    }
    
    public void put(String key,String val) {
	vars.put(key,val);
    }
    
    public String get(String key) {
	return (String)vars.get(key);
    }
    
    public int getAsInteger(String key) {
	try {
	    return Integer.parseInt((String)vars.get(key));
	}
	catch (Exception e) {
	    return 0;
	}
    }
    
    public boolean exists(String key) {
	return (vars.get(key) != null);
    }
    
    public void remove(String key) {
	vars.remove(key);
    }
    
    public void synchronize() {
	try {
	    if (file.exists()) file.delete();
	    OutputStreamWriter osw = new OutputStreamWriter(new FileOutputStream(file),"SJIS");
	    
	    String header = ZenHanTranslator.ZENKAKU_AST + Satori.ZENKAKU_SAVEDATA + "\r\n";
	    osw.write(header,0,header.length());
	    
	    Enumeration keys = vars.keys();
	    while (keys.hasMoreElements()) {
		String key = (String)keys.nextElement();
		String val = (String)vars.get(key);
		
		String line = ZenHanTranslator.ZENKAKU_DOLLAR + key + '\t' + val + "\r\n";
		osw.write(line,0,line.length());
	    }
	    
	    osw.flush();
	    osw.close();
	}
	catch (Exception e) {
	    System.out.println("Variable error : synchronize caused an exception.");
	    e.printStackTrace();
	}
    }
    
    public String updateTimer() {
	// OnSecondChange̔̓xɌĂŉB
	// ׂ^C}[΂̃^C}[iGg̖u^C}v菜́jԂA
	// nullԂ܂B
	
	// Ggu^C}vŏIAl1ȉłϐ
	// 폜ă^C}[B
	String timerToFire = null;
	for (Enumeration keys = vars.keys();keys.hasMoreElements();) {
	    String key = (String)keys.nextElement();
	    if (key.endsWith(Satori.ZENKAKU_TIMER)) { // u^C}vŏIĂ
		// llłȂΖB[Ȃ甭ɍ폜BiSp͎gpj
		// 2ȏȂfNgA1Ȃ甭B
		try {
		    int timer_value = Integer.parseInt((String)vars.get(key));
		    if (timer_value == 0) { // IɃ[܂ꂽ
			vars.remove(key);
		    }
		    else if (timer_value >= 2) { // fNg
			vars.put(key,""+(timer_value - 1));
		    }
		    else if (timerToFire == null) { // BɔĂ܂^C}[ɑ݂΍͌B
			timerToFire = key.substring(0,key.length() - Satori.ZENKAKU_TIMER.length());
			vars.remove(key);
		    }
		}
		catch (NumberFormatException e) {}
	    }
	}
	
	return timerToFire;
    }
}
