/*
  $Id: DGPDecodingStream.java,v 1.2 2003/06/15 06:19:54 phonohawk Exp $
  ----------
  
  "NiseRingo" is a clone of "Niseharuna" works on MacOS X.
  Copyright (C) 2001 phonohawk
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package util;
import java.io.*;
import java.security.MessageDigest;

public class DGPDecodingStream extends FilterInputStream {
    byte[] key; // B
    int cstyle_keylen; // strlen(key)
    int key_pos; // ݁AoCgڂgpĂ̂B

    public DGPDecodingStream(InputStream in,String filename) throws Exception {
	super(in);

	// t@C𔼕ɂB
	byte[] fullname = filename.getBytes("SJIS");
	byte[] halfname = new byte[fullname.length / 2];
	System.arraycopy(fullname,0,halfname,0,fullname.length / 2);

	// ̖Omd5߂B
	MessageDigest md = MessageDigest.getInstance("MD5");
	byte[] salt = stringify(md.digest(halfname));
	assert salt.length == 32 : salt.length;

	// OS铂md5߁Aƃt@CB
	md.reset();
	byte[] fullname_md5 = stringify(md.digest(fullname));
	assert fullname_md5.length == 32 : fullname_md5.length;
	key = new byte[32 + fullname.length];
	System.arraycopy(fullname_md5,0,key,0,fullname_md5.length);
	System.arraycopy(fullname,0,key,32,fullname.length);

	// ̌Asaltpĉ̂B̉ߒŌ̒0x00鎖ਁA
	// ȍ~̃IWi\[Xstrlenɂ͒ӂȂ΂ȂȂB
	for (int i = 0, j = 0; i < key.length;) {
	    key[i++] ^= salt[j++];

	    // salt̏I͂܂ōsA擪ɖ߂B
	    if (j >= salt.length) {
		j = 0;
	    }
	}

	cstyle_keylen = cstyle_strlen(key);
	if (cstyle_keylen == 0) {
	    // ̒łBDGP͕̌słA椂͕s\B
	    // ͎d̃oOłB
	    throw new Exception(fullname+" generates a null key.");
	}
	else if (cstyle_keylen == 1) {
	    // ̒ł鎞́A擪gӁB
	    key_pos = 0;
	}
	else {
	    // łȂ΁AƕڂgӁB
	    key_pos = 1;
	}
    }

    public boolean markSupported() {
	return false;
    }

    public int read() throws IOException {
	int c = super.read();
	if (c == -1) {
	    // EOF
	    return -1;
	}

	c ^= key[key_pos++];
	// ̏I͂܂ōsA擪ɖ߂B
	if (key_pos >= cstyle_keylen) {
	    key_pos = 0;
	}
	return c;
    }

    public int read(byte[] b) throws IOException {
	return read(b,0,b.length);
    }

    public int read(byte[] b,int off,int len) throws IOException {
	int n = super.read(b,off,len);
	if (n == -1) {
	    // EOF
	    return -1;
	}

	for (int i = 0; i < n; i++) {
	    b[i + off] ^= key[key_pos++];
	    if (key_pos >= cstyle_keylen) {
		key_pos = 0;
	    }
	}
	
	return n;
    }

    public static int cstyle_strlen(byte[] bytes) {
	// 0x00܂܂Ă΁ÄʒuԂB
	// Ȃ΁Abytes̒ԂB
	for (int i = 0; i < bytes.length; i++) {
	    if (bytes[i] == 0x00) {
		return i;
	    }
	}
	return bytes.length;
    }

    public static byte[] stringify(byte[] src) {
	// src̊eoCgɂAvX16i2ŕ\AĂёoCgɂB
	// ߒl̃TCÝAsrc2{ƂȂB
	byte[] result = new byte[src.length * 2];
	
	for (int i = 0, j = 0; i < src.length; i++, j += 2) {
	    int num = src[i] < 0 ? src[i] + 256 : src[i];
	    String hex = Integer.toHexString(num);
	    assert hex.length() <= 2;

	    if (hex.length() == 2) {
		result[j  ] = (byte)hex.charAt(0);
		result[j+1] = (byte)hex.charAt(1);
	    }
	    else if (hex.length() == 1) {
		result[j  ] = (byte)'0';
		result[j+1] = (byte)hex.charAt(0);
	    }
	}

	return result;
    }
}